
/*  A Bison parser, made from readnet.y
    by GNU Bison version 1.28  */

#define YYBISON 1  /* Identify Bison output.  */

#define	ident	257
#define	equal	258
#define	comma	259
#define	number	260
#define	key_next	261
#define	key_analyse	262
#define	key_place	263
#define	key_marking	264
#define	key_transition	265
#define	key_consume	266
#define	key_produce	267
#define	colon	268
#define	semicolon	269
#define	tand	270
#define	tor	271
#define	exists	272
#define	forall	273
#define	globally	274
#define	future	275
#define	until	276
#define	tnot	277
#define	tgeq	278
#define	tgt	279
#define	tleq	280
#define	tlt	281
#define	tneq	282
#define	key_formula	283
#define	lpar	284
#define	rpar	285
#define	key_state	286
#define	key_path	287
#define	key_generator	288
#define	key_record	289
#define	key_end	290
#define	key_sort	291
#define	key_function	292
#define	key_do	293
#define	key_array	294
#define	key_enumerate	295
#define	key_constant	296
#define	key_boolean	297
#define	key_of	298
#define	key_begin	299
#define	key_while	300
#define	key_if	301
#define	key_then	302
#define	key_else	303
#define	key_switch	304
#define	key_case	305
#define	key_repeat	306
#define	key_for	307
#define	key_to	308
#define	key_all	309
#define	key_exit	310
#define	key_return	311
#define	key_true	312
#define	key_false	313
#define	key_mod	314
#define	key_var	315
#define	key_guard	316
#define	tiff	317
#define	timplies	318
#define	lbrack	319
#define	rbrack	320
#define	dot	321
#define	plus	322
#define	minus	323
#define	times	324
#define	divide	325
#define	slash	326
#define	key_exists	327

#line 1 "readnet.y"

#include"dimensions.H"
#include"net.H"
#include"symboltab.H"
#include"formula.H"
#include "unfold.H"
#include<stdio.h>
#include<limits.h>

extern UBooType * TheBooType;
extern UNumType * TheNumType;

#define YYDEBUG 1
void yyerror(char *);

class arc_list
{
 public:
	PlSymbol * place;
	UTermList * mt;
	unsigned int nu;
    arc_list    * next;
};   

class case_list
{
	public:
	UStatement * stm;
	UExpression * exp;
	case_list * next;
};

/* list of places and multiplicities to become arcs */

UFunction * CurrentFunction;
Place *P;
Transition *T;
Symbol * S;
PlSymbol * PS;
TrSymbol * TS;
SymbolTab * GlobalTable;
SymbolTab * LocalTable;
UVar * V;
VaSymbol * VS;

#line 46 "readnet.y"
typedef union
{
	char * str;
	int value;
	UType * t;
	URcList * rcl;
	UEnList * el;
	ULVal * lval;
	int * exl;
	UStatement * stm;
	case_list * cl;
	UFunction * fu;
	UExpression * ex;
	arc_list * al;
	formula * form;
	IdList * idl;
	UTermList * tlist;
	Place * pl;
	Transition * tr;
	fmode * fm;
	TrSymbol * ts;
	VaSymbol * varsy;
} YYSTYPE;
#line 142 "readnet.y"

extern YYSTYPE yylval;
#include"lex.yy.c"
 #ifndef YYDEBUG
#define YYDEBUG 1
#endif

#include <stdio.h>

#ifndef __cplusplus
#ifndef __STDC__
#define const
#endif
#endif



#define	YYFINAL		402
#define	YYFLAG		-32768
#define	YYNTBASE	74

#define YYTRANSLATE(x) ((unsigned)(x) <= 327 ? yytranslate[x] : 154)

static const char yytranslate[] = {     0,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     1,     3,     4,     5,     6,
     7,     8,     9,    10,    11,    12,    13,    14,    15,    16,
    17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
    27,    28,    29,    30,    31,    32,    33,    34,    35,    36,
    37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
    47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
    57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
    67,    68,    69,    70,    71,    72,    73
};

#if YYDEBUG != 0
static const short yyprhs[] = {     0,
     0,     3,     8,    14,    20,    26,    28,    30,    35,    38,
    42,    48,    50,    54,    55,    58,    61,    62,    66,    68,
    71,    76,    78,    80,    84,    89,    95,    99,   101,   104,
   106,   108,   111,   116,   120,   121,   124,   125,   128,   133,
   135,   139,   146,   147,   149,   153,   157,   161,   163,   167,
   169,   171,   173,   175,   177,   179,   181,   183,   185,   191,
   197,   207,   214,   220,   228,   231,   233,   238,   245,   246,
   249,   254,   258,   260,   265,   269,   273,   277,   279,   283,
   287,   289,   292,   294,   298,   302,   306,   310,   314,   318,
   320,   324,   328,   330,   334,   338,   342,   344,   347,   349,
   351,   355,   360,   364,   366,   368,   370,   372,   374,   379,
   380,   382,   386,   390,   392,   396,   398,   402,   406,   410,
   411,   420,   424,   426,   428,   432,   434,   436,   437,   439,
   443,   447,   451,   453,   457,   459,   463,   465,   470,   471,
   473,   477,   479,   482,   493,   495,   497,   499,   500,   503,
   504,   506,   510,   514,   518,   520,   524,   528,   532,   536,
   540,   544,   548,   552,   556,   559,   563,   568,   573,   577,
   585,   593,   598,   603,   608,   613,   618,   623,   625,   631,
   635,   636,   638,   643,   648,   652,   656,   659,   663,   665,
   671,   673,   675,   679
};

static const short yyrhs[] = {    80,
   127,     0,    80,   127,    75,   146,     0,    80,   127,     8,
     9,    79,     0,    80,   127,     8,    11,    76,     0,    80,
   127,     8,    10,   125,     0,    29,     0,   131,     0,    77,
    65,    78,    66,     0,   131,    67,     0,   131,     4,   113,
     0,    78,    72,   131,     4,   113,     0,   131,     0,   131,
    67,   113,     0,     0,    80,    81,     0,    37,    83,     0,
     0,    38,    82,    90,     0,    84,     0,    83,    84,     0,
     3,     4,    85,    15,     0,    43,     0,     3,     0,    35,
    88,    36,     0,    40,    85,    44,    85,     0,    65,     6,
     5,     6,    66,     0,    41,    86,    36,     0,    87,     0,
    87,    86,     0,     3,     0,    89,     0,    88,    89,     0,
     3,    14,    85,    15,     0,    95,    91,    98,     0,     0,
    61,    92,     0,     0,    92,    93,     0,    94,    14,    85,
    15,     0,     3,     0,     3,     5,    94,     0,     3,    30,
    96,    31,    14,    85,     0,     0,    97,     0,    96,    15,
    97,     0,    94,    14,    85,     0,    45,    99,    36,     0,
   100,     0,    99,    15,   100,     0,   101,     0,   102,     0,
   103,     0,   104,     0,   105,     0,   108,     0,   111,     0,
   106,     0,   107,     0,    46,   113,    39,    99,    36,     0,
    52,    99,    22,   113,    36,     0,    53,     3,     4,   113,
    54,   113,    39,    99,    36,     0,    53,    55,     3,    39,
    99,    36,     0,    47,   113,    48,    99,    36,     0,    47,
   113,    48,    99,    49,    99,    36,     0,    57,   113,     0,
    56,     0,    50,   113,   109,    36,     0,    50,   113,   109,
    49,    99,    36,     0,     0,   110,   109,     0,    51,   113,
    14,    99,     0,   112,     4,   113,     0,     3,     0,   112,
    65,   113,    66,     0,   112,    67,     3,     0,   113,    63,
   114,     0,   113,    64,   114,     0,   114,     0,   114,    16,
   115,     0,   114,    17,   115,     0,   115,     0,    23,   115,
     0,   116,     0,   116,     4,   117,     0,   116,    25,   117,
     0,   116,    27,   117,     0,   116,    24,   117,     0,   116,
    26,   117,     0,   116,    28,   117,     0,   117,     0,   117,
    68,   118,     0,   117,    69,   118,     0,   118,     0,   118,
    70,   119,     0,   118,    71,   119,     0,   118,    60,   119,
     0,   119,     0,    69,   120,     0,   120,     0,     3,     0,
   112,    67,     3,     0,   112,    65,   113,    66,     0,    30,
   113,    31,     0,    58,     0,    59,     0,   121,     0,   123,
     0,     6,     0,     3,    30,   122,    31,     0,     0,   113,
     0,   113,     5,   122,     0,    65,   124,    66,     0,   113,
     0,   113,    72,   124,     0,   126,     0,   125,     5,   126,
     0,   131,    14,     6,     0,   131,    14,   134,     0,     0,
     9,   129,    15,    10,   128,   132,    15,   138,     0,   129,
     5,   130,     0,   130,     0,   131,     0,   131,    14,    85,
     0,     3,     0,     6,     0,     0,   133,     0,   132,     5,
   133,     0,   131,    14,     6,     0,   131,    14,   134,     0,
   135,     0,   134,    68,   135,     0,   136,     0,   136,    14,
     6,     0,     3,     0,     3,    30,   137,    31,     0,     0,
   136,     0,   136,     5,   137,     0,   139,     0,   138,   139,
     0,    11,   141,   140,   142,    12,   143,    15,    13,   143,
    15,     0,    91,     0,     3,     0,     6,     0,     0,    62,
   113,     0,     0,   144,     0,   144,     5,   143,     0,   131,
    14,     6,     0,   131,    14,   134,     0,     6,     0,    30,
   113,    31,     0,   147,     4,   145,     0,   147,    28,   145,
     0,   147,    26,   145,     0,   147,    24,   145,     0,   147,
    27,   145,     0,   147,    25,   145,     0,   146,    16,   146,
     0,   146,    17,   146,     0,    23,   146,     0,    65,   113,
    66,     0,    73,   148,    14,   146,     0,    55,   148,    14,
   146,     0,    30,   146,    31,     0,    18,   149,    65,   146,
    22,   146,    66,     0,    19,   149,    65,   146,    22,   146,
    66,     0,    18,   149,    20,   146,     0,    19,   149,    20,
   146,     0,    18,   149,     7,   146,     0,    19,   149,     7,
   146,     0,    18,   149,    21,   146,     0,    19,   149,    21,
   146,     0,   131,     0,   131,    67,    30,   113,    31,     0,
   131,    14,    85,     0,     0,   150,     0,    73,   148,    14,
   150,     0,    55,   148,    14,   150,     0,   150,    16,   150,
     0,   150,    17,   150,     0,    23,   150,     0,    30,   150,
    31,     0,   151,     0,   151,    67,    65,   152,    66,     0,
   131,     0,   153,     0,   152,    72,   153,     0,   131,     4,
   113,     0
};

#endif

#if YYDEBUG != 0
static const short yyrline[] = { 0,
   148,   153,   158,   172,   180,   182,   184,   194,   252,   262,
   274,   296,   302,   327,   328,   330,   331,   332,   333,   333,
   336,   348,   349,   357,   361,   369,   379,   383,   384,   389,
   401,   402,   408,   422,   428,   428,   429,   429,   430,   445,
   450,   457,   487,   487,   487,   488,   504,   506,   507,   515,
   516,   517,   518,   519,   520,   521,   522,   523,   525,   535,
   545,   564,   573,   583,   594,   604,   609,   631,   654,   655,
   657,   663,   673,   681,   696,   717,   729,   741,   743,   755,
   767,   769,   780,   782,   790,   798,   806,   814,   822,   830,
   832,   844,   856,   858,   870,   882,   894,   896,   907,   909,
   943,   969,   990,   991,   995,   999,  1000,  1001,  1005,  1030,
  1031,  1036,  1042,  1071,  1076,  1082,  1083,  1085,  1104,  1146,
  1146,  1287,  1288,  1290,  1299,  1332,  1333,  1335,  1336,  1337,
  1339,  1358,  1400,  1401,  1403,  1404,  1407,  1428,  1459,  1460,
  1461,  1467,  1468,  1470,  1703,  1704,  1705,  1707,  1708,  1710,
  1711,  1712,  1717,  1735,  1760,  1765,  1773,  1780,  1787,  1794,
  1801,  1808,  1815,  1820,  1825,  1830,  1839,  1845,  1851,  1856,
  1861,  1866,  1871,  1876,  1881,  1886,  1891,  1897,  1905,  1918,
  1925,  1926,  1928,  1934,  1940,  1945,  1950,  1955,  1956,  1965,
  1975,  1981,  1982,  1987
};
#endif


#if YYDEBUG != 0 || defined (YYERROR_VERBOSE)

static const char * const yytname[] = {   "$","error","$undefined.","ident",
"equal","comma","number","key_next","key_analyse","key_place","key_marking",
"key_transition","key_consume","key_produce","colon","semicolon","tand","tor",
"exists","forall","globally","future","until","tnot","tgeq","tgt","tleq","tlt",
"tneq","key_formula","lpar","rpar","key_state","key_path","key_generator","key_record",
"key_end","key_sort","key_function","key_do","key_array","key_enumerate","key_constant",
"key_boolean","key_of","key_begin","key_while","key_if","key_then","key_else",
"key_switch","key_case","key_repeat","key_for","key_to","key_all","key_exit",
"key_return","key_true","key_false","key_mod","key_var","key_guard","tiff","timplies",
"lbrack","rbrack","dot","plus","minus","times","divide","slash","key_exists",
"input","formulaheader","atransition","hlprefix","firingmode","aplace","declarations",
"declaration","@1","sortdeclarations","sortdeclaration","sortdescription","enums",
"enu","recordcomponents","recordcomponent","functiondeclaration","vardeclarations",
"vdeclarations","vdeclaration","identlist","head","fparlists","fparlist","body",
"statement_seq","statement","while_statement","repeat_statement","for_statement",
"forall_statement","if_statement","return_statement","exit_statement","case_statement",
"caselist","case","assignment","lvalue","expression","express","expre","expr",
"exp","term","factor","fac","functioncall","expressionlist","arrayvalue","valuelist",
"amarkinglist","amarking","net","@2","placelist","place","nodeident","markinglist",
"marking","multiterm","mtcomponent","hlterm","termlist","transitionlist","transition",
"transitionvariables","tname","guard","arclist","arc","numex","ctlformula","cplace",
"quantification","transformula","transitionformula","formulatransition","parfiringmode",
"fmodeblock", NULL
};
#endif

static const short yyr1[] = {     0,
    74,    74,    74,    74,    74,    75,    76,    76,    77,    78,
    78,    79,    79,    80,    80,    81,    82,    81,    83,    83,
    84,    85,    85,    85,    85,    85,    85,    86,    86,    87,
    88,    88,    89,    90,    91,    91,    92,    92,    93,    94,
    94,    95,    96,    96,    96,    97,    98,    99,    99,   100,
   100,   100,   100,   100,   100,   100,   100,   100,   101,   102,
   103,   104,   105,   105,   106,   107,   108,   108,   109,   109,
   110,   111,   112,   112,   112,   113,   113,   113,   114,   114,
   114,   115,   115,   116,   116,   116,   116,   116,   116,   116,
   117,   117,   117,   118,   118,   118,   118,   119,   119,   120,
   120,   120,   120,   120,   120,   120,   120,   120,   121,   122,
   122,   122,   123,   124,   124,   125,   125,   126,   126,   128,
   127,   129,   129,   130,   130,   131,   131,   132,   132,   132,
   133,   133,   134,   134,   135,   135,   136,   136,   137,   137,
   137,   138,   138,   139,   140,   141,   141,   142,   142,   143,
   143,   143,   144,   144,   145,   145,   146,   146,   146,   146,
   146,   146,   146,   146,   146,   146,   146,   146,   146,   146,
   146,   146,   146,   146,   146,   146,   146,   147,   147,   148,
   149,   149,   150,   150,   150,   150,   150,   150,   150,   150,
   151,   152,   152,   153
};

static const short yyr2[] = {     0,
     2,     4,     5,     5,     5,     1,     1,     4,     2,     3,
     5,     1,     3,     0,     2,     2,     0,     3,     1,     2,
     4,     1,     1,     3,     4,     5,     3,     1,     2,     1,
     1,     2,     4,     3,     0,     2,     0,     2,     4,     1,
     3,     6,     0,     1,     3,     3,     3,     1,     3,     1,
     1,     1,     1,     1,     1,     1,     1,     1,     5,     5,
     9,     6,     5,     7,     2,     1,     4,     6,     0,     2,
     4,     3,     1,     4,     3,     3,     3,     1,     3,     3,
     1,     2,     1,     3,     3,     3,     3,     3,     3,     1,
     3,     3,     1,     3,     3,     3,     1,     2,     1,     1,
     3,     4,     3,     1,     1,     1,     1,     1,     4,     0,
     1,     3,     3,     1,     3,     1,     3,     3,     3,     0,
     8,     3,     1,     1,     3,     1,     1,     0,     1,     3,
     3,     3,     1,     3,     1,     3,     1,     4,     0,     1,
     3,     1,     2,    10,     1,     1,     1,     0,     2,     0,
     1,     3,     3,     3,     1,     3,     3,     3,     3,     3,
     3,     3,     3,     3,     2,     3,     4,     4,     3,     7,
     7,     4,     4,     4,     4,     4,     4,     1,     5,     3,
     0,     1,     4,     4,     3,     3,     2,     3,     1,     5,
     1,     1,     3,     3
};

static const short yydefact[] = {    14,
     0,     0,     0,    17,    15,     1,   126,   127,     0,   123,
   124,     0,    16,    19,     0,     0,     6,     0,     0,     0,
     0,     0,    20,     0,    18,    35,     0,     0,     0,   181,
   181,     0,     0,     0,     0,     0,   178,     2,     0,   122,
   120,    23,     0,     0,     0,    22,     0,   125,     0,    43,
    37,     0,     3,    12,     5,   116,     0,     4,     0,     7,
     0,     0,     0,     0,   191,     0,   182,   189,     0,   165,
     0,     0,     0,   100,   108,     0,     0,   104,   105,     0,
     0,     0,     0,    78,    81,    83,    90,    93,    97,    99,
   106,   107,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,   128,     0,     0,    31,     0,    30,     0,    28,
     0,    21,    40,     0,     0,    44,    36,     0,    34,     0,
     0,     0,     0,     9,   187,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,   169,
     0,     0,   110,    82,     0,   114,     0,    98,     0,     0,
     0,     0,   166,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,   163,   164,
   155,     0,   157,   160,   162,   159,   161,   158,     0,     0,
   129,     0,    24,    32,     0,    27,    29,     0,     0,     0,
     0,     0,    38,     0,    73,     0,     0,     0,     0,     0,
    66,     0,     0,    48,    50,    51,    52,    53,    54,    57,
    58,    55,    56,     0,    13,   117,   137,   118,   119,   133,
   135,     0,     0,   188,     0,     0,   174,   172,   176,     0,
   185,   186,     0,   175,   173,   177,     0,   180,   168,   111,
     0,   103,     0,   113,     0,   101,    76,    77,    79,    80,
    84,    87,    85,    88,    86,    89,    91,    92,    96,    94,
    95,   167,     0,     0,     0,     0,     0,     0,    25,     0,
    41,    46,    45,     0,     0,     0,     0,    69,     0,     0,
     0,    65,     0,    47,     0,     0,     0,   139,     0,     0,
     8,     0,     0,   184,   183,     0,     0,     0,   192,     0,
   110,   109,   115,   102,   179,   156,   131,   132,   130,     0,
   121,   142,    33,    26,    42,     0,     0,     0,     0,     0,
    69,     0,     0,     0,    49,    72,     0,    75,   140,     0,
   134,   136,     0,    10,     0,     0,   190,     0,     0,   112,
   146,   147,    35,   143,    39,     0,     0,     0,    67,     0,
    70,     0,     0,     0,    74,   139,   138,     0,   170,   194,
   193,   171,   145,   148,    59,    63,     0,     0,     0,    60,
     0,     0,   141,    11,     0,     0,     0,    71,    68,     0,
    62,   149,   150,    64,     0,     0,     0,   151,     0,     0,
     0,   150,    61,   153,   154,   150,   152,     0,   144,     0,
     0,     0
};

static const short yydefgoto[] = {   400,
    18,    58,    59,   222,    53,     1,     5,    15,    13,    14,
    48,   109,   110,   105,   106,    25,    52,   117,   193,   114,
    26,   115,   116,   119,   203,   204,   205,   206,   207,   208,
   209,   210,   211,   212,   320,   321,   213,    82,   146,    84,
    85,    86,    87,    88,    89,    90,    91,   241,    92,   147,
    55,    56,     6,   103,     9,    10,    37,   180,   181,   219,
   220,   221,   330,   311,   312,   364,   343,   376,   387,   388,
   173,    38,    39,    73,    66,    67,    68,   298,   299
};

static const short yypact[] = {-32768,
   113,    51,    46,-32768,-32768,    43,-32768,-32768,    87,-32768,
    81,    27,    46,-32768,   127,   318,-32768,    18,    51,   115,
    15,    15,-32768,   112,-32768,    91,    51,    51,    51,    16,
    16,    18,    18,    51,   123,    51,   120,   322,   201,-32768,
-32768,-32768,   204,    15,   213,-32768,   183,-32768,   245,   274,
-32768,   276,-32768,   258,   329,-32768,   336,-32768,   290,   273,
    16,    16,    51,    51,-32768,   107,   326,   289,   137,   322,
   230,   343,   344,     0,-32768,   123,   123,-32768,-32768,   123,
    90,   165,   232,   328,-32768,   217,   278,   195,-32768,-32768,
-32768,-32768,   345,   330,    18,    18,    17,    17,    17,    17,
    17,    17,    51,   347,    30,-32768,   319,-32768,   331,   213,
   357,-32768,   359,   351,   175,-32768,   274,   162,-32768,   123,
    51,    94,    51,-32768,   326,   241,   352,   354,    18,    18,
    18,    18,    16,    16,   304,    18,    18,    18,    18,-32768,
    15,    18,   123,-32768,   -11,   215,   305,-32768,   123,   367,
   123,   123,-32768,   123,   123,    78,    78,    78,    78,    78,
    78,    78,    78,    78,    78,    78,    18,   123,-32768,-32768,
-32768,   123,-32768,-32768,-32768,-32768,-32768,-32768,   358,   271,
-32768,    15,-32768,-32768,    15,-32768,-32768,   368,   274,    15,
   274,   361,-32768,   362,-32768,   123,   123,   123,   162,     9,
-32768,   123,   139,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,    11,   285,-32768,   348,-32768,   309,-32768,
   365,   128,   369,-32768,    16,    16,   322,   322,   322,   275,
-32768,-32768,    51,   322,   322,   322,   277,-32768,-32768,    35,
   349,-32768,   123,-32768,   237,   172,   328,   328,-32768,-32768,
   278,   278,   278,   278,   278,   278,   195,   195,-32768,-32768,
-32768,-32768,    76,   114,   314,    51,   371,   370,-32768,   317,
-32768,-32768,-32768,    15,    15,   122,   185,   199,    20,   380,
   383,   285,   162,-32768,   123,   123,   384,   385,   385,   386,
-32768,    51,   123,-32768,-32768,    18,   387,   209,-32768,    18,
   123,-32768,-32768,   268,-32768,-32768,-32768,   309,-32768,   316,
   371,-32768,-32768,-32768,-32768,   374,   162,   162,   123,    41,
   342,   123,   123,   356,-32768,   285,   252,-32768,   391,   366,
-32768,-32768,   394,   285,    -3,   123,-32768,    51,    28,-32768,
-32768,-32768,    91,-32768,-32768,   184,   144,    54,-32768,   162,
-32768,   134,   219,   162,-32768,   385,-32768,   123,-32768,   285,
-32768,-32768,-32768,   337,-32768,-32768,   162,   162,   186,-32768,
   123,   198,-32768,   285,   123,   388,   202,   389,-32768,   132,
-32768,   285,    51,-32768,   162,   392,   390,   396,   220,   320,
   395,    51,-32768,-32768,   309,    51,-32768,   397,-32768,   402,
   403,-32768
};

static const short yypgoto[] = {-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,   398,
    -6,   297,-32768,-32768,   308,-32768,    66,-32768,-32768,  -107,
-32768,-32768,   223,-32768,  -194,   133,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,    89,-32768,-32768,  -114,   -34,   200,
   -67,-32768,   148,   191,   166,   334,-32768,   116,-32768,   176,
-32768,   299,-32768,-32768,-32768,   399,    -2,-32768,   155,  -257,
   135,  -277,    67,-32768,   111,-32768,-32768,-32768,  -112,-32768,
   212,   -26,-32768,   147,   400,   -59,-32768,-32768,    88
};


#define	YYLAST		431


static const short yytable[] = {    11,
    83,   125,   126,   214,   279,    70,    71,   308,   144,   194,
   329,   280,    95,    96,   285,    49,    11,    42,     7,   242,
     7,     8,   171,     8,    54,    57,    60,    65,    65,   143,
    22,    72,   104,    72,   283,    30,    31,   107,    61,   301,
    32,   322,   145,    95,    96,    62,   172,    33,    12,    43,
    16,   151,   152,     7,    44,    45,     8,    46,    65,    65,
    72,    72,   359,   281,   -73,   183,   -73,   368,   169,   170,
    63,    17,    34,   231,   232,   286,   349,   287,   329,    47,
    74,   271,    35,    75,   214,   215,   249,   250,    64,   350,
    36,    19,    74,   362,    21,    75,   217,   151,   152,   218,
   179,    20,   227,   228,   229,   230,   305,    77,   240,   234,
   235,   236,   237,   129,   245,   239,   151,   152,    57,    77,
   223,     2,   346,   347,    41,    74,   130,   131,    75,    24,
    65,    65,   395,   263,   238,    78,    79,   264,   151,   152,
   262,    50,    80,   136,   306,    76,    81,    78,    79,     3,
     4,    51,    77,   283,    80,   369,   137,   138,   283,   372,
   317,   276,   277,   278,   195,   294,   295,   282,   214,   370,
   385,   132,   377,   378,   284,   268,   151,   152,   269,   366,
    78,    79,    93,   272,   151,   152,    94,    80,   111,   191,
   389,    81,   367,   291,   151,   152,   151,   152,   283,   292,
   283,   139,   214,   214,    97,   192,   104,   196,   197,   127,
   128,   198,   283,   199,   200,   108,   283,   201,   202,   365,
   156,   379,    65,    65,    98,    99,   100,   101,   102,   149,
   297,   150,   318,   381,   283,   214,   -75,   384,   -75,   214,
   157,   158,   159,   160,   161,    95,    96,   151,   152,   319,
   326,   327,   214,   214,   164,   393,   133,   134,   334,   112,
   140,   151,   152,   179,   165,   166,   240,   315,   316,   335,
   214,   224,   371,   339,   337,   266,   113,   151,   152,   397,
   338,   151,   152,   398,   348,   267,   243,   352,   353,   333,
    95,    96,    95,    96,   151,   152,   296,   153,   300,   151,
   152,   360,   304,   251,   252,   253,   254,   255,   256,   174,
   175,   176,   177,   178,   151,   152,   217,   355,   341,   307,
   118,   342,   217,   374,   120,   394,    27,    28,    29,   259,
   260,   261,   -74,   121,   -74,   297,   380,    95,    96,   124,
   382,   133,   134,   154,   155,   162,   163,   151,   152,   122,
   247,   248,   257,   258,   123,   135,   141,   142,   167,   168,
   182,   188,   185,   189,   190,   225,   186,   226,   233,   246,
   244,   265,   293,   270,   274,   275,   289,   288,   290,   302,
   386,   310,   314,   323,   313,   324,   328,   217,   345,   386,
   336,   332,   319,   386,   354,   356,   357,   358,   375,   383,
   392,   401,   402,   283,   391,   390,   187,   396,   363,   351,
    23,   399,   184,   273,   148,   325,   340,    40,   303,   216,
   309,   344,   373,   331,     0,   361,     0,     0,     0,     0,
    69
};

static const short yycheck[] = {     2,
    35,    61,    62,   118,   199,    32,    33,   265,    76,   117,
   288,     3,    16,    17,     4,    22,    19,     3,     3,    31,
     3,     6,     6,     6,    27,    28,    29,    30,    31,    30,
     4,    34,     3,    36,    15,    18,    19,    44,    23,     5,
    23,    22,    77,    16,    17,    30,    30,    30,     3,    35,
     8,    63,    64,     3,    40,    41,     6,    43,    61,    62,
    63,    64,    66,    55,    65,    36,    67,    14,    95,    96,
    55,    29,    55,   133,   134,    65,    36,    67,   356,    65,
     3,   189,    65,     6,   199,   120,   154,   155,    73,    49,
    73,     5,     3,    66,    14,     6,     3,    63,    64,     6,
   103,    15,   129,   130,   131,   132,    31,    30,   143,   136,
   137,   138,   139,     7,   149,   142,    63,    64,   121,    30,
   123,     9,   317,   318,    10,     3,    20,    21,     6,     3,
   133,   134,   390,   168,   141,    58,    59,   172,    63,    64,
   167,    30,    65,     7,    31,    23,    69,    58,    59,    37,
    38,    61,    30,    15,    65,   350,    20,    21,    15,   354,
    39,   196,   197,   198,     3,   225,   226,   202,   283,    36,
    39,    65,   367,   368,    36,   182,    63,    64,   185,    36,
    58,    59,    36,   190,    63,    64,    67,    65,     6,    15,
   385,    69,    49,    66,    63,    64,    63,    64,    15,    72,
    15,    65,   317,   318,     4,    31,     3,    46,    47,    63,
    64,    50,    15,    52,    53,     3,    15,    56,    57,    36,
     4,    36,   225,   226,    24,    25,    26,    27,    28,    65,
   233,    67,    48,    36,    15,   350,    65,    36,    67,   354,
    24,    25,    26,    27,    28,    16,    17,    63,    64,    51,
   285,   286,   367,   368,    60,    36,    16,    17,   293,    15,
    31,    63,    64,   266,    70,    71,   301,   274,   275,   296,
   385,    31,    54,   300,    66,     5,     3,    63,    64,   392,
    72,    63,    64,   396,   319,    15,    72,   322,   323,   292,
    16,    17,    16,    17,    63,    64,    22,    66,    22,    63,
    64,   336,    66,   156,   157,   158,   159,   160,   161,    98,
    99,   100,   101,   102,    63,    64,     3,    66,     3,     6,
    45,     6,     3,   358,    67,     6,     9,    10,    11,   164,
   165,   166,    65,     5,    67,   338,   371,    16,    17,    67,
   375,    16,    17,    16,    17,    68,    69,    63,    64,    14,
   151,   152,   162,   163,    65,    67,    14,    14,    14,    30,
    14,     5,    44,     5,    14,    14,    36,    14,    65,     3,
    66,    14,     4,     6,    14,    14,    68,    30,    14,    31,
   383,    11,    66,     4,    15,     3,     3,     3,    15,   392,
     4,     6,    51,   396,    39,     5,    31,     4,    62,    12,
     5,     0,     0,    15,    15,    14,   110,    13,   343,   321,
    13,    15,   105,   191,    81,   283,   301,    19,   243,   121,
   266,   311,   356,   289,    -1,   338,    -1,    -1,    -1,    -1,
    31
};
/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */
#line 3 "//usr/lib/bison.simple"
/* This file comes from bison-1.28.  */

/* Skeleton output parser for bison,
   Copyright (C) 1984, 1989, 1990 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* This is the parser code that is written into each bison parser
  when the %semantic_parser declaration is not specified in the grammar.
  It was written by Richard Stallman by simplifying the hairy parser
  used when %semantic_parser is specified.  */

#ifndef YYSTACK_USE_ALLOCA
#ifdef alloca
#define YYSTACK_USE_ALLOCA
#else /* alloca not defined */
#ifdef __GNUC__
#define YYSTACK_USE_ALLOCA
#define alloca __builtin_alloca
#else /* not GNU C.  */
#if (!defined (__STDC__) && defined (sparc)) || defined (__sparc__) || defined (__sparc) || defined (__sgi) || (defined (__sun) && defined (__i386))
#define YYSTACK_USE_ALLOCA
#include <alloca.h>
#else /* not sparc */
/* We think this test detects Watcom and Microsoft C.  */
/* This used to test MSDOS, but that is a bad idea
   since that symbol is in the user namespace.  */
#if (defined (_MSDOS) || defined (_MSDOS_)) && !defined (__TURBOC__)
#if 0 /* No need for malloc.h, which pollutes the namespace;
	 instead, just don't use alloca.  */
#include <malloc.h>
#endif
#else /* not MSDOS, or __TURBOC__ */
#if defined(_AIX)
/* I don't know what this was needed for, but it pollutes the namespace.
   So I turned it off.   rms, 2 May 1997.  */
/* #include <malloc.h>  */
 #pragma alloca
#define YYSTACK_USE_ALLOCA
#else /* not MSDOS, or __TURBOC__, or _AIX */
#if 0
#ifdef __hpux /* haible@ilog.fr says this works for HPUX 9.05 and up,
		 and on HPUX 10.  Eventually we can turn this on.  */
#define YYSTACK_USE_ALLOCA
#define alloca __builtin_alloca
#endif /* __hpux */
#endif
#endif /* not _AIX */
#endif /* not MSDOS, or __TURBOC__ */
#endif /* not sparc */
#endif /* not GNU C */
#endif /* alloca not defined */
#endif /* YYSTACK_USE_ALLOCA not defined */

#ifdef YYSTACK_USE_ALLOCA
#define YYSTACK_ALLOC alloca
#else
#define YYSTACK_ALLOC malloc
#endif

/* Note: there must be only one dollar sign in this file.
   It is replaced by the list of actions, each action
   as one case of the switch.  */

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	goto yyacceptlab
#define YYABORT 	goto yyabortlab
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.
   This remains here temporarily to ease the
   transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(token, value) \
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    { yychar = (token), yylval = (value);			\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { yyerror ("syntax error: cannot back up"); YYERROR; }	\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

#ifndef YYPURE
#define YYLEX		yylex()
#endif

#ifdef YYPURE
#ifdef YYLSP_NEEDED
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, &yylloc, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval, &yylloc)
#endif
#else /* not YYLSP_NEEDED */
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval)
#endif
#endif /* not YYLSP_NEEDED */
#endif

/* If nonreentrant, generate the variables here */

#ifndef YYPURE

int	yychar;			/*  the lookahead symbol		*/
YYSTYPE	yylval;			/*  the semantic value of the		*/
				/*  lookahead symbol			*/

#ifdef YYLSP_NEEDED
YYLTYPE yylloc;			/*  location data for the lookahead	*/
				/*  symbol				*/
#endif

int yynerrs;			/*  number of parse errors so far       */
#endif  /* not YYPURE */

#if YYDEBUG != 0
int yydebug;			/*  nonzero means print parse trace	*/
/* Since this is uninitialized, it does not stop multiple parsers
   from coexisting.  */
#endif

/*  YYINITDEPTH indicates the initial size of the parser's stacks	*/

#ifndef	YYINITDEPTH
#define YYINITDEPTH 200
#endif

/*  YYMAXDEPTH is the maximum size the stacks can grow to
    (effective only if the built-in stack extension method is used).  */

#if YYMAXDEPTH == 0
#undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
#define YYMAXDEPTH 10000
#endif

/* Define __yy_memcpy.  Note that the size argument
   should be passed with type unsigned int, because that is what the non-GCC
   definitions require.  With GCC, __builtin_memcpy takes an arg
   of type size_t, but it can handle unsigned int.  */

#if __GNUC__ > 1		/* GNU C and GNU C++ define this.  */
#define __yy_memcpy(TO,FROM,COUNT)	__builtin_memcpy(TO,FROM,COUNT)
#else				/* not GNU C or C++ */
#ifndef __cplusplus

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (to, from, count)
     char *to;
     char *from;
     unsigned int count;
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#else /* __cplusplus */

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (char *to, char *from, unsigned int count)
{
  register char *t = to;
  register char *f = from;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#endif
#endif

#line 217 "//usr/lib/bison.simple"

/* The user can define YYPARSE_PARAM as the name of an argument to be passed
   into yyparse.  The argument should have type void *.
   It should actually point to an object.
   Grammar actions can access the variable by casting it
   to the proper pointer type.  */

#ifdef YYPARSE_PARAM
#ifdef __cplusplus
#define YYPARSE_PARAM_ARG void *YYPARSE_PARAM
#define YYPARSE_PARAM_DECL
#else /* not __cplusplus */
#define YYPARSE_PARAM_ARG YYPARSE_PARAM
#define YYPARSE_PARAM_DECL void *YYPARSE_PARAM;
#endif /* not __cplusplus */
#else /* not YYPARSE_PARAM */
#define YYPARSE_PARAM_ARG
#define YYPARSE_PARAM_DECL
#endif /* not YYPARSE_PARAM */

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
#ifdef YYPARSE_PARAM
int yyparse (void *);
#else
int yyparse (void);
#endif
#endif

int
yyparse(YYPARSE_PARAM_ARG)
     YYPARSE_PARAM_DECL
{
  register int yystate;
  register int yyn;
  register short *yyssp;
  register YYSTYPE *yyvsp;
  int yyerrstatus;	/*  number of tokens to shift before error messages enabled */
  int yychar1 = 0;		/*  lookahead token as an internal (translated) token number */

  short	yyssa[YYINITDEPTH];	/*  the state stack			*/
  YYSTYPE yyvsa[YYINITDEPTH];	/*  the semantic value stack		*/

  short *yyss = yyssa;		/*  refer to the stacks thru separate pointers */
  YYSTYPE *yyvs = yyvsa;	/*  to allow yyoverflow to reallocate them elsewhere */

#ifdef YYLSP_NEEDED
  YYLTYPE yylsa[YYINITDEPTH];	/*  the location stack			*/
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;

#define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else
#define YYPOPSTACK   (yyvsp--, yyssp--)
#endif

  int yystacksize = YYINITDEPTH;
  int yyfree_stacks = 0;

#ifdef YYPURE
  int yychar;
  YYSTYPE yylval;
  int yynerrs;
#ifdef YYLSP_NEEDED
  YYLTYPE yylloc;
#endif
#endif

  YYSTYPE yyval;		/*  the variable used to return		*/
				/*  semantic values from the action	*/
				/*  routines				*/

  int yylen;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Starting parse\n");
#endif

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss - 1;
  yyvsp = yyvs;
#ifdef YYLSP_NEEDED
  yylsp = yyls;
#endif

/* Push a new state, which is found in  yystate  .  */
/* In all cases, when you get here, the value and location stacks
   have just been pushed. so pushing a state here evens the stacks.  */
yynewstate:

  *++yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Give user a chance to reallocate the stack */
      /* Use copies of these so that the &'s don't force the real ones into memory. */
      YYSTYPE *yyvs1 = yyvs;
      short *yyss1 = yyss;
#ifdef YYLSP_NEEDED
      YYLTYPE *yyls1 = yyls;
#endif

      /* Get the current used size of the three stacks, in elements.  */
      int size = yyssp - yyss + 1;

#ifdef yyoverflow
      /* Each stack pointer address is followed by the size of
	 the data in use in that stack, in bytes.  */
#ifdef YYLSP_NEEDED
      /* This used to be a conditional around just the two extra args,
	 but that might be undefined if yyoverflow is a macro.  */
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yyls1, size * sizeof (*yylsp),
		 &yystacksize);
#else
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yystacksize);
#endif

      yyss = yyss1; yyvs = yyvs1;
#ifdef YYLSP_NEEDED
      yyls = yyls1;
#endif
#else /* no yyoverflow */
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	{
	  yyerror("parser stack overflow");
	  if (yyfree_stacks)
	    {
	      free (yyss);
	      free (yyvs);
#ifdef YYLSP_NEEDED
	      free (yyls);
#endif
	    }
	  return 2;
	}
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;
#ifndef YYSTACK_USE_ALLOCA
      yyfree_stacks = 1;
#endif
      yyss = (short *) YYSTACK_ALLOC (yystacksize * sizeof (*yyssp));
      __yy_memcpy ((char *)yyss, (char *)yyss1,
		   size * (unsigned int) sizeof (*yyssp));
      yyvs = (YYSTYPE *) YYSTACK_ALLOC (yystacksize * sizeof (*yyvsp));
      __yy_memcpy ((char *)yyvs, (char *)yyvs1,
		   size * (unsigned int) sizeof (*yyvsp));
#ifdef YYLSP_NEEDED
      yyls = (YYLTYPE *) YYSTACK_ALLOC (yystacksize * sizeof (*yylsp));
      __yy_memcpy ((char *)yyls, (char *)yyls1,
		   size * (unsigned int) sizeof (*yylsp));
#endif
#endif /* no yyoverflow */

      yyssp = yyss + size - 1;
      yyvsp = yyvs + size - 1;
#ifdef YYLSP_NEEDED
      yylsp = yyls + size - 1;
#endif

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Stack size increased to %d\n", yystacksize);
#endif

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Entering state %d\n", yystate);
#endif

  goto yybackup;
 yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Reading a token: ");
#endif
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Now at end of input.\n");
#endif
    }
  else
    {
      yychar1 = YYTRANSLATE(yychar);

#if YYDEBUG != 0
      if (yydebug)
	{
	  fprintf (stderr, "Next token is %d (%s", yychar, yytname[yychar1]);
	  /* Give the individual parser a way to print the precise meaning
	     of a token, for further debugging info.  */
#ifdef YYPRINT
	  YYPRINT (stderr, yychar, yylval);
#endif
	  fprintf (stderr, ")\n");
	}
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting token %d (%s), ", yychar, yytname[yychar1]);
#endif

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* count tokens shifted since error; after three, turn off error status.  */
  if (yyerrstatus) yyerrstatus--;

  yystate = yyn;
  goto yynewstate;

/* Do the default action for the current state.  */
yydefault:

  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;

/* Do a reduction.  yyn is the number of a rule to reduce with.  */
yyreduce:
  yylen = yyr2[yyn];
  if (yylen > 0)
    yyval = yyvsp[1-yylen]; /* implement default value of the action */

#if YYDEBUG != 0
  if (yydebug)
    {
      int i;

      fprintf (stderr, "Reducing via rule %d (line %d), ",
	       yyn, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (i = yyprhs[yyn]; yyrhs[i] > 0; i++)
	fprintf (stderr, "%s ", yytname[yyrhs[i]]);
      fprintf (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif


  switch (yyn) {

case 1:
#line 148 "readnet.y"
{ 
#ifdef WITHFORMULA
F = (formula *) 0 ; 
#endif
;
    break;}
case 2:
#line 153 "readnet.y"
{ 
#ifdef WITHFORMULA
F = yyvsp[0].form;
#endif
;
    break;}
case 3:
#line 158 "readnet.y"
{
	CheckPlace = yyvsp[0].pl;
#ifdef STUBBORN
	Transitions[0]->StartOfStubbornList = (Transition *) 0;
int i;
	for(i=0;CheckPlace -> PreTransitions[i];i++)
	{
		CheckPlace->PreTransitions[i]->instubborn = true;
		CheckPlace->PreTransitions[i]->NextStubborn = Transitions[0]->StartOfStubbornList;
		Transitions[0]->StartOfStubbornList = CheckPlace->PreTransitions[i];
	}
	Transitions[0]->EndOfStubbornList = LastAttractor = CheckPlace -> PreTransitions[0];
#endif
                ;
    break;}
case 4:
#line 172 "readnet.y"
{
	CheckTransition = yyvsp[0].tr;
#ifdef STUBBORN
	Transitions[0]->EndOfStubbornList = LastAttractor = Transitions[0]->StartOfStubbornList = CheckTransition;
	CheckTransition -> NextStubborn = (Transition *) 0;
	CheckTransition -> instubborn = true;
#endif
	;
    break;}
case 6:
#line 182 "readnet.y"
{LocalTable = new SymbolTab(256);;
    break;}
case 7:
#line 184 "readnet.y"
{
				TS = (TrSymbol *) TransitionTable -> lookup(yyvsp[0].str);
				if(!TS) yyerror("transition does not exist");
				if(TS -> vars && TS -> vars -> card)
				{
					yyerror("HL transition requires firing mode");
				}
				yyval.tr = TS -> transition;
			;
    break;}
case 8:
#line 194 "readnet.y"
{
		   unsigned int i, j,card;
		   fmode * fm;
		   VaSymbol * v;
		   UValue * vl;
		   char ** cc;
		   char ** inst;
		   unsigned int len;
		   for(card=0,fm=yyvsp[-1].fm;fm;fm = fm -> next,card++);
		   if(card != yyvsp[-3].ts -> vars -> card)
		   {
			yyerror("firing mode incomplete");
		   }
		   cc = new char * [ card];
		   inst= new char * [ card];
		   len = strlen(yyvsp[-3].ts->name) + 4;
		   j=0;
		   for(i=0;i<LocalTable->size;i++)
		   {
			for(VS = (VaSymbol *) (LocalTable -> table[i]);VS; VS = (VaSymbol *) (VS -> next))
			{
				UValue * pl;
				for(fm=yyvsp[-1].fm;fm;fm=fm ->next)
				{	
					if(fm -> v == VS) break;
				}
				if(!fm) yyerror("firing mode incomplete");
				vl = fm -> t -> evaluate();
				pl = VS -> var -> type -> make();
				pl -> assign(vl);
				cc[j] = pl -> text();
				inst[j] = new char [strlen(VS -> name)+strlen(cc[j]) + 2];
				strcpy(inst[j],VS -> name);
				strcpy(inst[j]+strlen(inst[j]),"=");
				strcpy(inst[j]+strlen(inst[j]),cc[j]);
				len += strlen(inst[j]) + 1;
				j++;
			}
		   } 
		   char * llt;
		   llt = new char[len];
		   strcpy(llt,yyvsp[-3].ts -> name);
		   strcpy(llt+strlen(llt),".[");
		   for(j=0;j<card;j++)
		   {
			strcpy(llt + strlen(llt),inst[j]);
			strcpy(llt + strlen(llt),"|");
		   }
		   strcpy(llt + (strlen(llt) - 1),"]");
		   TS = (TrSymbol *) TransitionTable -> lookup(llt);
		   if(!TS) yyerror("transition instance does not exist");
		   if(TS -> vars && TS -> vars -> card)
		   {
			yyerror("HL and LL transition names mixed up");
		   }
		   yyval.tr = TS -> transition;
		   ;
    break;}
case 9:
#line 252 "readnet.y"
{
			TS = (TrSymbol *) TransitionTable -> lookup(yyvsp[-1].str);
			if(!TS) yyerror("transition does not exist");
			if( ( !(TS -> vars) || TS -> vars -> card == 0))
			{
				yyerror("only HL transitions require firing mode");
			}
			yyval.ts = TS;
			LocalTable = TS -> vars;
			;
    break;}
case 10:
#line 262 "readnet.y"
{
			VS = (VaSymbol *) LocalTable -> lookup(yyvsp[-2].str);
			if(!VS) yyerror("transition does not have this variable");
			if(! (VS -> var -> type -> iscompatible(yyvsp[0].ex -> type)))
			{
				yyerror("expression not compatible with transition variable");
			}
			yyval.fm = new fmode;
			yyval.fm -> next = (fmode *) 0;
			yyval.fm -> v = VS;
			yyval.fm -> t = yyvsp[0].ex;
			;
    break;}
case 11:
#line 274 "readnet.y"
{
			fmode * fm;
			VS = (VaSymbol *) LocalTable -> lookup(yyvsp[-2].str);
			if(!VS) yyerror("transition does not have this variable");
			if(! (VS -> var -> type -> iscompatible(yyvsp[0].ex -> type)))
			{
				yyerror("expression not compatible with transition variable");
			}
			yyval.fm = new fmode;
			yyval.fm -> next = yyvsp[-4].fm;
			yyval.fm -> v = VS;
			yyval.fm -> t = yyvsp[0].ex ;
			for(fm = yyvsp[-4].fm; fm ; fm = fm -> next)
			{
				if(fm -> v == yyval.fm -> v)
				{
					yyerror("variable appears twice in firing mode");
				}
			}
			;
    break;}
case 12:
#line 296 "readnet.y"
{
	PS = (PlSymbol *) PlaceTable ->lookup(yyvsp[0].str); 
	if(!PS) yyerror("Place does not exist");
	if(PS -> sort) yyerror("HL places require instance");
	yyval.pl = PS -> place;
	;
    break;}
case 13:
#line 302 "readnet.y"
{
	PS = (PlSymbol *) PlaceTable ->lookup(yyvsp[-2].str); 
	if(!PS) yyerror("Place does not exist");
	if(!(PS -> sort)) yyerror("LL places do not require instance");
	if(!(PS -> sort -> iscompatible(yyvsp[0].ex -> type)))
	{	
		yyerror("place color not compatible to place sort");
	}
	UValue * vl , * pl;
	vl = yyvsp[0].ex -> evaluate();
	pl = PS -> sort -> make();
	pl -> assign(vl);
	char * inst;
	inst = pl -> text();
	char * ll;
	ll = new char [strlen(PS -> name) + strlen(inst) + 2];
	strcpy(ll,PS -> name);
	strcpy(ll + strlen(ll),".");
	strcpy(ll + strlen(ll),inst);
	PS = (PlSymbol *) PlaceTable -> lookup(ll);
	if(!PS) yyerror("place instance does not exist");
	if(PS->sort) yyerror("mixed up HL and LL place names");
	yyval.pl = PS -> place;
	;
    break;}
case 17:
#line 331 "readnet.y"
{LocalTable = new SymbolTab(256);;
    break;}
case 21:
#line 336 "readnet.y"
{
				// sort symbols are globally visible. A sort entry in the
				// symbol table relates a name to a sort description (UType)

				SoSymbol * s;
				if(s = (SoSymbol *) (GlobalTable -> lookup(yyvsp[-3].str)))
				{
					yyerror("sort symbol name already used");
				}
				s = new SoSymbol(yyvsp[-3].str,yyvsp[-1].t);
			;
    break;}
case 22:
#line 348 "readnet.y"
{ yyval.t = TheBooType; ;
    break;}
case 23:
#line 349 "readnet.y"
{
							// assign an additional name to an existing sort
							SoSymbol * s;
							s = (SoSymbol *) (GlobalTable -> lookup(yyvsp[0].str));
							if(!s) yyerror("undefined sort name");
							if(s -> kind != so) yyerror("sort name expected");
							yyval.t = s -> type;
						;
    break;}
case 24:
#line 357 "readnet.y"
{
						URcList * rl;
						yyval.t = new URecType(yyvsp[-1].rcl);
						;
    break;}
case 25:
#line 361 "readnet.y"
{
						// index type must be scalar
						if(yyvsp[-2].t -> tag != boo && yyvsp[-2].t ->tag != num && yyvsp[-2].t -> tag != enu)
						{
							yyerror("non-scalar type as index of array");
						}
						yyval.t = new UArrType(yyvsp[-2].t,yyvsp[0].t);
						;
    break;}
case 26:
#line 369 "readnet.y"
{
				// integer interval
				unsigned int l,r;
				sscanf(yyvsp[-3].str,"%u",&l);
				sscanf(yyvsp[-1].str,"%u",&r);
				{
					if(l > r) yyerror("negative range in integer type");
				}
				yyval.t = new UNumType(l,r);
			;
    break;}
case 27:
#line 379 "readnet.y"
{
					yyval.t = new UEnuType(yyvsp[-1].el);
					;
    break;}
case 29:
#line 384 "readnet.y"
{ 
					yyvsp[-1].el -> next = yyvsp[0].el;
					yyval.el = yyvsp[-1].el;
				 ;
    break;}
case 30:
#line 389 "readnet.y"
{
			EnSymbol * e;
			UEnList * eel;
			e = (EnSymbol *) GlobalTable -> lookup(yyvsp[0].str);
			if(e) yyerror("element name of enumeration already used");
			e = new EnSymbol(yyvsp[0].str);
			eel = new UEnList;
			eel -> sy = e;
			eel -> next = (UEnList *) 0;
			yyval.el = eel;
			;
    break;}
case 32:
#line 403 "readnet.y"
{
						yyvsp[0].rcl -> next = yyvsp[-1].rcl;
						yyval.rcl = yyvsp[0].rcl;
					;
    break;}
case 33:
#line 408 "readnet.y"
{
						RcSymbol * r;
						URcList * rl;
						r = (RcSymbol *) GlobalTable -> lookup(yyvsp[-3].str);
						if(r) yyerror("record component name already used");
						r = new RcSymbol(yyvsp[-3].str,yyvsp[-1].t);
						rl = new URcList;
						rl -> next = (URcList *) 0;
						rl -> sy = r;
						rl -> ty = yyvsp[-1].t;
						yyval.rcl = rl;
					;
    break;}
case 34:
#line 423 "readnet.y"
{
							yyvsp[-2].fu -> body = yyvsp[0].stm;
							yyvsp[-2].fu -> localsymb = LocalTable;
						;
    break;}
case 39:
#line 430 "readnet.y"
{
							IdList * il;
							for(il = yyvsp[-3].idl;il;il=il->next)
							{	
								VaSymbol * v;
								UVar * vvv;
								if(v = (VaSymbol *) (LocalTable -> lookup(il -> name)))
								{
									yyerror("variable name already used");
								}
								vvv = new UVar(yyvsp[-1].t);
								v = new VaSymbol(il -> name,vvv);
							}
							;
    break;}
case 40:
#line 445 "readnet.y"
{
				yyval.idl = new IdList;
				yyval.idl -> name = yyvsp[0].str;
				yyval.idl -> next = (IdList *) 0;
				;
    break;}
case 41:
#line 450 "readnet.y"
{
				yyval.idl = new IdList;
				yyval.idl -> name = yyvsp[-2].str;
				yyval.idl -> next = yyvsp[0].idl;
			;
    break;}
case 42:
#line 457 "readnet.y"
{
			FcSymbol * fs;
			UFunction * f;
			fs = (FcSymbol *) GlobalTable -> lookup(yyvsp[-5].str);
			if(fs)
			{
				yyerror("function name already used");
			}
			CurrentFunction = f = new UFunction();
			fs = new FcSymbol(yyvsp[-5].str,f);
			f -> type = yyvsp[0].t;
			f -> localsymb = LocalTable;
			f -> result = (UValueList *) 0;
			f -> resultstack = (UResultList *) 0;
			f -> arity = LocalTable -> card;
			f -> formalpar = new UVar * [f -> arity];
			int i;
			i = 0;
			for(int j = 0; j < LocalTable -> size; j++)
			{
				Symbol * s;
				for(s = LocalTable -> table[j]; s; s = s -> next)
				{	
					f -> formalpar[i++] = ((VaSymbol *) s) -> var;
				}
			}
				
				yyval.fu = f;
		;
    break;}
case 46:
#line 488 "readnet.y"
{
		IdList * il;
		for(il = yyvsp[-2].idl; il; il = il -> next)
		{
								VaSymbol * v;
								UVar * vvv;
								if(v = (VaSymbol *) (LocalTable -> lookup(il -> name)))
								{
									yyerror("variable name already used");
								}
								vvv = new UVar(yyvsp[0].t);
								v = new VaSymbol(il -> name,vvv);
			
		}
		;
    break;}
case 47:
#line 504 "readnet.y"
{ yyval.stm = yyvsp[-1].stm; ;
    break;}
case 49:
#line 507 "readnet.y"
{ 
										   UStatement * s;
										   s = new USequenceStatement;
                                          ((USequenceStatement * ) s) -> first = yyvsp[-2].stm;
                                          ((USequenceStatement *) s) -> second = yyvsp[0].stm;
											yyval.stm = s;
					;
    break;}
case 59:
#line 525 "readnet.y"
{
		if(yyvsp[-3].ex -> type -> tag != boo)
		{
			yyerror("while condition must be boolean");
		}
		yyval.stm = new UWhileStatement;
		((UWhileStatement *) yyval.stm) -> cond = yyvsp[-3].ex;
		((UWhileStatement *) yyval.stm) -> body = yyvsp[-1].stm;
		;
    break;}
case 60:
#line 535 "readnet.y"
{
		if(yyvsp[-1].ex -> type -> tag != boo)
		{
			yyerror("while condition must be boolean");
		}
		yyval.stm = new URepeatStatement;
		((URepeatStatement *) yyval.stm) -> cond = yyvsp[-1].ex;
		((URepeatStatement *) yyval.stm) -> body = yyvsp[-3].stm;
		;
    break;}
case 61:
#line 545 "readnet.y"
{
		VaSymbol * v;
		v = (VaSymbol *) LocalTable -> lookup(yyvsp[-7].str);
		if(!v) yyerror("loop variable not declared");
		yyval.stm = new UForStatement;
		((UForStatement *) yyval.stm) -> var = v -> var;
		if(! ( v->var->type -> iscompatible(yyvsp[-5].ex -> type)))
		{
			yyerror("initial expression of for statement not compatible to counter variable");
		}
		if(! ( v->var->type -> iscompatible(yyvsp[-3].ex -> type)))
		{
			yyerror("exit expression of for statement not compatible to counter variable");
		}
		((UForStatement *) yyval.stm) -> init = yyvsp[-5].ex;
		((UForStatement *) yyval.stm) -> finit = yyvsp[-3].ex;
		((UForStatement *) yyval.stm) -> body = yyvsp[-1].stm;
		;
    break;}
case 62:
#line 564 "readnet.y"
{
			VaSymbol * v;
			v = (VaSymbol *) LocalTable -> lookup(yyvsp[-3].str);
			if(!v) yyerror("loop variable not declared");
			yyval.stm = new UForallStatement;
			((UForallStatement *) yyval.stm) -> var = v -> var;
			((UForallStatement *) yyval.stm) -> body = yyvsp[-1].stm;
			;
    break;}
case 63:
#line 573 "readnet.y"
{
			if(yyvsp[-3].ex -> type -> tag != boo)
			{
				yyerror("condition in if statement must be boolean");
			}
			yyval.stm = new UConditionalStatement;
			((UConditionalStatement *) yyval.stm) -> cond = yyvsp[-3].ex;
			((UConditionalStatement *) yyval.stm) -> yes = yyvsp[-1].stm;
			((UConditionalStatement *) yyval.stm) -> no = new UNopStatement;
			;
    break;}
case 64:
#line 583 "readnet.y"
{
			if(yyvsp[-5].ex -> type -> tag != boo)
			{
				yyerror("condition in if statement must be boolean");
			}
			yyval.stm = new UConditionalStatement;
			((UConditionalStatement *) yyval.stm) -> cond = yyvsp[-5].ex;
			((UConditionalStatement *) yyval.stm) -> yes = yyvsp[-3].stm;
			((UConditionalStatement *) yyval.stm) -> no = yyvsp[-1].stm;
			;
    break;}
case 65:
#line 594 "readnet.y"
{
		   if(!(yyvsp[0].ex -> type -> iscompatible(CurrentFunction -> type)))
		   {
			yyerror("returned value incompatible to function type");
		   }
		   yyval.stm = new UReturnStatement;
		   ((UReturnStatement *) yyval.stm) -> fct = CurrentFunction;
		   ((UReturnStatement *) yyval.stm) -> exp = yyvsp[0].ex;
		   ;
    break;}
case 66:
#line 604 "readnet.y"
{
			yyval.stm = new UExitStatement;
			((UExitStatement *) yyval.stm) -> fct = CurrentFunction;
			 ;
    break;}
case 67:
#line 609 "readnet.y"
{
		unsigned int crd;
		case_list * l;
		for(l = yyvsp[-1].cl,crd = 0; l; l = l -> next,crd++)
		{
			if(!(yyvsp[-2].ex -> type -> iscompatible(l -> exp -> type)))
			{
				yyerror("case item incompatible to case expression");
			}
	    	}
		yyval.stm = new UCaseStatement;
		((UCaseStatement *) yyval.stm) -> exp = yyvsp[-2].ex;
		((UCaseStatement *) yyval.stm) -> cond = new UExpression * [crd + 1];
		((UCaseStatement *) yyval.stm) -> yes = new UStatement * [crd + 1];
		((UCaseStatement *) yyval.stm) -> def = new UNopStatement;
		for(l=yyvsp[-1].cl,crd=0; l; l = l -> next,crd++)
		{	
			((UCaseStatement *) yyval.stm) -> cond[crd] = l -> exp;
			((UCaseStatement *) yyval.stm) -> yes[crd] = l -> stm;
		}
		((UCaseStatement *) yyval.stm) -> card = crd;
		;
    break;}
case 68:
#line 631 "readnet.y"
{
		unsigned int crd;
		case_list * l;
		for(l = yyvsp[-3].cl,crd = 0; l; l = l -> next,crd++)
		{
			if(!(yyvsp[-4].ex -> type -> iscompatible(l -> exp -> type)))
			{
				yyerror("case item incompatible to case expression");
			}
	    	}
		yyval.stm = new UCaseStatement;
		((UCaseStatement *) yyval.stm) -> exp = yyvsp[-4].ex;
		((UCaseStatement *) yyval.stm) -> cond = new UExpression * [crd + 1];
		((UCaseStatement *) yyval.stm) -> yes = new UStatement * [crd + 1];
		((UCaseStatement *) yyval.stm) -> def = yyvsp[-1].stm;
		for(l=yyvsp[-3].cl,crd=0; l; l = l -> next,crd++)
		{	
			((UCaseStatement *) yyval.stm) -> cond[crd] = l -> exp;
			((UCaseStatement *) yyval.stm) -> yes[crd] = l -> stm;
		}
		((UCaseStatement *) yyval.stm) -> card = crd;
		;
    break;}
case 69:
#line 654 "readnet.y"
{ yyval.cl = (case_list *) 0;;
    break;}
case 70:
#line 655 "readnet.y"
{yyvsp[-1].cl -> next = yyvsp[0].cl; yyval.cl = yyvsp[-1].cl;;
    break;}
case 71:
#line 657 "readnet.y"
{ yyval.cl = new case_list;
					yyval.cl -> exp = yyvsp[-2].ex;
					yyval.cl -> stm = yyvsp[0].stm;
					yyval.cl -> next = (case_list *) 0;
					;
    break;}
case 72:
#line 663 "readnet.y"
{
		if(!(yyvsp[-2].lval -> type -> iscompatible(yyvsp[0].ex->type)))
		{	
			yyerror("incompatible types in assignment");
		}	
		yyval.stm = new UAssignStatement;
		((UAssignStatement *) yyval.stm) -> left = yyvsp[-2].lval;
		((UAssignStatement *) yyval.stm) -> right = yyvsp[0].ex;
		;
    break;}
case 73:
#line 673 "readnet.y"
{
		VaSymbol * v;
		v = (VaSymbol *) (LocalTable -> lookup(yyvsp[0].str));
		if(!v) yyerror("variable not defined");
		yyval.lval = new UVarLVal;
		((UVarLVal*) yyval.lval) -> var = v -> var;
		yyval.lval -> type = ((UVarLVal *) yyval.lval) -> var -> type;
		;
    break;}
case 74:
#line 681 "readnet.y"
{
		if(yyvsp[-3].lval -> type -> tag != arr)
		{
			yyerror("component of something not an array referenced");
		}
		if((yyvsp[-1].ex -> type -> tag != boo) && (yyvsp[-1].ex -> type -> tag != num) && (yyvsp[-1].ex -> type -> tag != enu))
		{
			yyerror("non-scalar expression for array index");
		}
		yyval.lval = new UArrayLVal;
		yyval.lval -> type = ((UArrType *) (yyvsp[-3].lval -> type)) -> component;
		((UArrayLVal *) yyval.lval) -> indextype = ((UArrType *) (yyvsp[-3].lval -> type)) -> index;
		((UArrayLVal *) yyval.lval) -> parent = yyvsp[-3].lval;
		((UArrayLVal *) yyval.lval) -> idx = yyvsp[-1].ex;
		;
    break;}
case 75:
#line 696 "readnet.y"
{
			RcSymbol *r;
			r = (RcSymbol *) (GlobalTable -> lookup(yyvsp[0].str));
			if((!r) || (r -> kind != rc))
			{
				yyerror("record component unknown");
			}
			if(yyvsp[-2].lval -> type -> tag != rec)
			{
				yyerror("component of something not a record referenced");
			}
			if(r -> index >= ((URecType *) (yyvsp[-2].lval -> type)) -> card ||(r -> type != ((URecType *) (yyvsp[-2].lval -> type)) -> component[r->index]))
			{
				yyerror("record type does not have such component");
			}
			yyval.lval = new URecordLVal;
			yyval.lval -> type = ((URecType *) (yyvsp[-2].lval -> type)) -> component[r -> index];
			((URecordLVal *) yyval.lval) -> parent = yyvsp[-2].lval;
			((URecordLVal *) yyval.lval) -> offset = r -> index;
		;
    break;}
case 76:
#line 717 "readnet.y"
{
				UDivExpression * e;
				if(!deep_compatible(yyvsp[-2].ex -> type,yyvsp[0].ex -> type, boo))
				{
					yyerror("boolean operator applied to non-boolean operands");
				}
				e = new UDivExpression;
				e -> left = yyvsp[-2].ex;
				e -> right = yyvsp[0].ex;
				e -> type = yyvsp[-2].ex -> type;
				yyval.ex = e;
				;
    break;}
case 77:
#line 729 "readnet.y"
{
				USubExpression * e;
				if(!deep_compatible(yyvsp[-2].ex -> type,yyvsp[0].ex -> type, boo))
				{
					yyerror("boolean operator applied to non-boolean operands");
				}
				e = new USubExpression;
				e -> left = yyvsp[-2].ex;
				e -> right = yyvsp[0].ex;
				e -> type = yyvsp[-2].ex -> type;
				yyval.ex = e;
				;
    break;}
case 79:
#line 743 "readnet.y"
{
				UMulExpression * e;
				if(!deep_compatible(yyvsp[-2].ex -> type,yyvsp[0].ex -> type, boo))
				{
					yyerror("boolean operator applied to non-boolean operands");
				}
				e = new UMulExpression;
				e -> left = yyvsp[-2].ex;
				e -> right = yyvsp[0].ex;
				e -> type = yyvsp[-2].ex -> type;
				yyval.ex = e;
				;
    break;}
case 80:
#line 755 "readnet.y"
{
				UAddExpression * e;
				if(!deep_compatible(yyvsp[-2].ex -> type,yyvsp[0].ex -> type, boo))
				{
					yyerror("boolean operator applied to non-boolean operands");
				}
				e = new UAddExpression;
				e -> left = yyvsp[-2].ex;
				e -> right = yyvsp[0].ex;
				e -> type = yyvsp[-2].ex -> type;
				yyval.ex = e;
				;
    break;}
case 82:
#line 769 "readnet.y"
{
				UNegExpression * e;
				if(!deep_compatible(yyvsp[0].ex -> type,boo))
				{
					yyerror("boolean operator applied to non-boolean operand");
				}
				e = new UNegExpression;
				e -> left = yyvsp[0].ex;
				e -> type = yyvsp[0].ex -> type;
				yyval.ex = e;
				;
    break;}
case 84:
#line 782 "readnet.y"
{
				UEqualExpression * e;
				e = new UEqualExpression;
				e -> left = yyvsp[-2].ex;
				e -> right = yyvsp[0].ex;
				e -> type = TheBooType;
				yyval.ex = e;
				;
    break;}
case 85:
#line 790 "readnet.y"
{
				UGreaterthanExpression * e;
				e = new UGreaterthanExpression;
				e -> left = yyvsp[-2].ex;
				e -> right = yyvsp[0].ex;
				e -> type = TheBooType;
				yyval.ex = e;
				;
    break;}
case 86:
#line 798 "readnet.y"
{
				ULessthanExpression * e;
				e = new ULessthanExpression;
				e -> left = yyvsp[-2].ex;
				e -> right = yyvsp[0].ex;
				e -> type = TheBooType;
				yyval.ex = e;
				;
    break;}
case 87:
#line 806 "readnet.y"
{
				UGreaterequalExpression * e;
				e = new UGreaterequalExpression;
				e -> left = yyvsp[-2].ex;
				e -> right = yyvsp[0].ex;
				e -> type = TheBooType;
				yyval.ex = e;
				;
    break;}
case 88:
#line 814 "readnet.y"
{
				ULessequalExpression * e;
				e = new ULessequalExpression;
				e -> left = yyvsp[-2].ex;
				e -> right = yyvsp[0].ex;
				e -> type = TheBooType;
				yyval.ex = e;
				;
    break;}
case 89:
#line 822 "readnet.y"
{
				UUnequalExpression * e;
				e = new UUnequalExpression;
				e -> left = yyvsp[-2].ex;
				e -> right = yyvsp[0].ex;
				e -> type = TheBooType;
				yyval.ex = e;
				;
    break;}
case 91:
#line 832 "readnet.y"
{
				UAddExpression * e;
				if(!deep_compatible(yyvsp[-2].ex -> type,yyvsp[0].ex -> type, num))
				{
					yyerror("integer operator applied to non-integer operands");
				}
				e = new UAddExpression;
				e -> left = yyvsp[-2].ex;
				e -> right = yyvsp[0].ex;
				e -> type = yyvsp[-2].ex -> type;
				yyval.ex = e;
				;
    break;}
case 92:
#line 844 "readnet.y"
{
				USubExpression * e;
				if(!deep_compatible(yyvsp[-2].ex -> type,yyvsp[0].ex -> type, num))
				{
					yyerror("integer operator applied to non-integer operands");
				}
				e = new USubExpression;
				e -> left = yyvsp[-2].ex;
				e -> right = yyvsp[0].ex;
				e -> type = yyvsp[-2].ex -> type;
				yyval.ex = e;
				;
    break;}
case 94:
#line 858 "readnet.y"
{
				UMulExpression * e;
				if(!deep_compatible(yyvsp[-2].ex -> type,yyvsp[0].ex -> type, num))
				{
					yyerror("integer operator applied to non-integer operands");
				}
				e = new UMulExpression;
				e -> left = yyvsp[-2].ex;
				e -> right = yyvsp[0].ex;
				e -> type = yyvsp[-2].ex -> type;
				yyval.ex = e;
				;
    break;}
case 95:
#line 870 "readnet.y"
{
				UDivExpression * e;
				if(!deep_compatible(yyvsp[-2].ex -> type,yyvsp[0].ex -> type, num))
				{
					yyerror("integer operator applied to non-integer operands");
				}
				e = new UDivExpression;
				e -> left = yyvsp[-2].ex;
				e -> right = yyvsp[0].ex;
				e -> type = yyvsp[-2].ex -> type;
				yyval.ex = e;
				;
    break;}
case 96:
#line 882 "readnet.y"
{
				UModExpression * e;
				if(!deep_compatible(yyvsp[-2].ex -> type,yyvsp[0].ex -> type, num))
				{
					yyerror("integer operator applied to non-integer operands");
				}
				e = new UModExpression;
				e -> left = yyvsp[-2].ex;
				e -> right = yyvsp[0].ex;
				e -> type = yyvsp[-2].ex -> type;
				yyval.ex = e;
				;
    break;}
case 98:
#line 896 "readnet.y"
{
				UNegExpression * e;
				if(!deep_compatible(yyvsp[0].ex -> type,num))
				{
					yyerror("integer operator applied to non-integer operands");
				}
				e = new UNegExpression;
				e -> left = yyvsp[0].ex;
				e -> type = yyvsp[0].ex -> type;
				yyval.ex = e;
				;
    break;}
case 100:
#line 909 "readnet.y"
{
		Symbol * s;
		s = LocalTable -> lookup(yyvsp[0].str);
		if(s)
		{
			// s is local variable

			VaSymbol * v;
			ULvalExpression * e;
			ULVal * l;
			v = (VaSymbol *) s;
			l = new UVarLVal;
			((UVarLVal *) l) -> var = v -> var;
			((UVarLVal *) l) -> type = ((UVarLVal *) l) -> var -> type;
			e = new ULvalExpression;
			e -> type = l -> type;
			e -> lval = l;
			yyval.ex = e;
		}
		else
		{
			// try global symbol
			EnSymbol *n;
			UEnuconstantExpression * e;
			s = GlobalTable -> lookup(yyvsp[0].str);
			if(!s) yyerror("identifier not defined");
			if(s->kind != en) yyerror("identifier of wrong kind");
			n = (EnSymbol *) s;
			e = new UEnuconstantExpression;
			e -> type = n -> type;
			e -> nu = n -> ord;
			yyval.ex = e;
		}
		;
    break;}
case 101:
#line 943 "readnet.y"
{
			RcSymbol *r;
			URecordLVal * l;
			ULvalExpression * e;
			r = (RcSymbol *) (GlobalTable -> lookup(yyvsp[0].str));
			if((!r) || (r -> kind != rc))
			{
				yyerror("record component unknown");
			}
			if(yyvsp[-2].lval -> type -> tag != rec)
			{
				yyerror("component of something not a record referenced");
			}
			if(r -> index >= ((URecType *) (yyvsp[-2].lval -> type)) -> card ||(r -> type != ((URecType *) (yyvsp[-2].lval -> type)) -> component[r->index]))
			{
				yyerror("record type does not have this component");
			}
			l = new URecordLVal;
			l -> type = ((URecType *) yyvsp[-2].lval) -> component[r -> index];
			l -> parent = yyvsp[-2].lval;
			l -> offset = r -> index;
			e = new ULvalExpression;
			e -> type = l -> type;
			e -> lval = l;
			yyval.ex = e;
		;
    break;}
case 102:
#line 969 "readnet.y"
{
		UArrayLVal * a;
		ULvalExpression * e;
		if(yyvsp[-3].lval -> type -> tag != arr)
		{
			yyerror("component of something not an array referenced");
		}
		if((yyvsp[-1].ex -> type -> tag != boo) && (yyvsp[-1].ex -> type -> tag != num) && (yyvsp[-1].ex -> type -> tag != enu))
		{
			yyerror("non-scalar expression for array index");
		}
		a = new UArrayLVal;
		a -> type = ((UArrType *) (yyvsp[-3].lval -> type)) -> component;
		a -> parent = yyvsp[-3].lval;
		a -> indextype = ((UArrType *) (yyvsp[-3].lval -> type)) -> index;
		a -> idx = yyvsp[-1].ex;
		e = new ULvalExpression;
		e -> type = a -> type;
		e -> lval = a;
		yyval.ex =e;
		;
    break;}
case 103:
#line 990 "readnet.y"
{yyval.ex = yyvsp[-1].ex;
    break;}
case 104:
#line 991 "readnet.y"
{
		yyval.ex = new UTrueExpression;
		yyval.ex -> type = TheBooType;
		;
    break;}
case 105:
#line 995 "readnet.y"
{
		yyval.ex = new UFalseExpression;
		yyval.ex -> type = TheBooType;
		;
    break;}
case 108:
#line 1001 "readnet.y"
{yyval.ex = new UIntconstantExpression;
			 sscanf(yyvsp[0].str,"%u",&(((UIntconstantExpression *) yyval.ex) -> nu)); 
			 yyval.ex -> type = TheNumType;;
    break;}
case 109:
#line 1005 "readnet.y"
{
					UCallExpression * e;
					case_list * c;
					FcSymbol * f;
					int i;
					f = (FcSymbol *) GlobalTable -> lookup(yyvsp[-3].str);
					if(!f) yyerror("undefined function called");
					e = new UCallExpression;
					e -> fct = f -> function;
					e -> type = f -> function -> type;
					e -> currentpar = new UExpression * [f -> function -> arity];
					for(i = 0,c=yyvsp[-1].cl; i < f->  function -> arity; i++)
					{
						if(!c) yyerror("too few arguments to function");
						e -> currentpar[i] = c -> exp;
						if(!(c -> exp -> type -> iscompatible(f -> function -> formalpar[i]->type)))
						{
							yyerror("type mismatch in call parameter");
						}
						c = c -> next;
					}
					if(c) yyerror("to many arguments to function");
					yyval.ex = e;
				;
    break;}
case 110:
#line 1030 "readnet.y"
{yyval.cl = (case_list *) 0;;
    break;}
case 111:
#line 1031 "readnet.y"
{
					yyval.cl = new case_list;
					yyval.cl -> exp = yyvsp[0].ex;
					yyval.cl -> next = (case_list *) 0;
				;
    break;}
case 112:
#line 1036 "readnet.y"
{
					yyval.cl = new case_list;
					yyval.cl -> exp = yyvsp[-2].ex;
					yyval.cl -> next = yyvsp[0].cl;
				;
    break;}
case 113:
#line 1042 "readnet.y"
{
					UNumType * it;
					UArrType * at;
					UType * ct;
					unsigned int h;
					int i;
					case_list * c;
					UArrayExpression * e;

					for(c=yyvsp[-1].cl,h=0;c;c = c -> next,h++);
					it = new UNumType(1,h);
					ct = yyvsp[-1].cl -> exp -> type;
					at = new UArrType(it,ct);
					e = new UArrayExpression;
					e -> type = at;
					e -> card = h;
					e -> cont = new UExpression * [h];
					for(i = 0,c = yyvsp[-1].cl; i < h; i++,c = c -> next)
					{
						e -> cont[i] = c -> exp;
						if(!(ct -> iscompatible(c -> exp -> type)))
						{
							yyerror("incompatible types in array value");
						}

					}
					yyval.ex = e;
				;
    break;}
case 114:
#line 1071 "readnet.y"
{
				yyval.cl = new case_list;
				yyval.cl ->exp = yyvsp[0].ex;
				yyval.cl -> next = (case_list *) 0;
			;
    break;}
case 115:
#line 1076 "readnet.y"
{
				yyval.cl = new case_list;
				yyval.cl -> next = yyvsp[0].cl;
				yyval.cl -> exp = yyvsp[-2].ex;
			;
    break;}
case 118:
#line 1085 "readnet.y"
{
 unsigned int i;
  PS = (PlSymbol *) PlaceTable -> lookup(yyvsp[-2].str);
  if(!PS)
    {
      yyerror("place does not exist");
    }
  if(PS -> sort)
  {
	// HL place, number nicht erlaubt
	yyerror("markings of high level places must be term expressions");
  }
  else
  {
  // LL place, number ist als Anzahl zu interpretieren
  sscanf(yyvsp[0].str,"%u",&i);
  PS->place->target_marking += i;
  }
 ;
    break;}
case 119:
#line 1104 "readnet.y"
{
				char * inst, * ll;
				UTermList * tl;
				UValueList * vl, * currentvl;
				UValue * pv;
				PlSymbol * PSI;
				PS = (PlSymbol *) PlaceTable -> lookup(yyvsp[-2].str);
				if(!PS)
				{
					yyerror("place does not exist");
				}
				if(!PS -> sort)
				{	
					yyerror("multiterm expression not allowed for low level places");
				}
				pv = PS -> sort -> make();
				for(tl = yyvsp[0].tlist; tl; tl = tl -> next) // do for all mt components
				{
					// check type compatibility
					if(!(PS -> sort -> iscompatible(tl -> t -> type)))
					{
						yyerror("marking expression not compatible to sort of place");
					}
					vl = tl -> t -> evaluate();
					for(currentvl = vl; currentvl;currentvl = currentvl -> next)
					{
						pv -> assign(currentvl -> val); // type adjustment
						inst = pv -> text();
						ll = new char [strlen(yyvsp[-2].str) + strlen(inst) + 2];
						strcpy(ll,yyvsp[-2].str);
						strcpy(ll + strlen(yyvsp[-2].str),".");
						strcpy(ll + (strlen(yyvsp[-2].str) + 1), inst);
						PSI = (PlSymbol *) PlaceTable -> lookup(ll); 
						if(!PSI)
						{
							yyerror("place instance does not exist");
						}
						PSI -> place -> target_marking += tl -> mult;
					}
				}
			;
    break;}
case 120:
#line 1146 "readnet.y"
{LocalTable = (SymbolTab *) 0;;
    break;}
case 121:
#line 1146 "readnet.y"
{
  unsigned int i,h,j;
  Symbol * ss;
  // Create array of places
  Places = new Place * [PlaceTable -> card];
  i = 0;
  for(h=0;h<PlaceTable -> size;h++)
    {
      for(ss= PlaceTable -> table[h];ss;ss = ss -> next)
	{
	  if(!(((PlSymbol *) ss) -> sort))
	  {
		  Places[i++] = ((PlSymbol *) ss) -> place;
	  }
	}
    }
	PlaceTable->card = i;
  // Create array of transitions 
  Transitions = new Transition * [TransitionTable -> card];
  i = 0;
  for(h=0;h<TransitionTable -> size;h++)
    {
      for(ss = TransitionTable -> table[h];ss;ss = ss -> next)
	{
	  if(!(((TrSymbol *) ss) -> vars))
	  {
		  Transitions[i++] = ((TrSymbol *) ss) -> transition;
	  }
	}
    }
	TransitionTable->card = i;
  // Create arc list of places pass 1 (count nr of arcs)
  for(i = 0; i < TransitionTable -> card;i++)
    {
      for(j=0;j < Transitions[i]->NrOfArriving;j++)
	{
	  Transitions[i]->ArrivingArcs[j]->pl->NrOfLeaving++;
	}
      for(j=0;j < Transitions[i]->NrOfLeaving;j++)
	{
	  Transitions[i]->LeavingArcs[j]->pl->NrOfArriving++;
	}
    }
  // pass 2 (allocate arc arrays)
  for(i=0;i<PlaceTable -> card;i++)
    {
      Places[i]->ArrivingArcs = new Arc * [Places[i]->NrOfArriving];
      Places[i]->NrOfArriving = 0;
      Places[i]->LeavingArcs = new Arc * [Places[i]->NrOfLeaving];
      Places[i]->NrOfLeaving = 0;
    }
  // pass 3 (fill in arcs)
  for(i=0;i<TransitionTable -> card;i++)
    {
      for(j=0;j < Transitions[i]->NrOfLeaving;j++)
	{
	  Place * pl;
	  pl = Transitions[i]->LeavingArcs[j]->pl;
	  pl->ArrivingArcs[pl->NrOfArriving] = Transitions[i]->LeavingArcs[j];
	  pl->NrOfArriving ++;
	}
      for(j=0;j < Transitions[i]->NrOfArriving;j++)
	{
	  Place * pl;
	  pl = Transitions[i]->ArrivingArcs[j]->pl;
	  pl->LeavingArcs[pl->NrOfLeaving] = Transitions[i]->ArrivingArcs[j];
	  pl->NrOfLeaving ++;
	}
    }
  // initialize transitions 
  for(i=0;i<TransitionTable -> card;i++)
    {
      Transitions[i]-> initialize();
    }
  for(i=0;i < TransitionTable -> card;i++)
    {
      Transitions[i]->NextEnabled = ((i == TransitionTable -> card - 1)? (Transition *) 0 : Transitions[i+1]);
      Transitions[i]->PrevEnabled = ((i==0)? (Transition *) 0 : Transitions[i-1]);
      Transitions[0]->NrEnabled++;
      Transitions[i] -> enabled = true;
#ifdef STUBBORN
      Transitions[i] -> mustbeincluded = Transitions[i]->conflicting;
#if defined(EXTENDED) && defined(MODELCHECKING)
	Transitions[i]->lstfired = new unsigned int [1];
	Transitions[i]->lstdisabled = new unsigned int [1];
#endif
#endif
    }
#if defined(EXTENDED) && defined(MODELCHECKING)
	formulaindex = 0;
	currentdfsnum = 0;
#endif
  // initialize places
#ifdef STUBBORN
  for(i= 0;i < PlaceTable -> card;i++) Places[i]->initialize();
#endif
  Transitions[0]-> StartOfEnabledList = Transitions[0];
  for(i=0;i<TransitionTable -> card;i++)
    {
      Transitions[i]-> check_enabled();
    }
// The following pieces of code initialize static attractor sets for
// various problems.
#ifdef BOUNDEDNET
#ifdef STUBBORN
	// initialize list of pumping transitions
	LastAttractor = (Transition*)0;
	int p,c,a; // produced, consumed tokens, current arc
	for(i=0;i< TransitionTable -> card;i++)
	{
		// count produced tokens
		for(a=0,p=0;a<Transitions[i]->NrOfLeaving;a++)
		{
			p += Transitions[i]->LeavingArcs[a] -> Multiplicity;
		}
		// count consumed tokens
		for(a=0,c=0;a<Transitions[i]->NrOfArriving;a++)
		{
			c += Transitions[i]->ArrivingArcs[a]->Multiplicity;
		}
		if(p > c)
		{
			Transitions[i]->instubborn = true;
			if(LastAttractor)
			{
				Transitions[i]->NextStubborn = 
					Transitions[i]->StartOfStubbornList;
				Transitions[i]->StartOfStubbornList = Transitions[i];
			}
			else
			{
				Transitions[i]->StartOfStubbornList = LastAttractor = Transitions[i];
				Transitions[i]-> NextStubborn = (Transition *) 0;
			}
		}
	}
		
#endif
#endif
;
    break;}
case 124:
#line 1290 "readnet.y"
{
			 if(PlaceTable -> lookup(yyvsp[0].str))
			 {
			   yyerror("Place name used twice");
		     }
			 P = new Place(yyvsp[0].str);
		     PS = new PlSymbol(P);
			 PS -> sort = (UType *) 0;
		;
    break;}
case 125:
#line 1299 "readnet.y"
{
			// high level place: unfold to all instances
			char * c;
			if(PlaceTable -> lookup(yyvsp[-2].str))
			{
				yyerror("Place name used twice");
			}
			c = new char [strlen(yyvsp[-2].str)];
			strcpy(c,yyvsp[-2].str);
			PS =  new PlSymbol(c);
			PS -> sort = yyvsp[0].t;
			UValue * v;
			v = yyvsp[0].t -> make();
			do
			{
				char * lowlevelplace;
				char * lowtag;
				lowtag = v -> text();
				lowlevelplace = new char [ strlen(c) + strlen(lowtag) + 2];
				strcpy(lowlevelplace,c);
				strcpy(lowlevelplace + strlen(c), ".");
				strcpy(lowlevelplace + strlen(c) + 1, lowtag);
				if(PlaceTable -> lookup(lowlevelplace))
				{
					yyerror("Place instance name already used");
				}
				P = new Place(lowlevelplace);
				PS = new PlSymbol(P);
				PS -> sort = (UType *) 0;
				(*v)++;
			} while(!(v -> isfirst()));
			;
    break;}
case 126:
#line 1332 "readnet.y"
{ yyval.str = yyvsp[0].str;;
    break;}
case 127:
#line 1333 "readnet.y"
{yyval.str = yyvsp[0].str; ;
    break;}
case 131:
#line 1339 "readnet.y"
{
  unsigned int i;
  PS = (PlSymbol *) PlaceTable -> lookup(yyvsp[-2].str);
  if(!PS)
    {
      yyerror("place does not exist");
    }
  if(PS -> sort)
  {
	// HL place, number nicht erlaubt
	yyerror("markings of high level places must be term expressions");
  }
  else
  {
  // LL place, number ist als Anzahl zu interpretieren
  sscanf(yyvsp[0].str,"%u",&i);
  *(PS->place) += i;
  }
 ;
    break;}
case 132:
#line 1358 "readnet.y"
{
				char * inst, * ll;
				UTermList * tl;
				UValueList * vl, * currentvl;
				UValue * pv;
				PlSymbol * PSI;
				PS = (PlSymbol *) PlaceTable -> lookup(yyvsp[-2].str);
				if(!PS)
				{
					yyerror("place does not exist");
				}
				if(!PS -> sort)
				{	
					yyerror("multiterm expression not allowed for low level places");
				}
				pv = PS -> sort -> make();
				for(tl = yyvsp[0].tlist; tl; tl = tl -> next) // do for all mt components
				{
					// check type compatibility
					if(!(PS -> sort -> iscompatible(tl -> t -> type)))
					{
						yyerror("marking expression not compatible to sort of place");
					}
					vl = tl -> t -> evaluate();
					for(currentvl = vl; currentvl;currentvl = currentvl -> next)
					{
						pv -> assign(currentvl -> val); // type adjustment
						inst = pv -> text();
						ll = new char [strlen(yyvsp[-2].str) + strlen(inst) + 2];
						strcpy(ll,yyvsp[-2].str);
						strcpy(ll + strlen(yyvsp[-2].str),".");
						strcpy(ll + (strlen(yyvsp[-2].str) + 1), inst);
						PSI = (PlSymbol *) PlaceTable -> lookup(ll); 
						if(!PSI)
						{
							yyerror("place instance does not exist");
						}
						(* PSI -> place) += tl -> mult;
					}
				}
			;
    break;}
case 133:
#line 1400 "readnet.y"
{ yyval.tlist = yyvsp[0].tlist;;
    break;}
case 134:
#line 1401 "readnet.y"
{yyvsp[0].tlist -> next = yyvsp[-2].tlist; yyval.tlist = yyvsp[0].tlist;;
    break;}
case 135:
#line 1403 "readnet.y"
{ yyval.tlist = yyvsp[0].tlist;;
    break;}
case 136:
#line 1404 "readnet.y"
{ unsigned int i; sscanf(yyvsp[0].str,"%u",&i);yyvsp[-2].tlist -> mult = i;
								 yyval.tlist = yyvsp[-2].tlist;;
    break;}
case 137:
#line 1407 "readnet.y"
{
		UTermList * tl;
		UVarTerm * vt;
		if(!LocalTable)
		{
			yyerror("only constant terms are allowed in this context");
		}
		VS =(VaSymbol *)  (LocalTable -> lookup(yyvsp[0].str));
		if(!VS)
		{
			yyerror("undeclared variable in term");
		}
		tl = new UTermList;
		tl -> next = (UTermList *) 0;
		tl -> mult = 1;
		vt = new UVarTerm;
		tl -> t = vt;
		vt -> v = VS -> var;
		vt -> type = VS -> var -> type;
		yyval.tlist =tl;
		;
    break;}
case 138:
#line 1428 "readnet.y"
{
		FcSymbol * FS;
		UTermList * tl;
		UOpTerm * ot;
		FS = (FcSymbol *) GlobalTable -> lookup(yyvsp[-3].str);
		if(!FS) yyerror("operation symbol not declared");
		if(FS ->kind != fc) yyerror("wrong symbol used as operation symbol");
		unsigned int i;
		UTermList * l;
		for(i=0,l=yyvsp[-1].tlist;l;i++,l=l->next);
		if(i != FS -> function -> arity) yyerror("wrong number of arguments");
		tl = new UTermList;
		tl -> next = (UTermList *) 0;
		tl -> mult = 1;
		ot = new UOpTerm;
		tl -> t = ot;
		ot -> arity = i;
		ot -> f = FS -> function;
		ot -> sub = new UTerm * [i];
		for(i=0,l=yyvsp[-1].tlist;i<ot -> arity;i++,l= l -> next)
		{
			if(!(ot -> f -> formalpar[i] -> type -> iscompatible(l -> t -> type)))
			{
				yyerror("type mismatch in subterm(s)");
			}
			ot -> sub[i] = l -> t;
		}
		ot -> type = ot -> f -> type;
		yyval.tlist = tl;
	   ;
    break;}
case 139:
#line 1459 "readnet.y"
{yyval.tlist = (UTermList *) 0;;
    break;}
case 140:
#line 1460 "readnet.y"
{ yyval.tlist = yyvsp[0].tlist;;
    break;}
case 141:
#line 1461 "readnet.y"
{
			yyvsp[-2].tlist -> next = yyvsp[0].tlist;
			yyval.tlist = yyvsp[-2].tlist;
			;
    break;}
case 144:
#line 1470 "readnet.y"
{
  unsigned int card;
  unsigned int i;
  arc_list * current;
  /* 1. Transition anlegen */
  if(TransitionTable -> lookup(yyvsp[-8].str))
    {
      yyerror("transition name used twice");
    }
  TS = new TrSymbol(yyvsp[-8].str);
  TS -> vars = LocalTable;
  TS -> guard = yyvsp[-6].ex;

  // unfold HL transitions
  // -> create transition instance for every assignment to the variables that
  //    matches the guard


  // init: initially, all variables have initial value

  while(1)
  {
	if(TS -> guard)
	{
		UValue * v;
		v = TS -> guard -> evaluate();
		if(((UBooValue * )v) -> v == false) goto nextass;
	}
	// A) create LL transition with current variable assignment

  /* generate name */
  char * llt;
  if((!LocalTable) || LocalTable -> card == 0)
  {
	llt = TS -> name;
	TS -> vars = (SymbolTab *) 0;
  }
  else
  {
  char ** assignment;
  unsigned int len;
  len = 0;
  assignment = new char * [LocalTable -> card + 1];
  VaSymbol * vs;
  unsigned int i,j;
  j=0;
  for(i=0;i < LocalTable -> size; i++)
  {
	for(vs = (VaSymbol *) (LocalTable-> table[i]); vs ; vs = (VaSymbol *) vs -> next)
	{
		char * inst;
		inst = vs -> var -> value -> text();
		assignment[j] = new char[strlen(vs -> name) + 1 + strlen(inst)];
		strcpy(assignment[j],vs -> name);
		strcpy(assignment[j]+strlen(vs -> name),"=");
		strcpy(assignment[j]+strlen(vs -> name)+1,inst);
		len += strlen(assignment[j++]);
	}
  }
  llt = new char [ strlen(TS -> name)  + len + LocalTable -> card + 3];
  strcpy(llt,TS->name);
  strcpy(llt + strlen(llt),".[");
  for(i=0;i<LocalTable -> card; i++)
  {
	strcpy(llt + strlen(llt),assignment[i]);
	strcpy(llt + strlen(llt),"|");
  }
  strcpy(llt + (strlen(llt) - 1), "]");
  }
  TrSymbol * TSI;
  if((!LocalTable) || LocalTable -> card == 0)
  {
	TSI = TS;
  }
  else
  {
  TSI = (TrSymbol *) TransitionTable -> lookup(llt);
  if(TSI) yyerror("transition instance already exists");
  TSI = new TrSymbol(llt);
  TSI -> vars = (SymbolTab *) 0;
  TSI -> guard = (UExpression *) 0;
  }
  T = TSI -> transition = new Transition(TSI -> name);
  /* 2. Inliste eintragen */
  /* HL-Boegen in LL-Boegen uebersetzen und zur Liste hinzufuegen */
  arc_list * root;
  root = yyvsp[-4].al;
  for(current = root;current; current = current -> next)
  {
	if(current -> mt)
	{
		// traverse multiterm
		arc_list * a;
		UTermList * mc;
		UValueList * vl;
		UValueList * vc;
		UValue * pv;
		pv = current -> place -> sort -> make();
		for(mc = current -> mt; mc ; mc = mc -> next)
		{	
			vl = mc -> t -> evaluate();

			for(vc = vl; vc; vc  = vc -> next)
			{
				char * inst;
				char * ll;
				pv -> assign(vc -> val);
				inst = pv -> text();
				ll = new char [strlen(current -> place -> name) + strlen(inst) + 2];
				strcpy(ll,current->place->name);
				strcpy(ll+strlen(current->place->name),".");
				strcpy(ll+strlen(current->place->name)+1,inst);
				PS = (PlSymbol *) PlaceTable -> lookup(ll);
				if(!ll) yyerror("place instance does not exist");
				if(PS -> sort) yyerror("arcs to HL places are not allowed");
				a = new arc_list;
				a -> place = PS;
				a -> mt = (UTermList *) 0;
				a -> nu =mc -> mult;
				a -> next = root;
				root = a;
			}
		}
	}
  }
  /* Anzahl der Boegen */
  for(card = 0, current = root;current;card++,current = current -> next);
  T->ArrivingArcs = new  Arc * [card];
  /* Schleife ueber alle Boegen */
  for(current = root;current;current = current -> next)
    {
	  /* Bogen ist nur HL-Bogen */
	  if(current -> place -> sort) continue;
      /* gibt es Bogen schon? */

      for(i = 0; i < T->NrOfArriving;i++)
	{
	  if(current->place -> place == T->ArrivingArcs[i]->pl)
	    {
	      /* Bogen existiert, nur Vielfachheit addieren */
	      *(T->ArrivingArcs[i]) += current->nu;
	      break;
	    }
	}
      if(i>=T->NrOfArriving)
	{
	  T->ArrivingArcs[T->NrOfArriving] = new Arc(T,current->place->place,true,current->nu);
	  T->NrOfArriving++;
	  current -> place -> place -> references ++;
	}
    }
  /* 2. Outliste eintragen */
  root = yyvsp[-1].al;
  for(current = root;current; current = current -> next)
  {
	if(current -> mt)
	{
		// traverse multiterm
		arc_list * a;
		UTermList * mc;
		UValueList * vl;
		UValueList * vc;
		UValue * pv;
		pv = current -> place -> sort -> make();
		for(mc = current -> mt; mc ; mc = mc -> next)
		{	
			vl = mc -> t -> evaluate();
			for(vc = vl; vc; vc  = vc -> next)
			{
				char * inst;
				char * ll;
				pv -> assign(vc -> val);
				inst = pv -> text();
				ll = new char [strlen(current -> place -> name) + strlen(inst) + 2];
				strcpy(ll,current->place->name);
				strcpy(ll+strlen(current->place->name),".");
				strcpy(ll+strlen(current->place->name)+1,inst);
				PS = (PlSymbol *) PlaceTable -> lookup(ll);
				if(!ll) yyerror("place instance does not exist");
				a = new arc_list;
				a -> place = PS;
				a -> mt = (UTermList *) 0;
				a -> nu =mc -> mult;
				a -> next = root;
				root = a;
			}
		}
	}
  }
  /* Anzahl der Boegen */
  for(card = 0, current = root;current;card++,current = current -> next);
  T->LeavingArcs = new  Arc * [card];
  /* Schleife ueber alle Boegen */
  for(current = root;current;current = current -> next)
    {
	  /* Bogen ist nur HL-Bogen */
	  if(current -> place -> sort) continue;
      /* gibt es Bogen schon? */

      for(i = 0; i < T->NrOfLeaving;i++)
	{
	  if(current->place -> place == T->LeavingArcs[i]->pl)
	    {
	      /* Bogen existiert, nur Vielfachheit addieren */
	      *(T->LeavingArcs[i]) += current->nu;
	      break;
	    }
	}
      if(i>=T->NrOfLeaving)
	{
	  T->LeavingArcs[T->NrOfLeaving] = new Arc(T,current->place -> place,false,current->nu);
	  T -> NrOfLeaving++;
	  current -> place -> place -> references ++;
	}
    }
	// B) switch to next assignment
nextass:
	if((!LocalTable) || LocalTable -> card == 0) break;
	unsigned int k;
	VaSymbol * vv;
	for(k=0;k < LocalTable -> size;k++)
	{
		for(vv = (VaSymbol *) (LocalTable-> table[k]); vv;vv = (VaSymbol *) (vv -> next))
		{
			(*(vv -> var -> value)) ++;
			if(!(vv -> var -> value -> isfirst()) ) break;
		}
		if(vv) break;
	}
	if(!vv) break;
	}
;
    break;}
case 146:
#line 1704 "readnet.y"
{LocalTable = new SymbolTab(256);;
    break;}
case 147:
#line 1705 "readnet.y"
{LocalTable = new SymbolTab(256);;
    break;}
case 148:
#line 1707 "readnet.y"
{ yyval.ex = (UExpression *) 0;
    break;}
case 149:
#line 1708 "readnet.y"
{if(yyvsp[0].ex -> type -> tag != boo) yyerror("guard expression must be boolean"); yyval.ex = yyvsp[0].ex;;
    break;}
case 150:
#line 1710 "readnet.y"
{ yyval.al = (arc_list *) 0;;
    break;}
case 151:
#line 1711 "readnet.y"
{yyval.al = yyvsp[0].al;;
    break;}
case 152:
#line 1712 "readnet.y"
{
      yyvsp[-2].al-> next = yyvsp[0].al;
	  yyval.al = yyvsp[-2].al;
    ;
    break;}
case 153:
#line 1717 "readnet.y"
{
      unsigned int i;
      PS = (PlSymbol *) PlaceTable -> lookup(yyvsp[-2].str);
      if(!PS)
	{
	  yyerror("place does not exist");
	}
	if(PS -> sort)
	{
		yyerror("arc expression of high level places must be term expressions");
	}
      yyval.al = new arc_list;
      yyval.al -> place = PS;
      yyval.al-> next = (arc_list *)  0;
      sscanf(yyvsp[0].str,"%u",&i);
      yyval.al -> nu = i;
	  yyval.al -> mt = (UTermList *) 0;
    ;
    break;}
case 154:
#line 1735 "readnet.y"
{
		UTermList * tl;
		PS = (PlSymbol *) PlaceTable -> lookup(yyvsp[-2].str);
		if(!PS)
		{
			yyerror("place does not exist");
		}
		if(!(PS -> sort))
		{
			yyerror("low level places require numerical multiplicity");
		}
		yyval.al = new arc_list;
		yyval.al -> place = PS; 
		yyval.al -> nu = 0;
		yyval.al -> mt = yyvsp[0].tlist;
		yyval.al -> next = (arc_list *) 0;
		for(tl = yyvsp[0].tlist; tl; tl = tl -> next)
		{
			if(!(PS -> sort -> iscompatible(tl -> t -> type)))
			{
				yyerror("type mismatch between place and arc expression");
			}
		}
	;
    break;}
case 155:
#line 1760 "readnet.y"
{ 
			yyval.ex = new UIntconstantExpression();
			sscanf(yyvsp[0].str,"%u",&(((UIntconstantExpression *) yyval.ex) -> nu));
			;
    break;}
case 156:
#line 1765 "readnet.y"
{
			if(yyvsp[-1].ex -> type -> tag != num)
			{
				yyerror("integer expression expected");
			}
			yyval.ex = yyvsp[-1].ex;
			;
    break;}
case 157:
#line 1773 "readnet.y"
{
#ifdef WITHFORMULA
					((hlatomicformula *) yyvsp[-2].form) -> k = yyvsp[0].ex;
					yyvsp[-2].form -> type = eq;
					yyval.form = yyvsp[-2].form;
#endif
				    ;
    break;}
case 158:
#line 1780 "readnet.y"
{
#ifdef WITHFORMULA
					((hlatomicformula *) yyvsp[-2].form) -> k = yyvsp[0].ex;
					yyvsp[-2].form -> type = neq;
					yyval.form = yyvsp[-2].form;
#endif
				  ;
    break;}
case 159:
#line 1787 "readnet.y"
{
#ifdef WITHFORMULA		   
					((hlatomicformula *) yyvsp[-2].form) -> k = yyvsp[0].ex;
					yyvsp[-2].form -> type = leq;
					yyval.form = yyvsp[-2].form;
#endif
				  ;
    break;}
case 160:
#line 1794 "readnet.y"
{
#ifdef WITHFORMULA
					((hlatomicformula *) yyvsp[-2].form) -> k = yyvsp[0].ex;
					yyvsp[-2].form -> type= geq;
					yyval.form = yyvsp[-2].form;
#endif
				    ;
    break;}
case 161:
#line 1801 "readnet.y"
{
#ifdef WITHFORMULA
					((hlatomicformula *) yyvsp[-2].form) -> k = yyvsp[0].ex;
					yyvsp[-2].form -> type = lt;
					yyval.form = yyvsp[-2].form;
#endif
				    ;
    break;}
case 162:
#line 1808 "readnet.y"
{
#ifdef WITHFORMULA    
					((hlatomicformula *) yyvsp[-2].form) -> k = yyvsp[0].ex;
					yyvsp[-2].form -> type = gt;
					yyval.form = yyvsp[-2].form;
#endif 	
	                            ;
    break;}
case 163:
#line 1815 "readnet.y"
{
#ifdef WITHFORMULA
					   yyval.form = new binarybooleanformula(conj,yyvsp[-2].form,yyvsp[0].form);
#endif
                                           ;
    break;}
case 164:
#line 1820 "readnet.y"
{
#ifdef WITHFORMULA
			                   yyval.form = new binarybooleanformula(disj,yyvsp[-2].form,yyvsp[0].form);
#endif
                                          ;
    break;}
case 165:
#line 1825 "readnet.y"
{
#ifdef WITHFORMULA
                                        yyval.form = new unarybooleanformula(neg,yyvsp[0].form);
#endif
                                 ;
    break;}
case 166:
#line 1830 "readnet.y"
{
#ifdef WITHFORMULA
				if(yyvsp[-1].ex -> type -> tag != boo)
				{	
					yyerror("formula requires boolean expression");
				}
				yyval.form = new staticformula(yyvsp[-1].ex);
#endif
					   ;
    break;}
case 167:
#line 1839 "readnet.y"
{
#ifdef WITHFORMULA
		yyvsp[-2].varsy -> name[0] = '\0';
		yyval.form = new quantifiedformula(qe,yyvsp[-2].varsy->var,yyvsp[0].form);
#endif
		;
    break;}
case 168:
#line 1845 "readnet.y"
{
#ifdef WITHFORMULA
		yyvsp[-2].varsy -> name[0] = '\0';
		yyval.form = new quantifiedformula(qa,yyvsp[-2].varsy->var,yyvsp[0].form);
#endif
		;
    break;}
case 169:
#line 1851 "readnet.y"
{
#ifdef WITHFORMULA
                                     yyval.form = yyvsp[-1].form;
#endif
                                    ;
    break;}
case 170:
#line 1856 "readnet.y"
{
#ifdef WITHFORMULA
                                  yyval.form = new untilformula(eu,yyvsp[-3].form,yyvsp[-1].form,(transitionformula *) yyvsp[-5].form);
#endif
                                                              ;
    break;}
case 171:
#line 1861 "readnet.y"
{
#ifdef WITHFORMULA
                             yyval.form = new untilformula(au,yyvsp[-3].form,yyvsp[-1].form,(transitionformula *) yyvsp[-5].form);
#endif
                                                              ;
    break;}
case 172:
#line 1866 "readnet.y"
{
#ifdef WITHFORMULA
                           yyval.form = new unarytemporalformula(eg,yyvsp[0].form,(transitionformula *) yyvsp[-2].form);
#endif
                                           ;
    break;}
case 173:
#line 1871 "readnet.y"
{
#ifdef WITHFORMULA
                                yyval.form = new unarytemporalformula(ag,yyvsp[0].form,(transitionformula *) yyvsp[-2].form);
#endif
                                           ;
    break;}
case 174:
#line 1876 "readnet.y"
{
#ifdef WITHFORMULA
                                      yyval.form = new unarytemporalformula(ex,yyvsp[0].form,(transitionformula *) yyvsp[-2].form);
#endif
                                         ;
    break;}
case 175:
#line 1881 "readnet.y"
{
#ifdef WITHFORMULA
				yyval.form = new unarytemporalformula(ax,yyvsp[0].form,(transitionformula *) yyvsp[-2].form);
#endif
                                        ;
    break;}
case 176:
#line 1886 "readnet.y"
{
#ifdef WITHFORMULA
                                      yyval.form = new unarytemporalformula(ef,yyvsp[0].form,(transitionformula *) yyvsp[-2].form);
#endif
                                         ;
    break;}
case 177:
#line 1891 "readnet.y"
{
#ifdef WITHFORMULA
				yyval.form = new unarytemporalformula(af,yyvsp[0].form,(transitionformula *) yyvsp[-2].form);
#endif
                                        ;
    break;}
case 178:
#line 1897 "readnet.y"
{
#ifdef WITHFORMULA
				    PS = (PlSymbol *) PlaceTable -> lookup(yyvsp[0].str);
                    if(!PS) yyerror("Place does not exist");
					if(PS -> sort) yyerror("HL places require instance");
					yyval.form = new hlatomicformula(neq,PS,(UExpression *) 0);
#endif
				  ;
    break;}
case 179:
#line 1905 "readnet.y"
{
#ifdef WITHFORMULA
				    PS = (PlSymbol *) PlaceTable -> lookup(yyvsp[-4].str);
                    if(!PS) yyerror("Place does not exist");
                    if(!(PS-> sort)) yyerror("LL places do not require instance");
					if(!(PS -> sort ->iscompatible(yyvsp[-1].ex -> type)))
					{
						yyerror("place color incompatible to place sort");
					}
					yyval.form = new hlatomicformula(neq,PS,yyvsp[-1].ex);
#endif
				;
    break;}
case 180:
#line 1918 "readnet.y"
{
		UVar * vv;
		VS = (VaSymbol *) LocalTable -> lookup(yyvsp[-2].str);
		if(VS) yyerror("variable used twice in formula");
		vv = new UVar(yyvsp[0].t);
		yyval.varsy = new VaSymbol(yyvsp[-2].str,vv);
	;
    break;}
case 181:
#line 1925 "readnet.y"
{ yyval.form = (transitionformula *) 0;;
    break;}
case 182:
#line 1926 "readnet.y"
{ yyval.form = yyvsp[0].form;;
    break;}
case 183:
#line 1928 "readnet.y"
{
#ifdef WITHFORMULA
					yyvsp[-2].varsy -> name[0] = '\0';
					yyval.form = new quantifiedformula(qe,yyvsp[-2].varsy -> var,yyvsp[0].form);
#endif
					;
    break;}
case 184:
#line 1934 "readnet.y"
{
#ifdef WITHFORMULA
					yyvsp[-2].varsy -> name[0] = '\0';
					yyval.form = new quantifiedformula(qa,yyvsp[-2].varsy -> var,yyvsp[0].form);
#endif
					;
    break;}
case 185:
#line 1940 "readnet.y"
{
#ifdef WITHFORMULA
						yyval.form = new binarybooleanformula(conj, yyvsp[-2].form, yyvsp[0].form);
#endif
					;
    break;}
case 186:
#line 1945 "readnet.y"
{
#ifdef WITHFORMULA
						yyval.form = new binarybooleanformula(disj, yyvsp[-2].form, yyvsp[0].form);
#endif
					;
    break;}
case 187:
#line 1950 "readnet.y"
{
#ifdef WITHFORMULA
						yyval.form = new unarybooleanformula(neg,yyvsp[0].form);
#endif
					;
    break;}
case 188:
#line 1955 "readnet.y"
{yyval.form = yyvsp[-1].form;;
    break;}
case 189:
#line 1956 "readnet.y"
{
#ifdef WITHFORMULA
					if(yyvsp[0].ts->vars && yyvsp[0].ts -> vars -> card)
					{
						yyerror("HL transition requires firing mode");
					}
					yyval.form = new transitionformula(yyvsp[0].ts -> transition);
#endif
				;
    break;}
case 190:
#line 1965 "readnet.y"
{
#ifdef WITHFORMULA
					if((! yyvsp[-4].ts -> vars) || (yyvsp[-4].ts -> vars -> card == 0))
					{
						yyerror("LL transition does not require firing mode");
					}
					yyval.form = new transitionformula(yyvsp[-4].ts,yyvsp[-1].fm);
#endif
				;
    break;}
case 191:
#line 1975 "readnet.y"
{
					TS = (TrSymbol *) TransitionTable -> lookup(yyvsp[0].str);
					if(!TS) yyerror("transition does not exist");
					yyval.ts = TS;
				;
    break;}
case 192:
#line 1981 "readnet.y"
{ yyval.fm = yyvsp[0].fm;;
    break;}
case 193:
#line 1982 "readnet.y"
{
					yyvsp[-2].fm -> next = yyvsp[0].fm;
					yyval.fm = yyvsp[-2].fm;
				;
    break;}
case 194:
#line 1987 "readnet.y"
{
			VS = (VaSymbol *) (TS -> vars -> lookup(yyvsp[-2].str));
			if(!VS) yyerror("no such transition variable");
			if(! (VS -> var -> type -> iscompatible(yyvsp[0].ex -> type)))
			{
				yyerror("variable binding incompatible with variable type");
			}
			yyval.fm = new fmode;
			yyval.fm -> v = VS;
			yyval.fm -> t = yyvsp[0].ex ;
			yyval.fm -> next = (fmode *) 0;
		;
    break;}
}
   /* the action file gets copied in in place of this dollarsign */
#line 543 "//usr/lib/bison.simple"

  yyvsp -= yylen;
  yyssp -= yylen;
#ifdef YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;

#ifdef YYLSP_NEEDED
  yylsp++;
  if (yylen == 0)
    {
      yylsp->first_line = yylloc.first_line;
      yylsp->first_column = yylloc.first_column;
      yylsp->last_line = (yylsp-1)->last_line;
      yylsp->last_column = (yylsp-1)->last_column;
      yylsp->text = 0;
    }
  else
    {
      yylsp->last_line = (yylsp+yylen-1)->last_line;
      yylsp->last_column = (yylsp+yylen-1)->last_column;
    }
#endif

  /* Now "shift" the result of the reduction.
     Determine what state that goes to,
     based on the state we popped back to
     and the rule number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;

yyerrlab:   /* here on detecting error */

  if (! yyerrstatus)
    /* If not already recovering from an error, report this error.  */
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  int size = 0;
	  char *msg;
	  int x, count;

	  count = 0;
	  /* Start X at -yyn if nec to avoid negative indexes in yycheck.  */
	  for (x = (yyn < 0 ? -yyn : 0);
	       x < (sizeof(yytname) / sizeof(char *)); x++)
	    if (yycheck[x + yyn] == x)
	      size += strlen(yytname[x]) + 15, count++;
	  msg = (char *) malloc(size + 15);
	  if (msg != 0)
	    {
	      strcpy(msg, "parse error");

	      if (count < 5)
		{
		  count = 0;
		  for (x = (yyn < 0 ? -yyn : 0);
		       x < (sizeof(yytname) / sizeof(char *)); x++)
		    if (yycheck[x + yyn] == x)
		      {
			strcat(msg, count == 0 ? ", expecting `" : " or `");
			strcat(msg, yytname[x]);
			strcat(msg, "'");
			count++;
		      }
		}
	      yyerror(msg);
	      free(msg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exceeded");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror("parse error");
    }

  goto yyerrlab1;
yyerrlab1:   /* here on error raised explicitly by an action */

  if (yyerrstatus == 3)
    {
      /* if just tried and failed to reuse lookahead token after an error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Discarding token %d (%s).\n", yychar, yytname[yychar1]);
#endif

      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token
     after shifting the error token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;

yyerrdefault:  /* current state does not do anything special for the error token. */

#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */
  yyn = yydefact[yystate];  /* If its default is to accept any token, ok.  Otherwise pop it.*/
  if (yyn) goto yydefault;
#endif

yyerrpop:   /* pop the current state because it cannot handle the error token */

  if (yyssp == yyss) YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#ifdef YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "Error: state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

yyerrhandle:

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting error token, ");
#endif

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;

 yyacceptlab:
  /* YYACCEPT comes here.  */
  if (yyfree_stacks)
    {
      free (yyss);
      free (yyvs);
#ifdef YYLSP_NEEDED
      free (yyls);
#endif
    }
  return 0;

 yyabortlab:
  /* YYABORT comes here.  */
  if (yyfree_stacks)
    {
      free (yyss);
      free (yyvs);
#ifdef YYLSP_NEEDED
      free (yyls);
#endif
    }
  return 1;
}
#line 2001 "readnet.y"



char * diagnosefilename;


void readnet()
{
	yydebug = 0;
	diagnosefilename = (char *) 0;
	if(netfile)
	{
		yyin = fopen(netfile,"r");
		if(!yyin)
		{
			cerr << "cannot open netfile: " << netfile << "\n";
			exit(4);
		}
		diagnosefilename = netfile;
	}
	GlobalTable = new SymbolTab(1024);
	TheBooType = new UBooType();
	TheNumType = new UNumType(0,INT_MAX);
	yyparse();
#ifdef WITHFORMULA
	  F = F -> replacequantifiers();
	  F -> tempcard = 0;
	  F = F -> merge();
#if (defined(MODELCHECKING) && defined(EXTENDED))
	unsigned int i;
	for(i=0;i< Transitions[0]->cnt;i++)
	{
		Transitions[i] -> lstfired = new unsigned int [F -> tempcard];
		Transitions[i] -> lstdisabled = new unsigned int [F -> tempcard];
	}
#endif
#endif
}

bool taskfile = false;

int yywrap()
{
	yylineno = 1;
	if(taskfile) return 1;
	if(!analysefile) return 1;
	taskfile = true;
	yyin = fopen(analysefile,"r");
	if(!yyin)
	{
		cerr << "cannot open analysis task file: " << analysefile << "\n";
		exit(4);
	}
	diagnosefilename = analysefile;
	return(0);
}

void yyerror(char * mess)
{
        printf("syntaxerror at line %d of file %s:  %s\n",yylineno, diagnosefilename,mess);
		exit(3);
}

