#! /usr/bin/env python
import sys
import re
import math
import commands
import copy

#################
#Read input file#
#################
def greedy_min_sum_topi(matrix_file):
	f=open(matrix_file, 'r')
	
	N=int(f.readline()) #the number of rows that one can shuffle
	M=int(f.readline()) #the number of columns
	Sis=[[i+1,[]] for i in range(N)]
	
	matchLevel = re.compile('(\d+) :')
	matchEvents = re.compile(' (\d+)')
	
	#Read line by line
	while 1 :
		line=f.readline()
		if not line: #End of file
			break
		level = matchLevel.match(line) # Find the number of the level
		events=matchEvents.findall(line)
		for event in events:
			Sis[int(level.group(1))-1][1].append(int(event)) 
	f.close()
	
	###############################
	#End of the input file reading#
	###############################
	
	#make a copy of the Sis object
	
	Sistemp = copy.deepcopy(Sis)
	
	
	def difference(a,b):
		len_a=len(a)
		len_b=len(b)
		counter_a=0
		current_index_a=0
		counter_b=0
		while counter_a<len_a and counter_b<len_b:
			if a[current_index_a]==b[counter_b]:
				del a[current_index_a]
				counter_b=counter_b+1
				counter_a=counter_a+1
			elif a[current_index_a]< b[counter_b]:
				counter_a=counter_a+1
				current_index_a=current_index_a+1
			else:
				counter_b=counter_b+1
	
	def minimal_index(matrix,len_matrix):
		min_index=-1
		min_row=1000000 #a sufficiently large number
		counter=0
		while counter < len_matrix:
			if len(matrix[counter][1])<min_row:
				min_index=counter
				min_row=len(matrix[counter][1])
			counter=counter+1
		return min_index
	
	
	#place the matrix by using the greedy method
	counter = N
	print N  ,' iterations'
	while counter > 1:
		min_index = minimal_index(Sis,counter)
		row = Sis.pop(min_index)
		Sis.append(row)
		counter_1=0
		while counter_1<counter-1:
			difference(Sis[counter_1][1],Sis[-1][1])
			counter_1=counter_1 + 1
		counter=counter-1
	
	row = Sis.pop(0)
	Sis.append(row)
	
	Sis.reverse()
	
	
	#for the purpose of calculating the old score
	counter = N
	while counter > 1:
		counter_1=0
		while counter_1<counter-1:
			difference(Sistemp[counter_1][1],Sistemp[counter - 1][1])
			counter_1 = counter_1 + 1
		counter = counter - 1
	
	
	#calculate the score and verify that no mistakes were made
	counter=1
	score_new=0
	total_1_new=0
	score_old=0
	total_1_old=0
	while counter <= N:
		score_new = score_new + counter * (len(Sis[counter-1][1]))
		score_old = score_old + counter * (len(Sistemp[counter-1][1]))
		total_1_new=total_1_new + len(Sis[counter-1][1])
		total_1_old=total_1_old + len(Sistemp[counter-1][1])
		counter = counter + 1
	
	
	#print out the results
	
	print 'Score:' 
	print score_new
	
	print 'Original score:' 
	print score_old
	
		
	
	finalorder=[]
	for row in Sis:
		print row
		finalorder.append(int(row[0])-1)
	
	return finalorder
	####################
	#Writes output file#
	####################
#	f=open(sys.argv[2],'w')
#	f.write("%i\n"%len(finalorder))
#	for i in finalorder:
#		f.write("%i\n"%(int(i)))
#	
#	
#	f.close()
