#! /usr/bin/env python
import sys
import re
import math
import commands
import random
#################
#Read input file#
#################
f=open(sys.argv[1], 'r')

N=int(f.readline())
M=int(f.readline())
Sis=[[] for i in range(M)]

matchLevel = re.compile('(\d+) :')
matchEvents = re.compile(' (\d+)')

#Read line by line
while 1 :
	line=f.readline()
	if not line: #End of file
		break
	level = matchLevel.match(line) # Find the number of the level
	events=matchEvents.findall(line)
	for event in events:
		Sis[int(event)-1].append(int(level.group(1))-1) 
f.close()
###############################
#End of the input file reading#
###############################

#Compute the cost
def score(temp_orderi):
	temp_order=[-1 for i in range(N)]
	for i in range(len(temp_orderi)):
		temp_order[temp_orderi[i]]=i
	NewSis=[[] for i in range(M)]
	cost=0
	for i in range(0,len(Sis)):
		for j in Sis[i]:
			if(temp_order[j]!=-1):
				NewSis[i].append(temp_order[j])
	for i in NewSis:
			if len(i)>0:
				cost+=max(max(i)-min(i)+1,0)
	return cost









def swap(i,j,ordering):
	temp=ordering[i]
	ordering[i]=ordering[j]
	ordering[j]=temp

order=[[i,0] for i in range(0,N)]
for i in range(0,M):
	for j in Sis[i]:
		order[j][1]+=1
order=[[i,0] for i in range(0,N)]
for i in range(0,M):
	for j in Sis[i]:
		order[j][1]+=1

def sort_columns(x, y):
	return y[1]-x[1]

random.shuffle(order)
order.sort(sort_columns)



deforder=[order[i][0] for i in range(N)]

rating= score(deforder)
order=deforder
change = 1

#deforder=random.shuffle(deforder)



while(change):
	change=0
	for i in range(0,N):
		for j in range(i+1,N):

			temporder=order[0:i]
			temporder=temporder+order[i+1:j+1]
			temporder=temporder+order[i:i+1]
			temporder=temporder + order[j+1:]

			scoretemp=score(temporder)

			if scoretemp<rating:
				rating=scoretemp
				order=temporder[:]
				change=1

		for j in range(i+1,N):
			temporder=order[:]

			swap(i,j,temporder)
			scoretemp=score(temporder)
			if scoretemp<rating:
				order=temporder[:]
				rating=scoretemp
				change=1

										


print "Score:"
print(score(order))
print "Original score:"
print score([i for i in range(N)])
####################
#Writes output file#
####################
f=open(sys.argv[2],'w')
f.write("%i\n"%len(order))
for i in order:
	f.write("%i\n"%(int(i)+1))


f.close()

############################
#End of output file writing#
############################






	

