/***************************************************************************
*
* Copyright (c) 1989 -- 2000
* by Helsinki University of Technology, Digital Systems Laboratory,
* a.k.a. Laboratory for Theoretical Computer Science.
* All rights reserved.
*
* This software is provided "as is" without express or implied warranty.
*
* Module:  prepctl.c
*
* Part of: PROD's program probe
*
* Authors: Keijo Heljanko
*
* Current version:
*     $Id: prepctl.h,v 3.1 1997/04/17 15:44:05 kepa Exp $
*
* Description:
*     This module implements the preprocessing of the aws file
*     to a form better suited for CTL model-checking. The files
*     created end in .caw and .cad .
*
* Version history:
*     $Log: prepctl.h,v $
 * Revision 3.1  1997/04/17  15:44:05  kepa
 * *** empty log message ***
 *
***************************************************************************/

DE1(BOOL, PrepareCTL,
    GRAPH *, graph)
DE1(BOOL, AwsPrepareCTL,
    GRAPH *, graph)
DE2(BOOL, EvalAtomicFormulas,
    GRAPH *, graph,
    LIST *, formulas)
DE1(VOID *, GetFile,
    char *, fileName)
DE1(long, GetFileLen,
    char *, fileName)
