#include "yypltl.h"

/*  A Bison parser, made from ltl.y with Bison version GNU Bison version 1.22
  */

#define YYBISON 1  /* Identify Bison output.  */

#define	T_LPAR	258
#define	T_RPAR	259
#define	T_LBRACK	260
#define	T_RBRACK	261
#define	T_LMARK	262
#define	T_RMARK	263
#define	T_D_PERCENT	264
#define	T_EMPTY	265
#define	T_CARD	266
#define	T_FIELD	267
#define	T_STRING	268
#define	T_NUMBER	269
#define	T_EOL	270
#define	T_UNTIL	271
#define	T_UNLESS	272
#define	T_OR	273
#define	T_IMPLIES	274
#define	T_AND	275
#define	T_NOT	276
#define	T_EVENTUALLY	277
#define	T_HENCEFORTH	278
#define	T_COMMA	279
#define	T_D_PERIOD	280
#define	T_QUEST	281
#define	T_COLON	282
#define	T_D_BAR	283
#define	T_D_ET	284
#define	T_BAR	285
#define	T_CARET	286
#define	T_ET	287
#define	T_EQ	288
#define	T_NE	289
#define	T_LT	290
#define	T_LE	291
#define	T_GT	292
#define	T_GE	293
#define	T_RSHIFT	294
#define	T_LSHIFT	295
#define	T_PLUS	296
#define	T_MINUS	297
#define	T_ASTERISK	298
#define	T_SLASH	299
#define	T_PERCENT	300
#define	T_EXCL	301
#define	T_TILDE	302



/***************************************************************************
*
* Copyright (c) 1989 -- 2000
* by Helsinki University of Technology, Digital Systems Laboratory,
* a.k.a. Laboratory for Theoretical Computer Science.
* All rights reserved.
*
* This software is provided "as is" without express or implied warranty.
*
* Module:  ltl.y
*
* Part of: PROD's program prpp
*
* Author: Kimmo Varpaaniemi
*
* Current version:
*     $Id$
*
* Description:
*     .
*
* Version history:
*     $Log$
***************************************************************************/

/***************************************************************************
*
* Static variable rcsid is not used anywhere in the code. The only reason
* for rcsid is the Revision Control System (RCS). RCS fills the template
* string with the latest revision information. C compiler puts the
* resulting literal string into the object file, and linker puts it into
* the executable file. It is then possible to check the revision
* information of the object or executable file. (There is a little
* problem. An optimizing compiler or linker may eliminate the unused
* static variable.)
*
****************************************************************************
*/
#ifdef RCS
static char rcsid[] = "$Id$";
#endif

#include "dynam.h"
#include "ppio.h"
#include "token.h"
#include "output.h"
#include "place.h"
#include "prpp.h"
#include "lexer.h"
#include "macro.h"
#include "util.h"
#include "ptrbl.h"
#include "baltree.h"
#include "gphutil.h"
#include "mark.h"
#include "encode.h"
#include "expr.h"
#include "net.h"
#include "prec.h"
#include "pplst.h"
#include "prpexpr.h"
#include "ltl.h"

#define ForImplies(f1,f2) ForXua(FO_IMPLIES, f1, f2)
#define ForNot(f) ForImplies(f, (FORMULA *) NULL)
#define ForOr(f1,f2) ForImplies(ForNot(f1), f2)
#define ForAnd(f1,f2) ForNot(ForImplies(f1, ForNot(f2)))
#define ForUntil(f1,f2) ForXua(FO_UNTIL, f1, f2)
#define ForEventually(f) ForUntil(ForNot((FORMULA *) NULL), f)
#define ForHenceforth(f) ForNot(ForEventually(ForNot(f)))
#define ForUnless(f1,f2) \
ForImplies(ForEventually(ForNot(f1)), ForUntil(f1, f2))

extern int yylex();
extern char *yytext;
unsigned ltlPlc;
static PLACE *pl;
static unsigned ind;
static PP_TOKEN *ppToken;
static VOID *cursor;

typedef struct RET
{
    BOOL isFrm;
    union
	{
	    FORMULA *frm;
	    MARKING *mk;
	} ur;
} RET;

static RET ret;

#ifndef YYLTYPE
typedef
  struct yyltype
    {
      int timestamp;
      int first_line;
      int first_column;
      int last_line;
      int last_column;
      char *text;
   }
  yyltype;

#define YYLTYPE yyltype
#endif



#ifndef __cplusplus
#ifndef PROTOZOA
#define const
#endif
#endif



#define	YYFINAL		140
#define	YYFLAG		-32768
#define	YYNTBASE	48

#define YYTRANSLATE(x) ((unsigned)(x) <= 302 ? yytranslate[x] : 56)

static const char yytranslate[] = {     0,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     1,     2,     3,     4,     5,
     6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
    16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
    26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
    36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
    46,    47
};

#if YYDEBUG != 0
static const short yyprhs[] = {     0,
     0,     2,     4,     7,    10,    12,    14,    17,    20,    23,
    27,    31,    35,    39,    43,    47,    51,    55,    59,    63,
    67,    71,    75,    79,    83,    87,    91,    95,   101,   105,
   109,   113,   117,   121,   125,   127,   132,   136,   141,   143,
   145,   149,   153,   157,   161,   165,   168,   170,   172,   174,
   178,   181,   185,   187,   191,   193,   197,   201,   203,   206,
   210,   214,   218,   221,   224,   228,   232
};

static const short yyrhs[] = {     1,
     0,    15,     0,    51,    15,     0,    55,    15,     0,     1,
     0,    50,     0,    42,    49,     0,    46,    49,     0,    47,
    49,     0,    49,    43,    49,     0,    49,    44,    49,     0,
    49,    45,    49,     0,    49,    41,    49,     0,    49,    42,
    49,     0,    49,    39,    49,     0,    49,    40,    49,     0,
    49,    35,    49,     0,    49,    36,    49,     0,    49,    37,
    49,     0,    49,    38,    49,     0,    49,    33,    49,     0,
    49,    34,    49,     0,    49,    32,    49,     0,    49,    31,
    49,     0,    49,    30,    49,     0,    49,    29,    49,     0,
    49,    28,    49,     0,    49,    26,    49,    27,    49,     0,
    51,    35,    51,     0,    51,    36,    51,     0,    51,    37,
    51,     0,    51,    38,    51,     0,    51,    33,    51,     0,
    51,    34,    51,     0,     1,     0,    11,     3,    51,     4,
     0,     3,    49,     4,     0,    12,     5,    49,     6,     0,
    14,     0,    52,     0,    51,    43,    51,     0,    51,    32,
    51,     0,    51,    41,    51,     0,    51,    42,    51,     0,
    52,    27,    50,     0,    50,    52,     0,     1,     0,    13,
     0,    10,     0,     7,    53,     8,     0,     7,     8,     0,
     3,    51,     4,     0,    54,     0,    53,    24,    54,     0,
    49,     0,    49,    25,    49,     0,     3,    54,     4,     0,
    49,     0,    21,    55,     0,    55,    20,    55,     0,    55,
    18,    55,     0,    55,    19,    55,     0,    22,    55,     0,
    23,    55,     0,    55,    16,    55,     0,    55,    17,    55,
     0,     3,    55,     4,     0
};

#endif

#if YYDEBUG != 0
static const short yyrline[] = { 0,
   138,   153,   157,   166,   178,   192,   195,   200,   205,   210,
   215,   220,   225,   230,   235,   240,   245,   250,   255,   260,
   265,   270,   275,   280,   285,   290,   295,   300,   303,   309,
   315,   321,   327,   333,   341,   355,   361,   364,   370,   378,
   381,   385,   389,   393,   397,   402,   409,   423,   465,   472,
   477,   482,   487,   501,   519,   526,   529,   534,   539,   542,
   545,   548,   551,   554,   557,   560,   563
};

static const char * const yytname[] = {   "$","error","$illegal.","T_LPAR","T_RPAR",
"T_LBRACK","T_RBRACK","T_LMARK","T_RMARK","T_D_PERCENT","T_EMPTY","T_CARD","T_FIELD",
"T_STRING","T_NUMBER","T_EOL","T_UNTIL","T_UNLESS","T_OR","T_IMPLIES","T_AND",
"T_NOT","T_EVENTUALLY","T_HENCEFORTH","T_COMMA","T_D_PERIOD","T_QUEST","T_COLON",
"T_D_BAR","T_D_ET","T_BAR","T_CARET","T_ET","T_EQ","T_NE","T_LT","T_LE","T_GT",
"T_GE","T_RSHIFT","T_LSHIFT","T_PLUS","T_MINUS","T_ASTERISK","T_SLASH","T_PERCENT",
"T_EXCL","T_TILDE","line","expression","easyexpression","marking","easy_marking",
"rangelist","range","formula",""
};
#endif

static const short yyr1[] = {     0,
    48,    48,    48,    48,    49,    49,    49,    49,    49,    49,
    49,    49,    49,    49,    49,    49,    49,    49,    49,    49,
    49,    49,    49,    49,    49,    49,    49,    49,    49,    49,
    49,    49,    49,    49,    50,    50,    50,    50,    50,    51,
    51,    51,    51,    51,    51,    51,    52,    52,    52,    52,
    52,    52,    53,    53,    54,    54,    54,    55,    55,    55,
    55,    55,    55,    55,    55,    55,    55
};

static const short yyr2[] = {     0,
     1,     1,     2,     2,     1,     1,     2,     2,     2,     3,
     3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
     3,     3,     3,     3,     3,     3,     3,     5,     3,     3,
     3,     3,     3,     3,     1,     4,     3,     4,     1,     1,
     3,     3,     3,     3,     3,     2,     1,     1,     1,     3,
     2,     3,     1,     3,     1,     3,     3,     1,     2,     3,
     3,     3,     2,     2,     3,     3,     3
};

static const short yydefact[] = {     0,
     5,     0,     0,    49,     0,     0,    48,    39,     2,     0,
     0,     0,     0,     0,     0,    58,     0,     0,    40,     0,
     5,    58,     0,     0,     0,    51,    55,     0,     0,    53,
     0,     0,    59,    63,    64,     0,     7,     8,     9,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,    47,     0,
    46,     3,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     4,     0,     0,     0,     0,     0,    37,
    52,    67,     0,     0,     0,    50,     0,    47,     0,     0,
     0,     0,     0,    27,    26,    25,    24,    23,    21,    22,
    17,    18,    19,    20,    15,    16,    13,    14,    10,    11,
    12,     0,    42,    33,    34,    29,    30,    31,    32,    43,
    44,    41,    35,     0,    45,    65,    66,    61,    62,    60,
    57,    56,    54,    36,    38,     0,    28,     0,     0,     0
};

static const short yydefgoto[] = {   138,
    16,    17,    28,    19,    29,    30,    20
};

static const short yypact[] = {   114,
   357,   141,   164,-32768,    11,    -1,-32768,-32768,-32768,   141,
   141,   141,    66,    66,    66,   400,   226,   340,    -5,   549,
   358,   288,   162,     1,   179,-32768,   360,   502,     7,-32768,
   206,    66,-32768,-32768,-32768,    66,-32768,-32768,-32768,    66,
    66,    66,    66,    66,    66,    66,    66,    66,    66,    66,
    66,    66,    66,    66,    66,    66,    66,    66,-32768,   206,
-32768,-32768,   206,   206,   206,   206,   206,   206,   206,   206,
   206,   206,   129,-32768,   141,   141,   141,   141,   141,-32768,
-32768,-32768,   268,    28,    66,-32768,   179,   358,   520,    77,
   309,   288,   380,   417,   433,   448,   462,   475,   511,   511,
   518,   518,   518,   518,   -35,   -35,   -16,   -16,-32768,-32768,
-32768,   127,   -10,    16,    16,    16,    16,    16,    16,   -10,
   -10,-32768,-32768,    66,-32768,    43,    43,    44,    44,-32768,
-32768,   400,-32768,-32768,-32768,    66,   400,    36,    68,-32768
};

static const short yypgoto[] = {-32768,
    -2,   216,    35,   -15,-32768,   -22,    14
};


#define	YYLAST		569


static const short yytable[] = {    22,
    27,    61,    84,    32,    82,    54,    55,    56,    57,    58,
    37,    38,    39,    31,    86,    24,    75,    76,    77,    78,
    79,    73,    83,    33,    34,    35,    56,    57,    58,    91,
    87,   131,    72,    92,    18,   139,    23,    93,    94,    95,
    96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
   106,   107,   108,   109,   110,   111,    70,    71,    72,    23,
    77,    78,    79,    79,   133,    90,    21,   140,    36,     0,
    23,     0,     3,    61,     0,     4,     5,     6,     7,     8,
   134,     0,   132,     0,    27,     0,     0,     0,   126,   127,
   128,   129,   130,     0,   112,     0,     0,   113,   114,   115,
   116,   117,   118,   119,   120,   121,   122,    13,    63,     0,
     0,    14,    15,     0,     1,     0,     2,    70,    71,    72,
     3,    92,     0,     4,     5,     6,     7,     8,     9,   123,
    81,   124,     0,   137,    10,    11,    12,     0,     0,     5,
     6,    21,     8,     2,     0,     0,     0,     3,     0,     0,
     4,     5,     6,     7,     8,    13,     0,     0,    63,    14,
    15,    10,    11,    12,    21,    81,    25,    70,    71,    72,
     3,    26,     0,     4,     5,     6,     7,     8,     0,    21,
     0,    25,    13,     0,     0,     3,    14,    15,     4,     5,
     6,     7,     8,    63,    64,    65,    66,    67,    68,    69,
     0,     0,    70,    71,    72,    13,    88,     0,    36,    14,
    15,     0,     3,     0,     0,     4,     5,     6,     7,     8,
    13,     0,     0,     0,    14,    15,    59,     0,    60,    -6,
     0,    -6,     3,    -6,     0,     4,     0,     0,     7,     0,
    -6,    -6,    -6,    -6,    -6,    -6,    89,     0,     0,    -6,
    -6,    -6,    -6,    -6,    -6,    -6,    -6,    -6,    -6,    -6,
    -6,    -6,    -6,    -6,    -6,    -6,    -6,    -6,    -6,    -6,
    -6,    80,     0,     0,     0,    89,     0,     0,    89,    89,
    89,    89,    89,    89,    89,    89,    89,    89,   125,     0,
     0,    80,    85,    40,     0,    41,    42,    43,    44,    45,
    46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
    56,    57,    58,    40,   135,    41,    42,    43,    44,    45,
    46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
    56,    57,    58,     0,    40,     0,    41,    42,    43,    44,
    45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
    55,    56,    57,    58,    62,     0,    -1,   -35,   -35,   -35,
   -35,     0,     0,   -35,   -35,     0,   -35,   -35,     0,   -35,
   -35,    63,    64,    65,    66,    67,    68,    69,     0,     0,
    70,    71,    72,   -47,    85,    40,     0,    41,    42,    43,
    44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
    54,    55,    56,    57,    58,    40,   136,    41,    42,    43,
    44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
    54,    55,    56,    57,    58,    40,     0,    41,    42,    43,
    44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
    54,    55,    56,    57,    58,    42,    43,    44,    45,    46,
    47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
    57,    58,    43,    44,    45,    46,    47,    48,    49,    50,
    51,    52,    53,    54,    55,    56,    57,    58,    44,    45,
    46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
    56,    57,    58,    45,    46,    47,    48,    49,    50,    51,
    52,    53,    54,    55,    56,    57,    58,    46,    47,    48,
    49,    50,    51,    52,    53,    54,    55,    56,    57,    58,
    59,     0,    60,     0,     0,     0,     3,     0,     0,     4,
     0,     0,     7,    63,    64,    65,    66,    67,    68,    69,
     0,     0,    70,    71,    72,    48,    49,    50,    51,    52,
    53,    54,    55,    56,    57,    58,    52,    53,    54,    55,
    56,    57,    58,    74,    75,    76,    77,    78,    79
};

static const short yycheck[] = {     2,
     3,    17,    25,     5,     4,    41,    42,    43,    44,    45,
    13,    14,    15,     3,     8,     2,    16,    17,    18,    19,
    20,    27,    25,    10,    11,    12,    43,    44,    45,    32,
    24,     4,    43,    36,     0,     0,     2,    40,    41,    42,
    43,    44,    45,    46,    47,    48,    49,    50,    51,    52,
    53,    54,    55,    56,    57,    58,    41,    42,    43,    25,
    18,    19,    20,    20,    87,    31,     1,     0,     3,    -1,
    36,    -1,     7,    89,    -1,    10,    11,    12,    13,    14,
     4,    -1,    85,    -1,    87,    -1,    -1,    -1,    75,    76,
    77,    78,    79,    -1,    60,    -1,    -1,    63,    64,    65,
    66,    67,    68,    69,    70,    71,    72,    42,    32,    -1,
    -1,    46,    47,    -1,     1,    -1,     3,    41,    42,    43,
     7,   124,    -1,    10,    11,    12,    13,    14,    15,     1,
     4,     3,    -1,   136,    21,    22,    23,    -1,    -1,    11,
    12,     1,    14,     3,    -1,    -1,    -1,     7,    -1,    -1,
    10,    11,    12,    13,    14,    42,    -1,    -1,    32,    46,
    47,    21,    22,    23,     1,     4,     3,    41,    42,    43,
     7,     8,    -1,    10,    11,    12,    13,    14,    -1,     1,
    -1,     3,    42,    -1,    -1,     7,    46,    47,    10,    11,
    12,    13,    14,    32,    33,    34,    35,    36,    37,    38,
    -1,    -1,    41,    42,    43,    42,     1,    -1,     3,    46,
    47,    -1,     7,    -1,    -1,    10,    11,    12,    13,    14,
    42,    -1,    -1,    -1,    46,    47,     1,    -1,     3,     4,
    -1,     6,     7,     8,    -1,    10,    -1,    -1,    13,    -1,
    15,    16,    17,    18,    19,    20,    31,    -1,    -1,    24,
    25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
    35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
    45,     4,    -1,    -1,    -1,    60,    -1,    -1,    63,    64,
    65,    66,    67,    68,    69,    70,    71,    72,    73,    -1,
    -1,     4,    25,    26,    -1,    28,    29,    30,    31,    32,
    33,    34,    35,    36,    37,    38,    39,    40,    41,    42,
    43,    44,    45,    26,     6,    28,    29,    30,    31,    32,
    33,    34,    35,    36,    37,    38,    39,    40,    41,    42,
    43,    44,    45,    -1,    26,    -1,    28,    29,    30,    31,
    32,    33,    34,    35,    36,    37,    38,    39,    40,    41,
    42,    43,    44,    45,    15,    -1,     0,     1,     1,     3,
     3,    -1,    -1,     7,     7,    -1,    10,    10,    -1,    13,
    13,    32,    33,    34,    35,    36,    37,    38,    -1,    -1,
    41,    42,    43,    27,    25,    26,    -1,    28,    29,    30,
    31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
    41,    42,    43,    44,    45,    26,    27,    28,    29,    30,
    31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
    41,    42,    43,    44,    45,    26,    -1,    28,    29,    30,
    31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
    41,    42,    43,    44,    45,    29,    30,    31,    32,    33,
    34,    35,    36,    37,    38,    39,    40,    41,    42,    43,
    44,    45,    30,    31,    32,    33,    34,    35,    36,    37,
    38,    39,    40,    41,    42,    43,    44,    45,    31,    32,
    33,    34,    35,    36,    37,    38,    39,    40,    41,    42,
    43,    44,    45,    32,    33,    34,    35,    36,    37,    38,
    39,    40,    41,    42,    43,    44,    45,    33,    34,    35,
    36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
     1,    -1,     3,    -1,    -1,    -1,     7,    -1,    -1,    10,
    -1,    -1,    13,    32,    33,    34,    35,    36,    37,    38,
    -1,    -1,    41,    42,    43,    35,    36,    37,    38,    39,
    40,    41,    42,    43,    44,    45,    39,    40,    41,    42,
    43,    44,    45,    15,    16,    17,    18,    19,    20
};
/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */


/* Skeleton output parser for bison,
   Copyright (C) 1984, 1989, 1990 Bob Corbett and Richard Stallman

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 1, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */


#ifndef alloca
#ifdef __GNUC__
#define alloca __builtin_alloca
#else /* not GNU C.  */
#if (!defined (PROTOZOA) && defined (sparc)) || defined (__sparc__) || defined (__sparc) || defined (__sgi)

#else /* not sparc */
#if defined (MSDOS) && !defined (__TURBOC__)

#else /* not MSDOS, or __TURBOC__ */
#if defined(_AIX)

 #pragma alloca
#else /* not MSDOS, __TURBOC__, or _AIX */
#ifdef __hpux
#ifdef __cplusplus
extern "C" {
VOID *alloca (unsigned int);
};
#else /* not __cplusplus */
VOID *alloca ();
#endif /* not __cplusplus */
#endif /* __hpux */
#endif /* not _AIX */
#endif /* not MSDOS, or __TURBOC__ */
#endif /* not sparc.  */
#endif /* not GNU C.  */
#endif /* alloca not defined.  */

/* This is the parser code that is written into each bison parser
  when the %semantic_parser declaration is not specified in the grammar.
  It was written by Richard Stallman by simplifying the hairy parser
  used when %semantic_parser is specified.  */

/* Note: there must be only one dollar sign in this file.
   It is replaced by the list of actions, each action
   as one case of the switch.  */

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	return(0)
#define YYABORT 	return(1)
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.
   This remains here temporarily to ease the
   transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(token, value) \
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    { yychar = (token), yylval = (value);			\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { yyerror ("syntax error: cannot back up"); YYERROR; }	\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

#ifndef YYPURE
#define YYLEX		yylex()
#endif

#ifdef YYPURE
#ifdef YYLSP_NEEDED
#define YYLEX		yylex(&yylval, &yylloc)
#else
#define YYLEX		yylex(&yylval)
#endif
#endif

/* If nonreentrant, generate the variables here */

#ifndef YYPURE

int	yychar;			/*  the lookahead symbol		*/
YYSTYPE	yylval;			/*  the semantic value of the		*/
				/*  lookahead symbol			*/

#ifdef YYLSP_NEEDED
YYLTYPE yylloc;			/*  location data for the lookahead	*/
				/*  symbol				*/
#endif

int yynerrs;			/*  number of parse errors so far       */
#endif  /* not YYPURE */

#if YYDEBUG != 0
int yydebug;			/*  nonzero means print parse trace	*/
/* Since this is uninitialized, it does not stop multiple parsers
   from coexisting.  */
#endif

/*  YYINITDEPTH indicates the initial size of the parser's stacks	*/

#ifndef	YYINITDEPTH
#define YYINITDEPTH 200
#endif

/*  YYMAXDEPTH is the maximum size the stacks can grow to
    (effective only if the built-in stack extension method is used).  */

#if YYMAXDEPTH == 0
#undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
#define YYMAXDEPTH 10000
#endif

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
int yyparse (void);
#endif

#if __GNUC__ > 1		/* GNU C and GNU C++ define this.  */
#define __yy_bcopy(FROM,TO,COUNT)	__builtin_memcpy(TO,FROM,COUNT)
#else				/* not GNU C or C++ */
#ifndef __cplusplus

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_bcopy (from, to, count)
     char *from;
     char *to;
     int count;
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#else /* __cplusplus */

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_bcopy (char *from, char *to, int count)
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#endif
#endif


int
yyparse()
{
  register int yystate;
  register int yyn;
  register short *yyssp;
  register YYSTYPE *yyvsp;
  int yyerrstatus;	/*  number of tokens to shift before error messages enabled */
  int yychar1 = 0;		/*  lookahead token as an internal (translated) token number */

  short	yyssa[YYINITDEPTH];	/*  the state stack			*/
  YYSTYPE yyvsa[YYINITDEPTH];	/*  the semantic value stack		*/

  short *yyss = yyssa;		/*  refer to the stacks thru separate pointers */
  YYSTYPE *yyvs = yyvsa;	/*  to allow yyoverflow to reallocate them elsewhere */

#ifdef YYLSP_NEEDED
  YYLTYPE yylsa[YYINITDEPTH];	/*  the location stack			*/
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;

#define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else
#define YYPOPSTACK   (yyvsp--, yyssp--)
#endif

  int yystacksize = YYINITDEPTH;

#ifdef YYPURE
  int yychar;
  YYSTYPE yylval;
  int yynerrs;
#ifdef YYLSP_NEEDED
  YYLTYPE yylloc;
#endif
#endif

  YYSTYPE yyval;		/*  the variable used to return		*/
				/*  semantic values from the action	*/
				/*  routines				*/

  int yylen;

#if YYDEBUG != 0
  if (yydebug)
    (void) fprintf(stderr, "Starting parse\n");
#endif

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss - 1;
  yyvsp = yyvs;
#ifdef YYLSP_NEEDED
  yylsp = yyls;
#endif

/* Push a new state, which is found in  yystate  .  */
/* In all cases, when you get here, the value and location stacks
   have just been pushed. so pushing a state here evens the stacks.  */
yynewstate:

  *++yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Give user a chance to reallocate the stack */
      /* Use copies of these so that the &'s don't force the real ones into memory. */
      YYSTYPE *yyvs1 = yyvs;
      short *yyss1 = yyss;
#ifdef YYLSP_NEEDED
      YYLTYPE *yyls1 = yyls;
#endif

      /* Get the current used size of the three stacks, in elements.  */
      int size = (int) (yyssp - yyss + 1);

#ifdef yyoverflow
      /* Each stack pointer address is followed by the size of
	 the data in use in that stack, in bytes.  */
#ifdef YYLSP_NEEDED
      /* This used to be a conditional around just the two extra args,
	 but that might be undefined if yyoverflow is a macro.  */
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yyls1, size * sizeof (*yylsp),
		 &yystacksize);
#else
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yystacksize);
#endif

      yyss = yyss1; yyvs = yyvs1;
#ifdef YYLSP_NEEDED
      yyls = yyls1;
#endif
#else /* no yyoverflow */
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	{
	  yyerror("parser stack overflow");
	  return 2;
	}
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;
      yyss = (short *) alloca (yystacksize * sizeof (*yyssp));
      __yy_bcopy ((char *)yyss1, (char *)yyss, size * sizeof (*yyssp));
      yyvs = (YYSTYPE *) alloca (yystacksize * sizeof (*yyvsp));
      __yy_bcopy ((char *)yyvs1, (char *)yyvs, size * sizeof (*yyvsp));
#ifdef YYLSP_NEEDED
      yyls = (YYLTYPE *) alloca (yystacksize * sizeof (*yylsp));
      __yy_bcopy ((char *)yyls1, (char *)yyls, size * sizeof (*yylsp));
#endif
#endif /* no yyoverflow */

      yyssp = yyss + size - 1;
      yyvsp = yyvs + size - 1;
#ifdef YYLSP_NEEDED
      yylsp = yyls + size - 1;
#endif

#if YYDEBUG != 0
      if (yydebug)
	(void) fprintf(stderr, "Stack size increased to %d\n", yystacksize);
#endif

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

#if YYDEBUG != 0
  if (yydebug)
    (void) fprintf(stderr, "Entering state %d\n", yystate);
#endif

  goto yybackup;
 yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
#if YYDEBUG != 0
      if (yydebug)
	(void) fprintf(stderr, "Reading a token: ");
#endif
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

#if YYDEBUG != 0
      if (yydebug)
	(void) fprintf(stderr, "Now at end of input.\n");
#endif
    }
  else
    {
      yychar1 = YYTRANSLATE(yychar);

#if YYDEBUG != 0
      if (yydebug)
	{
	  (void) fprintf (stderr, "Next token is %d (%s", yychar, yytname[yychar1]);
	  /* Give the individual parser a way to print the precise meaning
	     of a token, for further debugging info.  */
#ifdef YYPRINT
	  YYPRINT (stderr, yychar, yylval);
#endif
	  (void) fprintf (stderr, ")\n");
	}
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */

#if YYDEBUG != 0
  if (yydebug)
    (void) fprintf(stderr, "Shifting token %d (%s), ", yychar, yytname[yychar1]);
#endif

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* count tokens shifted since error; after three, turn off error status.  */
  if (yyerrstatus) yyerrstatus--;

  yystate = yyn;
  goto yynewstate;

/* Do the default action for the current state.  */
yydefault:

  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;

/* Do a reduction.  yyn is the number of a rule to reduce with.  */
yyreduce:
  yylen = yyr2[yyn];
  if (yylen > 0)
    yyval = yyvsp[1-yylen]; /* implement default value of the action */

#if YYDEBUG != 0
  if (yydebug)
    {
      int i;

      (void) fprintf (stderr, "Reducing via rule %d (line %d), ",
	       yyn, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (i = yyprhs[yyn]; yyrhs[i] > 0; i++)
	(void) fprintf (stderr, "%s ", yytname[yyrhs[i]]);
      (void) fprintf (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif


  switch (yyn) {

case 1:

{ if (errorFlag == NO_ERROR)
                              {
				  (void) fprintf(_err,
						 "Error in formula:\n");
				  (void) fflush(_err);
				  PrpCaret(ltlPlc,
					   (unsigned) strlen(yytext));
				  errorFlag = CML_ERROR;
			      }
			  ret.isFrm = FALSE;
			  ret.ur.mk = NULL;
			  yyclearin;
			;
    break;}
case 2:

{ ret.isFrm = FALSE;
			  ret.ur.mk = NULL; ;
    break;}
case 3:

{ ret.isFrm = FALSE;
			  if (errorFlag != NO_ERROR)
			      ret.ur.mk = NULL;
			  else
			      ret.ur.mk = MexEval(yyvsp[-1].mep);
			  if (yyvsp[-1].mep)
			      MexDiscard(yyvsp[-1].mep); ;
    break;}
case 4:

{ ret.isFrm = TRUE;
                          if (errorFlag != NO_ERROR)
			      {
				  ret.ur.frm = NULL;
				  ForDracsid(yyvsp[-1].fp);
			      }
			  else
			      ret.ur.frm = yyvsp[-1].fp; ;
    break;}
case 5:

{ if (errorFlag == NO_ERROR)
                              {
				  (void) fprintf(_err,
						 "Error in expression:\n");
				  (void) fflush(_err);
				  PrpCaret(ltlPlc,
					   (unsigned) strlen(yytext));
				  errorFlag = XPR_ERROR;
			      }
			  yyval.ep = NULL;
			  yyclearin;
			;
    break;}
case 6:

{ yyval.ep = yyvsp[0].ep; ;
    break;}
case 7:

{ yyval.ep = XprAux(EO_NEG, yyvsp[0].ep, (EXPRESSION *) NULL,
					  (EXPRESSION *) NULL, 0L);
                        ;
    break;}
case 8:

{ yyval.ep = XprAux(EO_NOT, yyvsp[0].ep, (EXPRESSION *) NULL,
					  (EXPRESSION *) NULL, 0L);
                        ;
    break;}
case 9:

{ yyval.ep = XprAux(EO_BNOT, yyvsp[0].ep, (EXPRESSION *) NULL,
					  (EXPRESSION *) NULL, 0L);
                        ;
    break;}
case 10:

{ yyval.ep = XprAux(EO_TIMES, yyvsp[-2].ep, yyvsp[0].ep,
					  (EXPRESSION *) NULL, 0L);
                        ;
    break;}
case 11:

{ yyval.ep = XprAux(EO_DIV, yyvsp[-2].ep, yyvsp[0].ep,
					  (EXPRESSION *) NULL, 0L);
                        ;
    break;}
case 12:

{ yyval.ep = XprAux(EO_REM, yyvsp[-2].ep, yyvsp[0].ep,
					  (EXPRESSION *) NULL, 0L);
                        ;
    break;}
case 13:

{ yyval.ep = XprAux(EO_PLUS, yyvsp[-2].ep, yyvsp[0].ep,
					  (EXPRESSION *) NULL, 0L);
                        ;
    break;}
case 14:

{ yyval.ep = XprAux(EO_MINUS, yyvsp[-2].ep, yyvsp[0].ep,
					  (EXPRESSION *) NULL, 0L);
                        ;
    break;}
case 15:

{ yyval.ep = XprAux(EO_RSHIFT, yyvsp[-2].ep, yyvsp[0].ep,
					  (EXPRESSION *) NULL, 0L);
                        ;
    break;}
case 16:

{ yyval.ep = XprAux(EO_LSHIFT, yyvsp[-2].ep, yyvsp[0].ep,
					  (EXPRESSION *) NULL, 0L);
                        ;
    break;}
case 17:

{ yyval.ep = XprAux(EO_LESS, yyvsp[-2].ep, yyvsp[0].ep,
					  (EXPRESSION *) NULL, 0L);
                        ;
    break;}
case 18:

{ yyval.ep = XprAux(EO_LEQUAL, yyvsp[-2].ep, yyvsp[0].ep,
					  (EXPRESSION *) NULL, 0L);
                        ;
    break;}
case 19:

{ yyval.ep = XprAux(EO_LESS, yyvsp[0].ep, yyvsp[-2].ep,
					  (EXPRESSION *) NULL, 0L);
                        ;
    break;}
case 20:

{ yyval.ep = XprAux(EO_LEQUAL, yyvsp[0].ep, yyvsp[-2].ep,
					  (EXPRESSION *) NULL, 0L);
                        ;
    break;}
case 21:

{ yyval.ep = XprAux(EO_EQUAL, yyvsp[-2].ep, yyvsp[0].ep,
					  (EXPRESSION *) NULL, 0L);
                        ;
    break;}
case 22:

{ yyval.ep = XprAux(EO_NEQUAL, yyvsp[-2].ep, yyvsp[0].ep,
					  (EXPRESSION *) NULL, 0L);
                        ;
    break;}
case 23:

{ yyval.ep = XprAux(EO_BAND, yyvsp[-2].ep, yyvsp[0].ep,
					  (EXPRESSION *) NULL, 0L);
                        ;
    break;}
case 24:

{ yyval.ep = XprAux(EO_BXOR, yyvsp[-2].ep, yyvsp[0].ep,
					  (EXPRESSION *) NULL, 0L);
                        ;
    break;}
case 25:

{ yyval.ep = XprAux(EO_BOR, yyvsp[-2].ep, yyvsp[0].ep,
					  (EXPRESSION *) NULL, 0L);
                        ;
    break;}
case 26:

{ yyval.ep = XprAux(EO_AND, yyvsp[-2].ep, yyvsp[0].ep,
					  (EXPRESSION *) NULL, 0L);
                        ;
    break;}
case 27:

{ yyval.ep = XprAux(EO_OR, yyvsp[-2].ep, yyvsp[0].ep,
					  (EXPRESSION *) NULL, 0L);
                        ;
    break;}
case 28:

{ yyval.ep = XprAux(EO_IF, yyvsp[-4].ep, yyvsp[-2].ep, yyvsp[0].ep, 0L); ;
    break;}
case 29:

{ yyval.ep = XprAux(EO_MLESS, (EXPRESSION *) yyvsp[-2].mep,
					  (EXPRESSION *) yyvsp[0].mep,
					  (EXPRESSION *) NULL, 0L);
                        ;
    break;}
case 30:

{ yyval.ep = XprAux(EO_MLEQUAL, (EXPRESSION *) yyvsp[-2].mep,
					  (EXPRESSION *) yyvsp[0].mep,
					  (EXPRESSION *) NULL, 0L);
                        ;
    break;}
case 31:

{ yyval.ep = XprAux(EO_MLESS, (EXPRESSION *) yyvsp[0].mep,
					  (EXPRESSION *) yyvsp[-2].mep,
					  (EXPRESSION *) NULL, 0L);
                        ;
    break;}
case 32:

{ yyval.ep = XprAux(EO_MLEQUAL, (EXPRESSION *) yyvsp[0].mep,
					  (EXPRESSION *) yyvsp[-2].mep,
					  (EXPRESSION *) NULL, 0L);
                        ;
    break;}
case 33:

{ yyval.ep = XprAux(EO_MEQUAL, (EXPRESSION *) yyvsp[-2].mep,
					  (EXPRESSION *) yyvsp[0].mep,
					  (EXPRESSION *) NULL, 0L);
                        ;
    break;}
case 34:

{ yyval.ep = XprAux(EO_MNEQUAL, (EXPRESSION *) yyvsp[-2].mep,
					  (EXPRESSION *) yyvsp[0].mep,
					  (EXPRESSION *) NULL, 0L);
                        ;
    break;}
case 35:

{ if (errorFlag == NO_ERROR)
                              {
				  (void) fprintf(_err,
						 "Error in expression:\n");
				  (void) fflush(_err);
				  PrpCaret(ltlPlc,
					   (unsigned) strlen(yytext));
				  errorFlag = XPR_ERROR;
			      }
			  yyval.ep = NULL;
			  yyclearin;
			;
    break;}
case 36:

{ yyval.ep = XprAux(EO_CARD, (EXPRESSION *) yyvsp[-1].mep,
					  (EXPRESSION *) NULL,
					  (EXPRESSION *) NULL, 0L);
                        ;
    break;}
case 37:

{ yyval.ep = yyvsp[-1].ep; ;
    break;}
case 38:

{ yyval.ep = XprAux(EO_FIELD, yyvsp[-1].ep,
					  (EXPRESSION *) NULL,
					  (EXPRESSION *) NULL, 0L);
                        ;
    break;}
case 39:

{ yyval.ep = XprAux(EO_DOM, (EXPRESSION *) NULL,
					  (EXPRESSION *) NULL,
					  (EXPRESSION *) NULL, yyvsp[0].dv);
                        ;
    break;}
case 40:

{ yyval.mep = yyvsp[0].mep; ;
    break;}
case 41:

{ yyval.mep = MexAux(MO_CARTES, yyvsp[-2].mep, yyvsp[0].mep,
					   (unsigned) 0); ;
    break;}
case 42:

{ yyval.mep = MexAux(MO_INTERS, yyvsp[-2].mep, yyvsp[0].mep,
					   (unsigned) 0); ;
    break;}
case 43:

{ yyval.mep = MexAux(MO_SUM, yyvsp[-2].mep, yyvsp[0].mep,
					   (unsigned) 0); ;
    break;}
case 44:

{ yyval.mep = MexAux(MO_DIFF, yyvsp[-2].mep, yyvsp[0].mep,
					   (unsigned) 0); ;
    break;}
case 45:

{ yyval.mep = MexAux(MO_SELECT, (MARKEXPR *) yyvsp[0].ep,
					   yyvsp[-2].mep, (unsigned) 0);
                        ;
    break;}
case 46:

{ yyval.mep = MexAux(MO_TIMES, (MARKEXPR *) yyvsp[-1].ep,
					   yyvsp[0].mep, (unsigned) 0);
                        ;
    break;}
case 47:

{ if (errorFlag == NO_ERROR)
                              {
				  (void) fprintf(_err, 
						 "Error in marking expression:\n");
				  (void) fflush(_err);
				  PrpCaret(ltlPlc,
					   (unsigned) strlen(yytext));
				  errorFlag = MEX_ERROR;
			      }
			  yyval.mep = NULL;
                          yyclearin;
			;
    break;}
case 48:

{ if (errorFlag == NO_ERROR)
			      {
				  ind = 0;
				  cursor = LstGet(prpExpList);
				  ppToken = (PP_TOKEN *) LstBegin(prpExpList);
				  while (TRUE)
				      {
					  ind += (unsigned)
					      strlen(ppToken->token);
					  if (ind > yyvsp[0].token.start)
					      break;
					  ppToken = (PP_TOKEN *)
					      LstStep(prpExpList);
				      }
				  LstSet(prpExpList, cursor);
				  LSTNUM (PlaceLst, pl, PLACE, ind)
				      if(!strcmp(ppToken->token, PlaGName(pl)))
					  break;
				  if (pl)
				      yyval.mep = MexAux(MO_PLACE,
						       (MARKEXPR *) NULL,
						       (MARKEXPR *) NULL,
						       ind);
				  else
				      {
					  (void) sprintf(errStr,
							 "Place %s not defined",
							 ppToken->token);
					  error(errStr);
					  PrpCaret(yyvsp[0].token.start
						   + yyvsp[0].token.length,
						   yyvsp[0].token.length);
					  errorFlag = MEX_ERROR;
					  yyval.mep = NULL;
				      }
			      }
                          else
                              yyval.mep = NULL;
                        ;
    break;}
case 49:

{ yyval.mep = MexAux(MO_CONSTANT,
					   (MARKEXPR *) MarCreate(),
					   (MARKEXPR *) NULL, (unsigned) 0);
                        ;
    break;}
case 50:

{ yyval.mep = MexAux(MO_TRANGE, (MARKEXPR *) yyvsp[-1].trp,
					   (MARKEXPR *) NULL, (unsigned) 0);
                        ;
    break;}
case 51:

{ yyval.mep = MexAux(MO_TRANGE, (MARKEXPR *) TrgCreate(),
					   (MARKEXPR *) NULL, (unsigned) 0);
                        ;
    break;}
case 52:

{ yyval.mep = yyvsp[-1].mep; ;
    break;}
case 53:

{ if (errorFlag == NO_ERROR)
			      {
				  yyval.trp = TrgCreate();
				  TrgInsert(yyval.trp, yyvsp[0].xrp);
			      }
                          else
                              {
				  yyval.trp = NULL;
				  if (yyvsp[0].xrp != NULL)
				      XrgDiscard(yyvsp[0].xrp);
			      }
                        ;
    break;}
case 54:

{ if (errorFlag == NO_ERROR)
			      {
				  yyval.trp = yyvsp[-2].trp;
				  TrgInsert(yyval.trp, yyvsp[0].xrp);
			      }
                          else
                              {
				  yyval.trp = NULL;
				  if (yyvsp[-2].trp != NULL)
				      TrgDiscard(yyvsp[-2].trp);
				  if (yyvsp[0].xrp != NULL)
				      XrgDiscard(yyvsp[0].xrp);
			      }
                        ;
    break;}
case 55:

{ if (yyvsp[0].ep)
			      yyval.xrp = XrgAux(yyvsp[0].ep, XprCopy(yyvsp[0].ep));
			  else
			      yyval.xrp = NULL;
		        ;
    break;}
case 56:

{ yyval.xrp = XrgAux(yyvsp[-2].ep, yyvsp[0].ep); ;
    break;}
case 57:

{ yyval.xrp = yyvsp[-1].xrp; ;
    break;}
case 58:

{ yyval.fp = ForXua(FO_EXPR, (FORMULA *) yyvsp[0].ep,
					  (FORMULA *) NULL);
                        ;
    break;}
case 59:

{ yyval.fp = ForNot(yyvsp[0].fp); ;
    break;}
case 60:

{ yyval.fp = ForAnd(yyvsp[-2].fp, yyvsp[0].fp); ;
    break;}
case 61:

{ yyval.fp = ForOr(yyvsp[-2].fp, yyvsp[0].fp); ;
    break;}
case 62:

{ yyval.fp = ForImplies(yyvsp[-2].fp, yyvsp[0].fp); ;
    break;}
case 63:

{ yyval.fp = ForEventually(yyvsp[0].fp); ;
    break;}
case 64:

{ yyval.fp = ForHenceforth(yyvsp[0].fp); ;
    break;}
case 65:

{ yyval.fp = ForUntil(yyvsp[-2].fp, yyvsp[0].fp); ;
    break;}
case 66:

{ yyval.fp = ForUnless(yyvsp[-2].fp, yyvsp[0].fp); ;
    break;}
case 67:

{ yyval.fp = yyvsp[-1].fp; ;
    break;}
}
   /* the action file gets copied in in place of this dollarsign */


  yyvsp -= yylen;
  yyssp -= yylen;
#ifdef YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      (void) fprintf (stderr, "state stack now");
      while (ssp1 != yyssp)
	(void) fprintf (stderr, " %d", *++ssp1);
      (void) fprintf (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;

#ifdef YYLSP_NEEDED
  yylsp++;
  if (yylen == 0)
    {
      yylsp->first_line = yylloc.first_line;
      yylsp->first_column = yylloc.first_column;
      yylsp->last_line = (yylsp-1)->last_line;
      yylsp->last_column = (yylsp-1)->last_column;
      yylsp->text = 0;
    }
  else
    {
      yylsp->last_line = (yylsp+yylen-1)->last_line;
      yylsp->last_column = (yylsp+yylen-1)->last_column;
    }
#endif

  /* Now "shift" the result of the reduction.
     Determine what state that goes to,
     based on the state we popped back to
     and the rule number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;

yyerrlab:   /* here on detecting error */

  if (! yyerrstatus)
    /* If not already recovering from an error, report this error.  */
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  int size = 0;
	  char *msg;
	  int x, count;

	  count = 0;
	  /* Start X at -yyn if nec to avoid negative indexes in yycheck.  */
	  for (x = (yyn < 0 ? -yyn : 0);
	       x < (sizeof(yytname) / sizeof(char *)); x++)
	    if (yycheck[x + yyn] == x)
	      size += strlen(yytname[x]) + 15, count++;
	  msg = (char *) malloc(size + 15);
	  if (msg != 0)
	    {
	      strcpy(msg, "parse error");

	      if (count < 5)
		{
		  count = 0;
		  for (x = (yyn < 0 ? -yyn : 0);
		       x < (sizeof(yytname) / sizeof(char *)); x++)
		    if (yycheck[x + yyn] == x)
		      {
			strcat(msg, count == 0 ? ", expecting `" : " or `");
			strcat(msg, yytname[x]);
			strcat(msg, "'");
			count++;
		      }
		}
	      yyerror(msg);
	      free(msg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exceeded");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror("parse error");
    }

  goto yyerrlab1;
yyerrlab1:   /* here on error raised explicitly by an action */

  if (yyerrstatus == 3)
    {
      /* if just tried and failed to reuse lookahead token after an error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;

#if YYDEBUG != 0
      if (yydebug)
	(void) fprintf(stderr, "Discarding token %d (%s).\n", yychar, yytname[yychar1]);
#endif

      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token
     after shifting the error token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;

yyerrdefault:  /* current state does not do anything special for the error token. */

#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */
  yyn = yydefact[yystate];  /* If its default is to accept any token, ok.  Otherwise pop it.*/
  if (yyn) goto yydefault;
#endif

yyerrpop:   /* pop the current state because it cannot handle the error token */

  if (yyssp == yyss) YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#ifdef YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      (void) fprintf (stderr, "Error: state stack now");
      while (ssp1 != yyssp)
	(void) fprintf (stderr, " %d", *++ssp1);
      (void) fprintf (stderr, "\n");
    }
#endif

yyerrhandle:

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

#if YYDEBUG != 0
  if (yydebug)
    (void) fprintf(stderr, "Shifting error token, ");
#endif

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;
}



/***************************************************************************
*
* Function:  LtlParse
* Purpose:
* Arguments: formula - 
*            value - 
*            marking - 
* Returns:
* See also:
*
****************************************************************************
*/
FE3(void, LtlParse,
    FORMULA **, formula,
    DOMAIN *, value,
    MARKING **, marking)
{
    ltlPlc = 0;
    ret.isFrm = FALSE;
    ret.ur.mk = NULL;
    (void) ltl_yyparse();
    if (errorFlag != NO_ERROR)
	return;
    if (formula || value)
	{
	    if (!(ret.isFrm))
		{
		    (void) sprintf(errStr,
				   "Expected %s, got %s",
				   formula
				   ? "formula" : "integer-valued expression",
				   ret.ur.mk ? "marking" : "nothing");
		    error(errStr);
		    if (formula)
			errorFlag = FOR_ERROR;
		    else
			errorFlag = XPR_ERROR;
		    if (ret.ur.mk)
			MarDiscard(ret.ur.mk);
		    return;
		}
	    if (value)
		{
		    if ((!(ret.ur.frm)) ||
			(ret.ur.frm->operator != FO_EXPR))
			{
			    error("Expected integer-valued expression, got formula");
			    ForDracsid(ret.ur.frm);
			    errorFlag = XPR_ERROR;
			    return;
			}
		    *value = XprEval(ret.ur.frm->uf.expression);
		    ForDracsid(ret.ur.frm);
		    return;
		}
	    *formula = ret.ur.frm;
	    return;
	}
    if (ret.isFrm)
	{
	    error("Expected marking, got formula");
	    ForDracsid(ret.ur.frm);
	    errorFlag = MEX_ERROR;
	    return;
	}
    if (ret.ur.mk)
	*marking = ret.ur.mk;
    else
	*marking = MarCreate();
}
