#include "yyprules.h"

/*  A Bison parser, made from rules.y with Bison version GNU Bison version 1.22
  */

#define YYBISON 1  /* Identify Bison output.  */

#define	T_DEFINE	258
#define	T_DEFS	259
#define	T_HELP	260
#define	T_LOAD	261
#define	T_UNDEF	262
#define	T_UNDEF_ALL	263
#define	T_LPAR	264
#define	T_RPAR	265
#define	T_LBRACK	266
#define	T_RBRACK	267
#define	T_LMARK	268
#define	T_RMARK	269
#define	T_D_PERCENT	270
#define	T_AT	271
#define	T_EF	272
#define	T_EG	273
#define	T_EMPTY	274
#define	T_EU	275
#define	T_EX	276
#define	T_CARD	277
#define	T_TRUE	278
#define	T_FALSE	279
#define	T_FIELD	280
#define	T_STRING	281
#define	T_VARNAME	282
#define	T_PRECLASS	283
#define	T_FAITHFUL	284
#define	T_NUMBER	285
#define	T_PREV	286
#define	T_CALC	287
#define	T_CHECK	288
#define	T_CLEAR	289
#define	T_CLEARALL	290
#define	T_TERMCOMPS	291
#define	T_AF	292
#define	T_AG	293
#define	T_ALLCOMPS	294
#define	T_ALL	295
#define	T_AU	296
#define	T_AX	297
#define	T_GOTO	298
#define	T_LOOK	299
#define	T_PRED	300
#define	T_PREDS	301
#define	T_QUERY	302
#define	T_QUIT	303
#define	T_SHOWENDS	304
#define	T_SHRINK	305
#define	T_STATISTICS	306
#define	T_NEXT	307
#define	T_SUCC	308
#define	T_SUCCS	309
#define	T_ARROW	310
#define	T_SGSUCC	311
#define	T_SGPRED	312
#define	T_MUTE	313
#define	T_VERBOSE	314
#define	T_SUPERVERBOSE	315
#define	T_VOLATILE	316
#define	T_SETS	317
#define	T_BUILD	318
#define	T_PERIOD	319
#define	T_EOL	320
#define	T_USE_REDIRECT	321
#define	T_OR	322
#define	T_AND	323
#define	T_NOT	324
#define	T_NODE	325
#define	T_STEP	326
#define	T_FIRE	327
#define	T_BPATH	328
#define	T_DPATH	329
#define	T_BSPAN	330
#define	T_DSPAN	331
#define	T_COMMA	332
#define	T_D_PERIOD	333
#define	T_QUEST	334
#define	T_COLON	335
#define	T_D_BAR	336
#define	T_D_ET	337
#define	T_BAR	338
#define	T_CARET	339
#define	T_ET	340
#define	T_EQ	341
#define	T_NE	342
#define	T_LT	343
#define	T_LE	344
#define	T_GT	345
#define	T_GE	346
#define	T_RSHIFT	347
#define	T_LSHIFT	348
#define	T_PLUS	349
#define	T_MINUS	350
#define	T_ASTERISK	351
#define	T_SLASH	352
#define	T_PERCENT	353
#define	T_EXCL	354
#define	T_TILDE	355



/***************************************************************************
*
* Copyright (c) 1989 -- 2000
* by Helsinki University of Technology, Digital Systems Laboratory,
* a.k.a. Laboratory for Theoretical Computer Science.
* All rights reserved.
*
* This software is provided "as is" without express or implied warranty.
*
* Module:  rules.y
*
* Part of: PROD's program probe
*
* Authors: Keijo Heljanko, Tomi Janhunen, Kimmo Valkealahti,
*          and Kimmo Varpaaniemi
*
* Current version:
*     $Id$
*
* Description:
*     .
*
* Version history:
*     $Log$
***************************************************************************/

/***************************************************************************
*
* Static variable rcsid is not used anywhere in the code. The only reason
* for rcsid is the Revision Control System (RCS). RCS fills the template
* string with the latest revision information. C compiler puts the
* resulting literal string into the object file, and linker puts it into
* the executable file. It is then possible to check the revision
* information of the object or executable file. (There is a little
* problem. An optimizing compiler or linker may eliminate the unused
* static variable.)
*
****************************************************************************
*/
#ifdef RCS
static char rcsid[] = "$Id$";
#endif

#include "dynam.h"
#include "ptrbl.h"
#include "baltree.h"
#include "bdd.h"
#include "gphutil.h"
#include "graph.h"
#include "mark.h"
#include "encode.h"
#include "expr.h"
#include "formula.h"
#include "mbufs.h"
#include "macptree.h"
#include "comline.h"
#include "probe.h"
#include "rules.h"

extern int yylex();
extern char *yytext;
unsigned rulesPlc;
BOOL inFiringClass;
static char *str;
static REF *ref;
static unsigned transition;
static COMLINE *ret;
static REDIRECT redirect;

#ifndef YYLTYPE
typedef
  struct yyltype
    {
      int timestamp;
      int first_line;
      int first_column;
      int last_line;
      int last_column;
      char *text;
   }
  yyltype;

#define YYLTYPE yyltype
#endif



#ifndef __cplusplus
#ifndef PROTOZOA
#define const
#endif
#endif



#define	YYFINAL		375
#define	YYFLAG		-32768
#define	YYNTBASE	101

#define YYTRANSLATE(x) ((unsigned)(x) <= 355 ? yytranslate[x] : 121)

static const char yytranslate[] = {     0,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     1,     2,     3,     4,     5,
     6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
    16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
    26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
    36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
    46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
    56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
    66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
    76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
    86,    87,    88,    89,    90,    91,    92,    93,    94,    95,
    96,    97,    98,    99,   100
};

#if YYDEBUG != 0
static const short yyprhs[] = {     0,
     0,     2,     4,     6,     9,    11,    14,    21,    28,    32,
    36,    40,    44,    47,    52,    57,    64,    68,    72,    75,
    82,    87,    94,   102,   105,   112,   119,   123,   126,   130,
   137,   142,   153,   162,   165,   166,   169,   172,   175,   178,
   179,   182,   185,   188,   191,   194,   197,   199,   203,   205,
   207,   210,   213,   214,   215,   223,   231,   239,   245,   253,
   256,   258,   260,   264,   268,   270,   274,   276,   278,   281,
   286,   291,   298,   303,   308,   313,   320,   325,   327,   331,
   335,   337,   339,   342,   345,   348,   352,   356,   360,   364,
   368,   372,   376,   380,   384,   388,   392,   396,   400,   404,
   408,   412,   416,   420,   426,   430,   434,   438,   442,   446,
   450,   452,   454,   456,   458,   463,   467,   472,   474,   476,
   478,   482,   486,   490,   494,   498,   501,   503,   505,   507,
   511,   514,   518,   520,   524,   526,   530,   534,   536,   537,
   543,   547,   550,   554,   558,   560,   564,   566,   568,   572,
   576,   580,   584,   586,   589,   593,   595,   598
};

static const short yyrhs[] = {     1,
     0,   103,     0,    65,     0,    66,    65,     0,   102,     0,
    31,   102,     0,   104,    56,   104,   120,   104,   102,     0,
   104,    57,   104,   120,   104,   102,     0,    32,   110,   102,
     0,    32,   112,   102,     0,    33,   109,   102,     0,    34,
   119,   102,     0,    35,   102,     0,   105,    36,   105,   102,
     0,   105,    39,   105,   102,     0,   104,    63,   104,   118,
   104,   102,     0,    43,   110,   102,     0,    44,   110,   102,
     0,    44,   102,     0,   104,    45,   104,   110,   104,   102,
     0,   104,    45,   104,   102,     0,   104,    47,   104,   106,
   104,   102,     0,   104,    47,   104,    70,   106,   104,   102,
     0,    48,   102,     0,   105,    49,   105,   118,   105,   102,
     0,   105,    49,   105,    40,   105,   102,     0,    50,   119,
   102,     0,    51,   102,     0,    52,   110,   102,     0,   104,
    53,   104,   110,   104,   102,     0,   104,    53,   104,   102,
     0,   104,    53,   104,   110,   104,    55,   104,   110,   104,
   102,     0,   104,    53,   104,    55,   104,   110,   104,   102,
     0,    62,   102,     0,     0,   104,    58,     0,   104,    59,
     0,   104,    60,     0,   104,    61,     0,     0,   105,    58,
     0,   105,    59,     0,   105,    60,     0,   105,    61,     0,
   105,    46,     0,   105,    54,     0,     1,     0,     9,   106,
    10,     0,    24,     0,    23,     0,    69,   106,     0,    71,
   106,     0,     0,     0,    72,     9,   107,   116,   108,    10,
   106,     0,    73,     9,   106,    77,   106,    10,   106,     0,
    74,     9,   106,    77,   106,    10,   106,     0,    75,     9,
   106,    10,   106,     0,    76,     9,   106,    77,   106,    10,
   106,     0,    16,   110,     0,   118,     0,   110,     0,   106,
    68,   106,     0,   106,    67,   106,     0,     1,     0,     9,
   109,    10,     0,    24,     0,    23,     0,    69,   109,     0,
    17,     9,   109,    10,     0,    18,     9,   109,    10,     0,
    20,     9,   109,    77,   109,    10,     0,    21,     9,   109,
    10,     0,    37,     9,   109,    10,     0,    38,     9,   109,
    10,     0,    41,     9,   109,    77,   109,    10,     0,    42,
     9,   109,    10,     0,   110,     0,   109,    68,   109,     0,
   109,    67,   109,     0,     1,     0,   111,     0,    95,   110,
     0,    99,   110,     0,   100,   110,     0,   110,    96,   110,
     0,   110,    97,   110,     0,   110,    98,   110,     0,   110,
    94,   110,     0,   110,    95,   110,     0,   110,    92,   110,
     0,   110,    93,   110,     0,   110,    88,   110,     0,   110,
    89,   110,     0,   110,    90,   110,     0,   110,    91,   110,
     0,   110,    86,   110,     0,   110,    87,   110,     0,   110,
    85,   110,     0,   110,    84,   110,     0,   110,    83,   110,
     0,   110,    82,   110,     0,   110,    81,   110,     0,   110,
    79,   110,    80,   110,     0,   112,    88,   112,     0,   112,
    89,   112,     0,   112,    90,   112,     0,   112,    91,   112,
     0,   112,    86,   112,     0,   112,    87,   112,     0,     1,
     0,    28,     0,    29,     0,    27,     0,    22,     9,   112,
    10,     0,     9,   110,    10,     0,    25,    11,   110,    12,
     0,    30,     0,    64,     0,   113,     0,   112,    96,   112,
     0,   112,    85,   112,     0,   112,    94,   112,     0,   112,
    95,   112,     0,   113,    80,   111,     0,   111,   113,     0,
     1,     0,    26,     0,    19,     0,    13,   114,    14,     0,
    13,    14,     0,     9,   112,    10,     0,   115,     0,   114,
    77,   115,     0,   110,     0,   110,    78,   110,     0,     9,
   115,    10,     0,     1,     0,     0,    27,     9,   117,   110,
    10,     0,     9,   116,    10,     0,    99,   116,     0,   116,
    81,   116,     0,   116,    82,   116,     0,     1,     0,     9,
   118,    10,     0,   119,     0,   120,     0,   118,    83,   118,
     0,   118,    94,   118,     0,   118,    85,   118,     0,   118,
    95,   118,     0,     1,     0,    98,   111,     0,     9,   119,
    10,     0,     1,     0,    15,   111,     0,     9,   120,    10,
     0
};

#endif

#if YYDEBUG != 0
static const short yyrline[] = { 0,
   168,   182,   186,   192,   198,   201,   207,   213,   219,   224,
   230,   237,   242,   248,   254,   260,   267,   272,   277,   289,
   294,   306,   313,   323,   329,   337,   345,   350,   356,   361,
   366,   378,   386,   401,   409,   412,   415,   418,   421,   426,
   429,   432,   435,   438,   441,   444,   449,   463,   466,   471,
   476,   481,   486,   487,   487,   492,   495,   498,   503,   507,
   514,   519,   526,   531,   538,   552,   555,   560,   565,   570,
   575,   580,   585,   590,   595,   600,   605,   610,   617,   622,
   629,   643,   646,   651,   656,   661,   666,   671,   676,   681,
   686,   691,   696,   701,   706,   711,   716,   721,   726,   731,
   736,   741,   746,   751,   754,   760,   766,   772,   778,   784,
   792,   806,   812,   818,   853,   859,   862,   868,   874,   884,
   887,   891,   895,   899,   903,   908,   915,   929,   963,   970,
   975,   980,   985,   999,  1017,  1024,  1027,  1032,  1046,  1071,
  1078,  1081,  1086,  1089,  1094,  1108,  1111,  1118,  1125,  1128,
  1131,  1134,  1140,  1154,  1157,  1163,  1177,  1180
};

static const char * const yytname[] = {   "$","error","$illegal.","T_DEFINE",
"T_DEFS","T_HELP","T_LOAD","T_UNDEF","T_UNDEF_ALL","T_LPAR","T_RPAR","T_LBRACK",
"T_RBRACK","T_LMARK","T_RMARK","T_D_PERCENT","T_AT","T_EF","T_EG","T_EMPTY",
"T_EU","T_EX","T_CARD","T_TRUE","T_FALSE","T_FIELD","T_STRING","T_VARNAME","T_PRECLASS",
"T_FAITHFUL","T_NUMBER","T_PREV","T_CALC","T_CHECK","T_CLEAR","T_CLEARALL","T_TERMCOMPS",
"T_AF","T_AG","T_ALLCOMPS","T_ALL","T_AU","T_AX","T_GOTO","T_LOOK","T_PRED",
"T_PREDS","T_QUERY","T_QUIT","T_SHOWENDS","T_SHRINK","T_STATISTICS","T_NEXT",
"T_SUCC","T_SUCCS","T_ARROW","T_SGSUCC","T_SGPRED","T_MUTE","T_VERBOSE","T_SUPERVERBOSE",
"T_VOLATILE","T_SETS","T_BUILD","T_PERIOD","T_EOL","T_USE_REDIRECT","T_OR","T_AND",
"T_NOT","T_NODE","T_STEP","T_FIRE","T_BPATH","T_DPATH","T_BSPAN","T_DSPAN","T_COMMA",
"T_D_PERIOD","T_QUEST","T_COLON","T_D_BAR","T_D_ET","T_BAR","T_CARET","T_ET",
"T_EQ","T_NE","T_LT","T_LE","T_GT","T_GE","T_RSHIFT","T_LSHIFT","T_PLUS","T_MINUS",
"T_ASTERISK","T_SLASH","T_PERCENT","T_EXCL","T_TILDE","line","redirect","realline",
"options","extraoptions","formula","@1","@2","ctl_formula","expression","easy_expression",
"marking","easy_marking","rangelist","range","firing_class","@3","setoperation",
"set","sgcomp",""
};
#endif

static const short yyr1[] = {     0,
   101,   101,   102,   102,   103,   103,   103,   103,   103,   103,
   103,   103,   103,   103,   103,   103,   103,   103,   103,   103,
   103,   103,   103,   103,   103,   103,   103,   103,   103,   103,
   103,   103,   103,   103,   104,   104,   104,   104,   104,   105,
   105,   105,   105,   105,   105,   105,   106,   106,   106,   106,
   106,   106,   107,   108,   106,   106,   106,   106,   106,   106,
   106,   106,   106,   106,   109,   109,   109,   109,   109,   109,
   109,   109,   109,   109,   109,   109,   109,   109,   109,   109,
   110,   110,   110,   110,   110,   110,   110,   110,   110,   110,
   110,   110,   110,   110,   110,   110,   110,   110,   110,   110,
   110,   110,   110,   110,   110,   110,   110,   110,   110,   110,
   111,   111,   111,   111,   111,   111,   111,   111,   111,   112,
   112,   112,   112,   112,   112,   112,   113,   113,   113,   113,
   113,   113,   114,   114,   115,   115,   115,   116,   117,   116,
   116,   116,   116,   116,   118,   118,   118,   118,   118,   118,
   118,   118,   119,   119,   119,   120,   120,   120
};

static const short yyr2[] = {     0,
     1,     1,     1,     2,     1,     2,     6,     6,     3,     3,
     3,     3,     2,     4,     4,     6,     3,     3,     2,     6,
     4,     6,     7,     2,     6,     6,     3,     2,     3,     6,
     4,    10,     8,     2,     0,     2,     2,     2,     2,     0,
     2,     2,     2,     2,     2,     2,     1,     3,     1,     1,
     2,     2,     0,     0,     7,     7,     7,     5,     7,     2,
     1,     1,     3,     3,     1,     3,     1,     1,     2,     4,
     4,     6,     4,     4,     4,     6,     4,     1,     3,     3,
     1,     1,     2,     2,     2,     3,     3,     3,     3,     3,
     3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
     3,     3,     3,     5,     3,     3,     3,     3,     3,     3,
     1,     1,     1,     1,     4,     3,     4,     1,     1,     1,
     3,     3,     3,     3,     3,     2,     1,     1,     1,     3,
     2,     3,     1,     3,     1,     3,     3,     1,     0,     5,
     3,     2,     3,     3,     1,     3,     1,     1,     3,     3,
     3,     3,     1,     2,     3,     1,     2,     3
};

static const short yydefact[] = {     0,
     1,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     3,     0,     5,     2,     0,     0,     6,
    81,     0,     0,   129,     0,     0,   128,   114,   112,   113,
   118,   119,     0,     0,     0,     0,     0,     0,   120,    81,
     0,     0,     0,     0,     0,    68,    67,     0,     0,     0,
     0,     0,     0,    78,     0,   153,     0,     0,     0,    13,
     0,    19,     0,    24,     0,    28,     0,    34,     4,    35,
    35,    35,    35,    35,    36,    37,    38,    39,    35,    40,
    40,    45,    40,    46,    41,    42,    43,    44,     0,     0,
     0,   131,   135,     0,   133,     0,     0,    83,    84,    85,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     9,
   127,     0,   126,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,    10,     0,     0,    78,     0,     0,     0,
     0,     0,     0,     0,     0,    69,     0,     0,    11,     0,
   111,     0,   154,    12,    17,    18,    27,    29,     0,     0,
     0,     0,     0,     0,     0,     0,     0,   116,   132,     0,
     0,     0,   130,     0,   127,     0,     0,     0,     0,   103,
   102,   101,   100,    99,    97,    98,    93,    94,    95,    96,
    91,    92,    89,    90,    86,    87,    88,     0,   122,   109,
   110,   105,   106,   107,   108,   123,   124,   121,   125,    66,
     0,     0,     0,     0,     0,     0,     0,     0,    80,    79,
   155,    21,    35,    81,     0,     0,     0,    50,    49,     0,
     0,     0,     0,     0,     0,     0,     0,    35,    62,    61,
   147,   148,    35,    31,    35,   156,     0,    35,    35,   145,
     0,    35,    14,    15,    40,    40,   137,   136,   134,   115,
   117,     0,    70,    71,     0,    73,    74,    75,     0,    77,
     0,     0,    62,    61,   147,   148,   157,    60,    51,    35,
    52,    53,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,   104,     0,     0,    20,    48,   146,   158,     0,
     0,     0,     0,     0,     0,    64,    63,    22,   149,   151,
   150,   152,    35,    35,    30,     7,     8,    16,    26,    25,
    72,    76,    23,   138,     0,     0,     0,    54,     0,     0,
     0,     0,     0,     0,     0,   139,   142,     0,     0,     0,
     0,     0,    58,     0,    33,    35,   141,     0,   143,   144,
     0,     0,     0,     0,     0,     0,    55,    56,    57,    59,
    32,   140,     0,     0,     0
};

static const short yydefgoto[] = {   373,
    16,    17,    18,    19,   238,   311,   350,    53,   239,    37,
    55,    39,    94,    95,   338,   358,   240,   241,   242
};

static const short yypact[] = {  1093,
-32768,   -43,   776,   532,    38,   -43,   776,   722,   -43,    38,
   -43,   776,   -43,-32768,   -49,-32768,-32768,  1236,  1158,-32768,
    29,   776,   744,-32768,    10,    30,-32768,-32768,-32768,-32768,
-32768,-32768,   776,   776,   776,  1095,   853,   524,   -47,  1043,
   532,    34,    45,    53,    55,-32768,-32768,    66,    74,    76,
    91,   532,   527,  1182,   440,-32768,    38,   480,   -43,-32768,
  1095,-32768,  1095,-32768,   -43,-32768,  1095,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,   888,   356,
   806,-32768,  1142,   -11,-32768,  1057,   776,-32768,-32768,-32768,
   776,   776,   776,   776,   776,   776,   776,   776,   776,   776,
   776,   776,   776,   776,   776,   776,   776,   776,   776,-32768,
-32768,  1057,-32768,  1057,  1057,  1057,  1057,  1057,  1057,  1057,
  1057,  1057,  1057,-32768,   480,     2,   888,   532,   532,   532,
   532,   532,   532,   532,   532,-32768,   532,   532,-32768,    39,
-32768,   776,-32768,-32768,-32768,-32768,-32768,-32768,   639,   360,
   578,   263,   263,   341,   517,   517,   439,-32768,-32768,   799,
    94,   776,-32768,   806,    29,   351,    -5,   940,  1162,  1218,
  1234,  1249,   868,   620,  1074,  1074,   686,   686,   686,   686,
   470,   470,    56,    56,-32768,-32768,-32768,    99,    17,   259,
   259,   259,   259,   259,   259,    17,    17,-32768,-32768,-32768,
    11,    14,    83,    35,    40,    67,   184,   146,    47,-32768,
-32768,-32768,  1182,  1038,   448,   480,   776,-32768,-32768,   448,
   448,   448,   119,   129,   149,   189,   192,   -39,  1182,   147,
-32768,-32768,-32768,-32768,  1182,-32768,    43,-32768,-32768,-32768,
    31,   147,-32768,-32768,-32768,   147,-32768,  1182,-32768,-32768,
-32768,   776,-32768,-32768,   532,-32768,-32768,-32768,   532,-32768,
   563,   152,   888,   102,    39,   200,-32768,  1182,-32768,   -39,
-32768,-32768,   448,   448,   448,   448,   448,   448,   563,    31,
    31,    31,    31,   661,   787,   200,   563,   563,   102,   563,
   517,   517,  1182,   182,   208,-32768,-32768,-32768,-32768,   563,
    26,   304,   328,   212,   330,   153,-32768,-32768,   139,    37,
-32768,-32768,  1182,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,    26,   206,    26,   145,   448,   448,
   448,   448,   563,   661,    -8,-32768,-32768,    26,    26,   219,
   236,   276,   -39,   280,-32768,  1182,-32768,   776,   155,-32768,
   448,   448,   448,   448,   563,   912,   -39,   -39,   -39,   -39,
-32768,-32768,   231,   235,-32768
};

static const short yypgoto[] = {-32768,
    -2,-32768,    22,   -66,    52,-32768,-32768,   -21,    64,   185,
    15,   -27,-32768,   -90,  -149,-32768,   -34,     3,  -137
};


#define	YYLAST		1347


static const short yytable[] = {    20,
   171,   357,   173,    60,   260,    62,    64,    59,    66,   123,
    68,   210,    65,   165,   166,    69,   167,    38,    96,   136,
   263,    14,    15,   264,   248,   249,   334,   287,   288,  -111,
   146,   250,   135,   120,   335,   134,    90,  -111,    56,   251,
    97,  -111,   138,   246,   266,   226,    57,  -111,   221,   267,
   149,   247,   336,   139,  -111,    90,   154,   226,   155,   150,
   156,   140,   157,   141,   158,   174,    36,    54,   147,   148,
    61,    63,   348,   349,   142,    67,   268,   147,   148,   124,
   147,   148,   143,   259,   144,    89,    93,   276,   131,   132,
   133,   159,   160,   161,   162,   163,    98,    99,   100,   145,
   164,   147,   148,   257,   137,    90,   147,   148,   169,   296,
   177,   308,   133,   276,   148,    54,   211,   212,   213,   214,
   215,   216,   217,   218,   337,   219,   220,   282,    58,   252,
   292,   293,   256,   147,   148,    58,   198,   283,   199,   200,
   201,   202,   203,   204,   205,   206,   207,   208,   123,   147,
   148,   117,   118,   119,   170,   270,   222,   284,   244,   265,
   178,   307,   253,   254,   179,   180,   181,   182,   183,   184,
   185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
   195,   196,   197,   124,   290,   345,   291,   347,   301,   302,
   274,   331,   131,   132,   133,   292,   293,   285,   359,   360,
   286,    54,    54,    54,    54,    54,    54,    54,    54,   309,
    54,    54,   147,   148,   346,    89,   299,   332,   287,   288,
   288,   341,   223,   291,   245,   348,   349,   275,   361,   290,
   374,   291,   292,   293,   375,   258,   349,    93,     0,    90,
   292,   293,   153,   304,   271,   362,     0,   305,   147,   148,
   147,   148,     0,   275,     0,   319,   320,   321,   322,   289,
   269,     0,     0,   246,   294,     0,   295,     0,   306,   297,
   298,   247,     0,   300,   147,   148,   272,   226,   287,   288,
   176,   279,   280,   281,     0,   363,   318,     0,   273,   364,
   278,     0,   325,     0,   326,   327,     0,   328,   329,   330,
     0,   310,   287,   288,     0,     0,   176,   333,   176,   176,
   176,   176,   176,   176,   176,   176,   176,   176,     0,   209,
    75,    76,    77,    78,     0,   303,     0,     0,    54,     0,
     0,     0,    54,     0,   312,   313,   314,   315,   316,   317,
   355,   250,   287,   288,   343,   344,   287,   288,     0,   251,
     0,   121,   131,   132,   133,   226,     0,   323,     0,   122,
   224,     0,   371,    23,     0,   169,     0,     0,   225,    24,
   287,   288,    23,     0,   226,   227,    27,   365,    24,     0,
   339,    25,   228,   229,    26,    27,    28,    29,    30,    31,
   351,   352,   353,   354,   287,   288,   287,   288,    75,    76,
    77,    78,     0,     0,   340,     0,   342,   356,     0,     0,
   277,     0,   367,   368,   369,   370,     0,    75,    76,    77,
    78,   366,     0,    32,     0,     0,     0,     0,   230,   231,
   232,   233,   234,   235,   236,   237,     0,     0,    58,   250,
   124,   125,   126,   127,   128,   129,   130,   251,   224,   131,
   132,   133,     0,   226,    33,     0,   225,    58,    34,    35,
    23,     0,   226,   227,     0,     0,    24,     0,     0,    25,
   228,   229,    26,    27,    28,    29,    30,    31,   255,     0,
   151,     0,     0,     0,    82,     0,     0,     0,   152,     0,
     0,     0,    84,     0,     0,     0,    85,    86,    87,    88,
     0,    25,     0,     0,    26,     0,    28,    29,    30,    31,
     0,    32,     0,     0,     0,     0,   230,     0,   232,   233,
   234,   235,   236,   237,   124,   125,   126,   127,   128,   129,
   130,     0,    40,   131,   132,   133,    58,     0,     0,     0,
    41,     0,    33,    32,    23,    58,    34,    35,    42,    43,
    24,    44,    45,    25,    46,    47,    26,    27,    28,    29,
    30,    31,    82,   115,   116,   117,   118,   119,    48,    49,
    84,     0,    50,    51,    85,    86,    87,    88,    21,     0,
     0,    14,    15,     0,     0,     0,    22,     0,    14,    15,
    23,    14,    15,   147,   148,    32,    24,     0,     0,    25,
    52,     0,    26,    27,    28,    29,    30,    31,   124,   125,
   126,   127,   128,   129,   130,     0,     0,   131,   132,   133,
    75,    76,    77,    78,     0,     0,    33,    14,    15,     0,
    34,    35,   243,     0,     0,    75,    76,    77,    78,    21,
     0,    32,    14,    15,     0,     0,     0,    22,     0,     0,
     0,    23,     0,     0,     0,     0,     0,    24,     0,     0,
    25,    21,     0,    26,    27,    28,    29,    30,    31,    22,
     0,     0,    33,    23,     0,     0,    34,    35,     0,    24,
     0,     0,    25,     0,     0,    26,    27,    28,    29,    30,
    31,     0,     0,     0,     0,     0,    75,    76,    77,    78,
     0,     0,    32,    14,    15,   107,   108,   109,   110,   111,
   112,   113,   114,   115,   116,   117,   118,   119,    75,    76,
    77,    78,    21,     0,    32,     0,     0,     0,     0,     0,
    22,     0,     0,    33,    23,     0,     0,    34,    35,     0,
    24,     0,     0,    25,    21,     0,    26,    27,    28,    29,
    30,    31,    91,     0,     0,    33,    23,    92,     0,    34,
    35,     0,    24,     0,     0,    25,     0,     0,    26,    27,
    28,    29,    30,    31,     0,     0,    21,   113,   114,   115,
   116,   117,   118,   119,    22,    32,    14,    15,    23,     0,
     0,     0,     0,     0,    24,     0,     0,    25,     0,     0,
    26,    27,    28,    29,    30,    31,    21,    32,   168,     0,
     0,     0,     0,     0,    91,     0,    33,     0,    23,     0,
    34,    35,     0,     0,    24,     0,     0,    25,     0,     0,
    26,    27,    28,    29,    30,    31,     0,     0,    33,    32,
     0,   324,    34,    35,    75,    76,    77,    78,     0,     0,
     0,    14,    15,   121,     0,     0,     0,     0,     0,     0,
     0,   122,   -82,     0,   -82,    23,   -82,     0,     0,    32,
    33,    24,     0,     0,    34,    35,   172,   101,    27,   102,
   103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
   113,   114,   115,   116,   117,   118,   119,   168,     0,     0,
    33,     0,     0,     0,    34,    35,     0,   -82,     0,     0,
   -82,   -82,   -82,   -82,     0,     0,     0,   -82,   -82,   -82,
   -82,   372,     0,     0,     0,     0,     0,     0,     0,   -82,
   -82,   -82,   -82,   -82,   -82,   -82,   -82,   -82,   -82,   -82,
   -82,   -82,   -82,   -82,   -82,   -82,   -82,   -82,   -82,   -82,
   -82,   261,   106,   107,   108,   109,   110,   111,   112,   113,
   114,   115,   116,   117,   118,   119,   101,     0,   102,   103,
   104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
   114,   115,   116,   117,   118,   119,     0,     0,     0,     0,
   101,     0,   102,   103,   104,   105,   106,   107,   108,   109,
   110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
     0,     0,     0,     0,     0,     0,     0,     0,   101,     0,
   102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
   112,   113,   114,   115,   116,   117,   118,   119,  -111,     0,
     0,     0,     0,  -111,     0,     0,  -111,   -47,     0,     0,
  -111,  -111,   -65,     0,     0,  -111,  -111,   175,     0,     0,
     0,  -111,     0,  -111,     0,    22,     0,     0,  -111,    23,
     0,     0,     0,     0,     0,    24,     0,     0,    25,     0,
     0,    26,    27,    28,    29,    30,    31,     0,     0,     0,
     0,     0,     0,     1,     0,   -47,   -47,   -47,   -47,     0,
     0,     0,   -47,   -47,   -47,   -47,     0,   -65,   -65,   -65,
   -65,     0,     0,     0,   -47,     0,     0,  -127,     0,   -65,
    32,     0,  -127,     2,     3,     4,     5,     6,   -40,     0,
     0,   -40,     0,     0,     0,     7,     8,   -35,   -40,   -35,
     9,   -40,    10,    11,    12,   -35,   -40,     0,   -35,   -35,
   -35,   -35,   -35,   -35,    13,   -35,     0,    14,    15,    14,
    15,   109,   110,   111,   112,   113,   114,   115,   116,   117,
   118,   119,     0,   101,     0,   102,   103,   104,   105,   106,
   107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
   117,   118,   119,    80,     0,     0,    81,     0,     0,     0,
     0,     0,     0,    82,     0,     0,    83,     0,     0,     0,
     0,    84,     0,     0,     0,    85,    86,    87,    88,   172,
   101,     0,   102,   103,   104,   105,   106,   107,   108,   109,
   110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
   101,   262,   102,   103,   104,   105,   106,   107,   108,   109,
   110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
   101,     0,   102,   103,   104,   105,   106,   107,   108,   109,
   110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
    70,     0,    71,     0,     0,     0,     0,     0,    72,     0,
     0,    73,    74,    75,    76,    77,    78,     0,    79,   103,
   104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
   114,   115,   116,   117,   118,   119,   104,   105,   106,   107,
   108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
   118,   119,   105,   106,   107,   108,   109,   110,   111,   112,
   113,   114,   115,   116,   117,   118,   119
};

static const short yycheck[] = {     2,
    91,    10,    14,     6,    10,     8,     9,     5,    11,    37,
    13,    10,    10,    80,    81,    65,    83,     3,     9,    41,
    10,    65,    66,    10,   162,   163,     1,    67,    68,     1,
    52,     1,    80,    36,     9,    38,    22,     9,     1,     9,
    11,    13,     9,     1,    10,    15,     9,    19,    10,    10,
    53,     9,    27,     9,    26,    41,    59,    15,    61,    57,
    63,     9,    65,     9,    67,    77,     3,     4,    67,    68,
     7,     8,    81,    82,     9,    12,    10,    67,    68,    85,
    67,    68,     9,   174,     9,    22,    23,   225,    94,    95,
    96,    70,    71,    72,    73,    74,    33,    34,    35,     9,
    79,    67,    68,    10,    41,    91,    67,    68,    10,   247,
    96,    10,    96,   251,    68,    52,   138,   139,   140,   141,
   142,   143,   144,   145,    99,   147,   148,     9,    98,   164,
    94,    95,   167,    67,    68,    98,   122,     9,   124,   125,
   126,   127,   128,   129,   130,   131,   132,   133,   176,    67,
    68,    96,    97,    98,    91,    10,   159,     9,   161,    77,
    97,    10,   165,   166,   101,   102,   103,   104,   105,   106,
   107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
   117,   118,   119,    85,    83,   335,    85,   337,   255,   256,
   225,    10,    94,    95,    96,    94,    95,     9,   348,   349,
     9,   138,   139,   140,   141,   142,   143,   144,   145,    10,
   147,   148,    67,    68,     9,   152,   251,    10,    67,    68,
    68,    10,   159,    85,   161,    81,    82,   225,    10,    83,
     0,    85,    94,    95,     0,   172,    82,   174,    -1,   225,
    94,    95,    58,   265,   223,    10,    -1,   269,    67,    68,
    67,    68,    -1,   251,    -1,   290,   291,   292,   293,   238,
    77,    -1,    -1,     1,   243,    -1,   245,    -1,   271,   248,
   249,     9,    -1,   252,    67,    68,   225,    15,    67,    68,
    96,   230,   231,   232,    -1,    10,   289,    -1,   225,    10,
   227,    -1,   295,    -1,   297,   298,    -1,   300,   301,   302,
    -1,   280,    67,    68,    -1,    -1,   122,   310,   124,   125,
   126,   127,   128,   129,   130,   131,   132,   133,    -1,   135,
    58,    59,    60,    61,    -1,   262,    -1,    -1,   265,    -1,
    -1,    -1,   269,    -1,   283,   284,   285,   286,   287,   288,
   343,     1,    67,    68,   323,   324,    67,    68,    -1,     9,
    -1,     1,    94,    95,    96,    15,    -1,   294,    -1,     9,
     1,    -1,   365,    13,    -1,    10,    -1,    -1,     9,    19,
    67,    68,    13,    -1,    15,    16,    26,   356,    19,    -1,
    77,    22,    23,    24,    25,    26,    27,    28,    29,    30,
   339,   340,   341,   342,    67,    68,    67,    68,    58,    59,
    60,    61,    -1,    -1,    77,    -1,    77,   344,    -1,    -1,
   226,    -1,   361,   362,   363,   364,    -1,    58,    59,    60,
    61,   358,    -1,    64,    -1,    -1,    -1,    -1,    69,    70,
    71,    72,    73,    74,    75,    76,    -1,    -1,    98,     1,
    85,    86,    87,    88,    89,    90,    91,     9,     1,    94,
    95,    96,    -1,    15,    95,    -1,     9,    98,    99,   100,
    13,    -1,    15,    16,    -1,    -1,    19,    -1,    -1,    22,
    23,    24,    25,    26,    27,    28,    29,    30,    40,    -1,
     1,    -1,    -1,    -1,    46,    -1,    -1,    -1,     9,    -1,
    -1,    -1,    54,    -1,    -1,    -1,    58,    59,    60,    61,
    -1,    22,    -1,    -1,    25,    -1,    27,    28,    29,    30,
    -1,    64,    -1,    -1,    -1,    -1,    69,    -1,    71,    72,
    73,    74,    75,    76,    85,    86,    87,    88,    89,    90,
    91,    -1,     1,    94,    95,    96,    98,    -1,    -1,    -1,
     9,    -1,    95,    64,    13,    98,    99,   100,    17,    18,
    19,    20,    21,    22,    23,    24,    25,    26,    27,    28,
    29,    30,    46,    94,    95,    96,    97,    98,    37,    38,
    54,    -1,    41,    42,    58,    59,    60,    61,     1,    -1,
    -1,    65,    66,    -1,    -1,    -1,     9,    -1,    65,    66,
    13,    65,    66,    67,    68,    64,    19,    -1,    -1,    22,
    69,    -1,    25,    26,    27,    28,    29,    30,    85,    86,
    87,    88,    89,    90,    91,    -1,    -1,    94,    95,    96,
    58,    59,    60,    61,    -1,    -1,    95,    65,    66,    -1,
    99,   100,    55,    -1,    -1,    58,    59,    60,    61,     1,
    -1,    64,    65,    66,    -1,    -1,    -1,     9,    -1,    -1,
    -1,    13,    -1,    -1,    -1,    -1,    -1,    19,    -1,    -1,
    22,     1,    -1,    25,    26,    27,    28,    29,    30,     9,
    -1,    -1,    95,    13,    -1,    -1,    99,   100,    -1,    19,
    -1,    -1,    22,    -1,    -1,    25,    26,    27,    28,    29,
    30,    -1,    -1,    -1,    -1,    -1,    58,    59,    60,    61,
    -1,    -1,    64,    65,    66,    86,    87,    88,    89,    90,
    91,    92,    93,    94,    95,    96,    97,    98,    58,    59,
    60,    61,     1,    -1,    64,    -1,    -1,    -1,    -1,    -1,
     9,    -1,    -1,    95,    13,    -1,    -1,    99,   100,    -1,
    19,    -1,    -1,    22,     1,    -1,    25,    26,    27,    28,
    29,    30,     9,    -1,    -1,    95,    13,    14,    -1,    99,
   100,    -1,    19,    -1,    -1,    22,    -1,    -1,    25,    26,
    27,    28,    29,    30,    -1,    -1,     1,    92,    93,    94,
    95,    96,    97,    98,     9,    64,    65,    66,    13,    -1,
    -1,    -1,    -1,    -1,    19,    -1,    -1,    22,    -1,    -1,
    25,    26,    27,    28,    29,    30,     1,    64,    10,    -1,
    -1,    -1,    -1,    -1,     9,    -1,    95,    -1,    13,    -1,
    99,   100,    -1,    -1,    19,    -1,    -1,    22,    -1,    -1,
    25,    26,    27,    28,    29,    30,    -1,    -1,    95,    64,
    -1,    55,    99,   100,    58,    59,    60,    61,    -1,    -1,
    -1,    65,    66,     1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,     9,    10,    -1,    12,    13,    14,    -1,    -1,    64,
    95,    19,    -1,    -1,    99,   100,    78,    79,    26,    81,
    82,    83,    84,    85,    86,    87,    88,    89,    90,    91,
    92,    93,    94,    95,    96,    97,    98,    10,    -1,    -1,
    95,    -1,    -1,    -1,    99,   100,    -1,    55,    -1,    -1,
    58,    59,    60,    61,    -1,    -1,    -1,    65,    66,    67,
    68,    10,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    77,
    78,    79,    80,    81,    82,    83,    84,    85,    86,    87,
    88,    89,    90,    91,    92,    93,    94,    95,    96,    97,
    98,    12,    85,    86,    87,    88,    89,    90,    91,    92,
    93,    94,    95,    96,    97,    98,    79,    -1,    81,    82,
    83,    84,    85,    86,    87,    88,    89,    90,    91,    92,
    93,    94,    95,    96,    97,    98,    -1,    -1,    -1,    -1,
    79,    -1,    81,    82,    83,    84,    85,    86,    87,    88,
    89,    90,    91,    92,    93,    94,    95,    96,    97,    98,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    79,    -1,
    81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
    91,    92,    93,    94,    95,    96,    97,    98,     1,    -1,
    -1,    -1,    -1,     1,    -1,    -1,     9,    10,    -1,    -1,
    13,     9,    10,    -1,    -1,    13,    19,     1,    -1,    -1,
    -1,    19,    -1,    26,    -1,     9,    -1,    -1,    26,    13,
    -1,    -1,    -1,    -1,    -1,    19,    -1,    -1,    22,    -1,
    -1,    25,    26,    27,    28,    29,    30,    -1,    -1,    -1,
    -1,    -1,    -1,     1,    -1,    58,    59,    60,    61,    -1,
    -1,    -1,    65,    66,    67,    68,    -1,    65,    66,    67,
    68,    -1,    -1,    -1,    77,    -1,    -1,    80,    -1,    77,
    64,    -1,    80,    31,    32,    33,    34,    35,    36,    -1,
    -1,    39,    -1,    -1,    -1,    43,    44,    45,    46,    47,
    48,    49,    50,    51,    52,    53,    54,    -1,    56,    57,
    58,    59,    60,    61,    62,    63,    -1,    65,    66,    65,
    66,    88,    89,    90,    91,    92,    93,    94,    95,    96,
    97,    98,    -1,    79,    -1,    81,    82,    83,    84,    85,
    86,    87,    88,    89,    90,    91,    92,    93,    94,    95,
    96,    97,    98,    36,    -1,    -1,    39,    -1,    -1,    -1,
    -1,    -1,    -1,    46,    -1,    -1,    49,    -1,    -1,    -1,
    -1,    54,    -1,    -1,    -1,    58,    59,    60,    61,    78,
    79,    -1,    81,    82,    83,    84,    85,    86,    87,    88,
    89,    90,    91,    92,    93,    94,    95,    96,    97,    98,
    79,    80,    81,    82,    83,    84,    85,    86,    87,    88,
    89,    90,    91,    92,    93,    94,    95,    96,    97,    98,
    79,    -1,    81,    82,    83,    84,    85,    86,    87,    88,
    89,    90,    91,    92,    93,    94,    95,    96,    97,    98,
    45,    -1,    47,    -1,    -1,    -1,    -1,    -1,    53,    -1,
    -1,    56,    57,    58,    59,    60,    61,    -1,    63,    82,
    83,    84,    85,    86,    87,    88,    89,    90,    91,    92,
    93,    94,    95,    96,    97,    98,    83,    84,    85,    86,
    87,    88,    89,    90,    91,    92,    93,    94,    95,    96,
    97,    98,    84,    85,    86,    87,    88,    89,    90,    91,
    92,    93,    94,    95,    96,    97,    98
};
/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */


/* Skeleton output parser for bison,
   Copyright (C) 1984, 1989, 1990 Bob Corbett and Richard Stallman

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 1, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */


#ifndef alloca
#ifdef __GNUC__
#define alloca __builtin_alloca
#else /* not GNU C.  */
#if (!defined (PROTOZOA) && defined (sparc)) || defined (__sparc__) || defined (__sparc) || defined (__sgi)

#else /* not sparc */
#if defined (MSDOS) && !defined (__TURBOC__)

#else /* not MSDOS, or __TURBOC__ */
#if defined(_AIX)

 #pragma alloca
#else /* not MSDOS, __TURBOC__, or _AIX */
#ifdef __hpux
#ifdef __cplusplus
extern "C" {
VOID *alloca (unsigned int);
};
#else /* not __cplusplus */
VOID *alloca ();
#endif /* not __cplusplus */
#endif /* __hpux */
#endif /* not _AIX */
#endif /* not MSDOS, or __TURBOC__ */
#endif /* not sparc.  */
#endif /* not GNU C.  */
#endif /* alloca not defined.  */

/* This is the parser code that is written into each bison parser
  when the %semantic_parser declaration is not specified in the grammar.
  It was written by Richard Stallman by simplifying the hairy parser
  used when %semantic_parser is specified.  */

/* Note: there must be only one dollar sign in this file.
   It is replaced by the list of actions, each action
   as one case of the switch.  */

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	return(0)
#define YYABORT 	return(1)
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.
   This remains here temporarily to ease the
   transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(token, value) \
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    { yychar = (token), yylval = (value);			\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { yyerror ("syntax error: cannot back up"); YYERROR; }	\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

#ifndef YYPURE
#define YYLEX		yylex()
#endif

#ifdef YYPURE
#ifdef YYLSP_NEEDED
#define YYLEX		yylex(&yylval, &yylloc)
#else
#define YYLEX		yylex(&yylval)
#endif
#endif

/* If nonreentrant, generate the variables here */

#ifndef YYPURE

int	yychar;			/*  the lookahead symbol		*/
YYSTYPE	yylval;			/*  the semantic value of the		*/
				/*  lookahead symbol			*/

#ifdef YYLSP_NEEDED
YYLTYPE yylloc;			/*  location data for the lookahead	*/
				/*  symbol				*/
#endif

int yynerrs;			/*  number of parse errors so far       */
#endif  /* not YYPURE */

#if YYDEBUG != 0
int yydebug;			/*  nonzero means print parse trace	*/
/* Since this is uninitialized, it does not stop multiple parsers
   from coexisting.  */
#endif

/*  YYINITDEPTH indicates the initial size of the parser's stacks	*/

#ifndef	YYINITDEPTH
#define YYINITDEPTH 200
#endif

/*  YYMAXDEPTH is the maximum size the stacks can grow to
    (effective only if the built-in stack extension method is used).  */

#if YYMAXDEPTH == 0
#undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
#define YYMAXDEPTH 10000
#endif

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
int yyparse (void);
#endif

#if __GNUC__ > 1		/* GNU C and GNU C++ define this.  */
#define __yy_bcopy(FROM,TO,COUNT)	__builtin_memcpy(TO,FROM,COUNT)
#else				/* not GNU C or C++ */
#ifndef __cplusplus

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_bcopy (from, to, count)
     char *from;
     char *to;
     int count;
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#else /* __cplusplus */

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_bcopy (char *from, char *to, int count)
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#endif
#endif


int
yyparse()
{
  register int yystate;
  register int yyn;
  register short *yyssp;
  register YYSTYPE *yyvsp;
  int yyerrstatus;	/*  number of tokens to shift before error messages enabled */
  int yychar1 = 0;		/*  lookahead token as an internal (translated) token number */

  short	yyssa[YYINITDEPTH];	/*  the state stack			*/
  YYSTYPE yyvsa[YYINITDEPTH];	/*  the semantic value stack		*/

  short *yyss = yyssa;		/*  refer to the stacks thru separate pointers */
  YYSTYPE *yyvs = yyvsa;	/*  to allow yyoverflow to reallocate them elsewhere */

#ifdef YYLSP_NEEDED
  YYLTYPE yylsa[YYINITDEPTH];	/*  the location stack			*/
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;

#define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else
#define YYPOPSTACK   (yyvsp--, yyssp--)
#endif

  int yystacksize = YYINITDEPTH;

#ifdef YYPURE
  int yychar;
  YYSTYPE yylval;
  int yynerrs;
#ifdef YYLSP_NEEDED
  YYLTYPE yylloc;
#endif
#endif

  YYSTYPE yyval;		/*  the variable used to return		*/
				/*  semantic values from the action	*/
				/*  routines				*/

  int yylen;

#if YYDEBUG != 0
  if (yydebug)
    (void) fprintf(stderr, "Starting parse\n");
#endif

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss - 1;
  yyvsp = yyvs;
#ifdef YYLSP_NEEDED
  yylsp = yyls;
#endif

/* Push a new state, which is found in  yystate  .  */
/* In all cases, when you get here, the value and location stacks
   have just been pushed. so pushing a state here evens the stacks.  */
yynewstate:

  *++yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Give user a chance to reallocate the stack */
      /* Use copies of these so that the &'s don't force the real ones into memory. */
      YYSTYPE *yyvs1 = yyvs;
      short *yyss1 = yyss;
#ifdef YYLSP_NEEDED
      YYLTYPE *yyls1 = yyls;
#endif

      /* Get the current used size of the three stacks, in elements.  */
      int size = (int) (yyssp - yyss + 1);

#ifdef yyoverflow
      /* Each stack pointer address is followed by the size of
	 the data in use in that stack, in bytes.  */
#ifdef YYLSP_NEEDED
      /* This used to be a conditional around just the two extra args,
	 but that might be undefined if yyoverflow is a macro.  */
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yyls1, size * sizeof (*yylsp),
		 &yystacksize);
#else
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yystacksize);
#endif

      yyss = yyss1; yyvs = yyvs1;
#ifdef YYLSP_NEEDED
      yyls = yyls1;
#endif
#else /* no yyoverflow */
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	{
	  yyerror("parser stack overflow");
	  return 2;
	}
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;
      yyss = (short *) alloca (yystacksize * sizeof (*yyssp));
      __yy_bcopy ((char *)yyss1, (char *)yyss, size * sizeof (*yyssp));
      yyvs = (YYSTYPE *) alloca (yystacksize * sizeof (*yyvsp));
      __yy_bcopy ((char *)yyvs1, (char *)yyvs, size * sizeof (*yyvsp));
#ifdef YYLSP_NEEDED
      yyls = (YYLTYPE *) alloca (yystacksize * sizeof (*yylsp));
      __yy_bcopy ((char *)yyls1, (char *)yyls, size * sizeof (*yylsp));
#endif
#endif /* no yyoverflow */

      yyssp = yyss + size - 1;
      yyvsp = yyvs + size - 1;
#ifdef YYLSP_NEEDED
      yylsp = yyls + size - 1;
#endif

#if YYDEBUG != 0
      if (yydebug)
	(void) fprintf(stderr, "Stack size increased to %d\n", yystacksize);
#endif

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

#if YYDEBUG != 0
  if (yydebug)
    (void) fprintf(stderr, "Entering state %d\n", yystate);
#endif

  goto yybackup;
 yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
#if YYDEBUG != 0
      if (yydebug)
	(void) fprintf(stderr, "Reading a token: ");
#endif
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

#if YYDEBUG != 0
      if (yydebug)
	(void) fprintf(stderr, "Now at end of input.\n");
#endif
    }
  else
    {
      yychar1 = YYTRANSLATE(yychar);

#if YYDEBUG != 0
      if (yydebug)
	{
	  (void) fprintf (stderr, "Next token is %d (%s", yychar, yytname[yychar1]);
	  /* Give the individual parser a way to print the precise meaning
	     of a token, for further debugging info.  */
#ifdef YYPRINT
	  YYPRINT (stderr, yychar, yylval);
#endif
	  (void) fprintf (stderr, ")\n");
	}
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */

#if YYDEBUG != 0
  if (yydebug)
    (void) fprintf(stderr, "Shifting token %d (%s), ", yychar, yytname[yychar1]);
#endif

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* count tokens shifted since error; after three, turn off error status.  */
  if (yyerrstatus) yyerrstatus--;

  yystate = yyn;
  goto yynewstate;

/* Do the default action for the current state.  */
yydefault:

  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;

/* Do a reduction.  yyn is the number of a rule to reduce with.  */
yyreduce:
  yylen = yyr2[yyn];
  if (yylen > 0)
    yyval = yyvsp[1-yylen]; /* implement default value of the action */

#if YYDEBUG != 0
  if (yydebug)
    {
      int i;

      (void) fprintf (stderr, "Reducing via rule %d (line %d), ",
	       yyn, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (i = yyprhs[yyn]; yyrhs[i] > 0; i++)
	(void) fprintf (stderr, "%s ", yytname[yyrhs[i]]);
      (void) fprintf (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif


  switch (yyn) {

case 1:

{ if (errorFlag == NO_ERROR)
                              { 
				  (void) fprintf(_err,
						 "Error in command:\n");
				  (void) fflush(_err);
				  PrtCaret(rulesPlc,
					   (unsigned) strlen(yytext));
				  errorFlag = CML_ERROR;
			      }
                          ret = NULL;
			  yyclearin;
			;
    break;}
case 2:

{ ret = yyvsp[0].com; ;
    break;}
case 3:

{ redirect.type = REDIRECT_NONE;
                          redirect.name = NULL;
			  redirect.args = NULL; ;
    break;}
case 4:

{ redirect.type = yyvsp[-1].redirect.type;
                          redirect.name = yyvsp[-1].redirect.name;
			  redirect.args = yyvsp[-1].redirect.args; ;
    break;}
case 5:

{ yyval.com = NULL; ;
    break;}
case 6:

{ yyval.com = CmlAux(LI_PREV, TG_NONE, 
					  (EXPRESSION *) NULL,
					  (EXPRESSION *) NULL);
                        ;
    break;}
case 7:

{ yyval.com = CmlAux(LI_SGSUCC,
					  yyvsp[-5].opt | yyvsp[-3].opt | yyvsp[-1].opt,
					  yyvsp[-2].ep, (EXPRESSION *) NULL);
                        ;
    break;}
case 8:

{ yyval.com = CmlAux(LI_SGPRED,
					  yyvsp[-5].opt | yyvsp[-3].opt | yyvsp[-1].opt,
					  yyvsp[-2].ep, (EXPRESSION *) NULL);
                        ;
    break;}
case 9:

{ yyval.com = CmlAux(LI_CALC, TG_NONE, yyvsp[-1].ep,
					  (EXPRESSION *) NULL);
                        ;
    break;}
case 10:

{ yyval.com = CmlAux(LI_CALC, TG_MARKING,
					  (EXPRESSION *) yyvsp[-1].mep,
					  (EXPRESSION *) NULL);
                        ;
    break;}
case 11:

{ yyval.com = CmlAux(LI_CHECK,
					   TG_NONE,
					   (EXPRESSION *) yyvsp[-1].fp,
					   (EXPRESSION *) NULL);
                        ;
    break;}
case 12:

{ yyval.com = CmlAux(LI_CLEAR, TG_NONE, yyvsp[-1].ep,
					  (EXPRESSION *) NULL);
                        ;
    break;}
case 13:

{ yyval.com = CmlAux(LI_CLEARALL, TG_NONE,
					  (EXPRESSION *) NULL,
					  (EXPRESSION *) NULL);
                        ;
    break;}
case 14:

{ yyval.com = CmlAux(LI_TERMCOMPS, yyvsp[-3].opt | yyvsp[-1].opt,
					  (EXPRESSION *) NULL,
					  (EXPRESSION *) NULL);
                        ;
    break;}
case 15:

{ yyval.com = CmlAux(LI_ALLCOMPS, yyvsp[-3].opt | yyvsp[-1].opt,
					  (EXPRESSION *) NULL,
					  (EXPRESSION *) NULL);
                        ;
    break;}
case 16:

{ yyval.com = CmlAux(LI_BUILD,
					  yyvsp[-5].opt | yyvsp[-3].opt | yyvsp[-1].opt,
					  (EXPRESSION *) yyvsp[-2].sop,
					  (EXPRESSION *) NULL);
                        ;
    break;}
case 17:

{ yyval.com = CmlAux(LI_GOTO, TG_NONE, yyvsp[-1].ep,
					  (EXPRESSION *) NULL);
                        ;
    break;}
case 18:

{ yyval.com = CmlAux(LI_LOOK, TG_NONE, yyvsp[-1].ep,
					  (EXPRESSION *) NULL);
                        ;
    break;}
case 19:

{ yyval.com = CmlAux(LI_LOOK, TG_NONE,
					  XprAux(EO_DOM,
						 (EXPRESSION *) NULL,
						 (EXPRESSION *) NULL,
						 (EXPRESSION *) NULL,
						 (DOMAIN)
						 GphOrdinal(theGraph, 
							    PthEnd(thePath))),
					  (EXPRESSION *) NULL);
                        ;
    break;}
case 20:

{ yyval.com = CmlAux(LI_PRED, yyvsp[-5].opt | yyvsp[-3].opt | yyvsp[-1].opt,
					  yyvsp[-2].ep, (EXPRESSION *) NULL);
                        ;
    break;}
case 21:

{ yyval.com = CmlAux(LI_PRED, yyvsp[-3].opt | yyvsp[-1].opt,
					  XprAux(EO_DOM, 
						 (EXPRESSION *) NULL,
						 (EXPRESSION *) NULL,
						 (EXPRESSION *) NULL,
						 (DOMAIN)
						 GphOrdinal(theGraph, 
							    PthEnd(thePath))),
					  (EXPRESSION *) NULL);
                        ;
    break;}
case 22:

{ yyval.com = CmlAux(LI_QUERY,
					  yyvsp[-5].opt | yyvsp[-3].opt | yyvsp[-1].opt,
					  (EXPRESSION *) yyvsp[-2].fp,
					  (EXPRESSION *) NULL);
                        ;
    break;}
case 23:

{ yyval.com = CmlAux(LI_QUERY, 
					  yyvsp[-6].opt | yyvsp[-4].opt | yyvsp[-1].opt,
					  (EXPRESSION *)
					  ForAux(FO_NODE, yyvsp[-2].fp,
						 (FORMULA *) NULL,
						 (FORMULA *) NULL),
					  (EXPRESSION *) NULL);
                        ;
    break;}
case 24:

{ yyval.com = CmlAux(LI_QUIT, TG_NONE,
					  (EXPRESSION *) NULL,
					  (EXPRESSION *) NULL);
                        ;
    break;}
case 25:

{ yyval.com = CmlAux(LI_SHOWENDS,
					  yyvsp[-5].opt | yyvsp[-3].opt | yyvsp[-1].opt,
					  (EXPRESSION *) yyvsp[-2].sop,
					  (EXPRESSION *) NULL);
                        ;
    break;}
case 26:

{ yyval.com = CmlAux(LI_SHOWENDS,
					  yyvsp[-5].opt | yyvsp[-3].opt | yyvsp[-1].opt,
					  (EXPRESSION *) NULL,
					  (EXPRESSION *) NULL);
                        ;
    break;}
case 27:

{ yyval.com = CmlAux(LI_SHRINK, TG_NONE, yyvsp[-1].ep,
					  (EXPRESSION *) NULL);
                        ;
    break;}
case 28:

{ yyval.com = CmlAux(LI_STATISTICS, TG_NONE,
					  (EXPRESSION *) NULL,
					  (EXPRESSION *) NULL);
                        ;
    break;}
case 29:

{ yyval.com = CmlAux(LI_NEXT, TG_NONE, yyvsp[-1].ep,
					  (EXPRESSION *) NULL);
                        ;
    break;}
case 30:

{ yyval.com = CmlAux(LI_SUCC, yyvsp[-5].opt | yyvsp[-3].opt | yyvsp[-1].opt,
					  yyvsp[-2].ep, (EXPRESSION *) NULL);
                        ;
    break;}
case 31:

{ yyval.com = CmlAux(LI_SUCC, yyvsp[-3].opt | yyvsp[-1].opt,
					  XprAux(EO_DOM, 
						 (EXPRESSION *) NULL,
						 (EXPRESSION *) NULL,
						 (EXPRESSION *) NULL,
						 (DOMAIN)
						 GphOrdinal(theGraph, 
							    PthEnd(thePath))), 
					  (EXPRESSION *) NULL);
                        ;
    break;}
case 32:

{ yyval.com = CmlAux(LI_SUCC,
					  yyvsp[-9].opt | yyvsp[-7].opt | yyvsp[-5].opt | 
					  yyvsp[-3].opt | yyvsp[-1].opt,
					  yyvsp[-6].ep, yyvsp[-2].ep);
                        ;
    break;}
case 33:

{ yyval.com = CmlAux(LI_SUCC, 
					  yyvsp[-7].opt | yyvsp[-5].opt | yyvsp[-3].opt | 
					  yyvsp[-1].opt, 
					  XprAux(EO_DOM, 
						 (EXPRESSION *) NULL,
						 (EXPRESSION *) NULL,
						 (EXPRESSION *) NULL,
						 (DOMAIN)
						 GphOrdinal(theGraph, 
							    PthEnd(thePath))), 
					  yyvsp[-2].ep);
                        ;
    break;}
case 34:

{ yyval.com = CmlAux(LI_SETS, TG_NONE, 
					  (EXPRESSION *) NULL,
					  (EXPRESSION *) NULL);
                        ;
    break;}
case 35:

{ yyval.opt = TG_NONE; ;
    break;}
case 36:

{ yyval.opt = yyvsp[-1].opt | TG_MUTE; ;
    break;}
case 37:

{ yyval.opt = yyvsp[-1].opt | TG_VERBOSE; ;
    break;}
case 38:

{ yyval.opt = yyvsp[-1].opt | TG_VERBOSE | TG_SUPERVERBOSE; ;
    break;}
case 39:

{ yyval.opt = yyvsp[-1].opt | TG_VOLATILE; ;
    break;}
case 40:

{ yyval.opt = TG_NONE; ;
    break;}
case 41:

{ yyval.opt = yyvsp[-1].opt | TG_MUTE; ;
    break;}
case 42:

{ yyval.opt = yyvsp[-1].opt | TG_VERBOSE; ;
    break;}
case 43:

{ yyval.opt = yyvsp[-1].opt | TG_VERBOSE | TG_SUPERVERBOSE; ;
    break;}
case 44:

{ yyval.opt = yyvsp[-1].opt | TG_VOLATILE; ;
    break;}
case 45:

{ yyval.opt = yyvsp[-1].opt | TG_PREDS; ;
    break;}
case 46:

{ yyval.opt = yyvsp[-1].opt | TG_SUCCS; ;
    break;}
case 47:

{ if (errorFlag == NO_ERROR)
                              {
				  (void) fprintf(_err,
						 "Error in formula:\n");
				  (void) fflush(_err);
				  PrtCaret(rulesPlc,
					   (unsigned) strlen(yytext));
				  errorFlag = FOR_ERROR;
			      }
			  yyval.fp = NULL;
			  yyclearin;
			;
    break;}
case 48:

{ yyval.fp = yyvsp[-1].fp; ;
    break;}
case 49:

{ yyval.fp = ForAux(FO_FALSE, (FORMULA *) NULL,
					  (FORMULA *) NULL, (FORMULA *) NULL);
                        ;
    break;}
case 50:

{ yyval.fp = ForAux(FO_TRUE, (FORMULA *) NULL,
					  (FORMULA *) NULL, (FORMULA *) NULL);
                        ;
    break;}
case 51:

{ yyval.fp = ForAux(FO_NOT, yyvsp[0].fp, (FORMULA *) NULL,
					  (FORMULA *) NULL);
                        ;
    break;}
case 52:

{ yyval.fp = ForAux(FO_STEP, yyvsp[0].fp, (FORMULA *) NULL,
					  (FORMULA *) NULL);
                        ;
    break;}
case 53:

{ inFiringClass = TRUE; ;
    break;}
case 54:

{ inFiringClass = FALSE; ;
    break;}
case 55:

{ yyval.fp = ForAux(FO_FIRE, (FORMULA *) yyvsp[-3].fcp,
					  yyvsp[0].fp, (FORMULA *) NULL);
                        ;
    break;}
case 56:

{ yyval.fp = ForAux(FO_BPATH, yyvsp[-4].fp, yyvsp[-2].fp, yyvsp[0].fp); ;
    break;}
case 57:

{ yyval.fp = ForAux(FO_DPATH, yyvsp[-4].fp, yyvsp[-2].fp, yyvsp[0].fp); ;
    break;}
case 58:

{ yyval.fp = ForAux(FO_BSPAN, yyvsp[-2].fp, yyvsp[0].fp,
					  (FORMULA *) NULL);
                        ;
    break;}
case 59:

{ yyval.fp = ForAux(FO_DSPAN, yyvsp[-4].fp, yyvsp[-2].fp, yyvsp[0].fp);
                        ;
    break;}
case 60:

{ if (yyvsp[0].ep)
			      (void) XprReduce(yyvsp[0].ep);
			  yyval.fp = ForAux(FO_AT, (FORMULA *) yyvsp[0].ep,
					  (FORMULA *) NULL, (FORMULA *) NULL);
                        ;
    break;}
case 61:

{ yyval.fp = ForAux(FO_INSET, (FORMULA *) yyvsp[0].sop,
					  (FORMULA *) NULL, (FORMULA *) NULL);
                        ;
    break;}
case 62:

{ if (yyvsp[0].ep)
			      (void) XprReduce(yyvsp[0].ep);
			  yyval.fp = ForAux(FO_EXPR, (FORMULA *) yyvsp[0].ep,
					  (FORMULA *) NULL, (FORMULA *) NULL);
                        ;
    break;}
case 63:

{ yyval.fp = ForAux(FO_AND, yyvsp[-2].fp, yyvsp[0].fp,
					  (FORMULA *) NULL);
                        ;
    break;}
case 64:

{ yyval.fp = ForAux(FO_OR, yyvsp[-2].fp, yyvsp[0].fp,
					  (FORMULA *) NULL);
                        ;
    break;}
case 65:

{ if (errorFlag == NO_ERROR)
                              {
				  (void) fprintf(_err,
						 "Error in CTL formula:\n");
				  (void) fflush(_err);
				  PrtCaret(rulesPlc,
					   (unsigned) strlen(yytext));
				  errorFlag = FOR_ERROR;
			      }
			  yyval.fp = NULL;
			  yyclearin;
			;
    break;}
case 66:

{ yyval.fp = yyvsp[-1].fp; ;
    break;}
case 67:

{ yyval.fp = ForAux(FO_CTL_FALSE, (FORMULA *) NULL,
					  (FORMULA *) NULL, (FORMULA *) NULL);
                        ;
    break;}
case 68:

{ yyval.fp = ForAux(FO_CTL_TRUE, (FORMULA *) NULL,
					  (FORMULA *) NULL, (FORMULA *) NULL);
                        ;
    break;}
case 69:

{ yyval.fp = ForAux(FO_CTL_NOT, yyvsp[0].fp, (FORMULA *) NULL,
					   (FORMULA *) NULL);
                        ;
    break;}
case 70:

{ yyval.fp = ForAux(FO_CTL_EF, yyvsp[-1].fp, (FORMULA *) NULL,
					   (FORMULA *) NULL);
			;
    break;}
case 71:

{ yyval.fp = ForAux(FO_CTL_EG, yyvsp[-1].fp, (FORMULA *) NULL,
					   (FORMULA *) NULL);
			;
    break;}
case 72:

{ yyval.fp = ForAux(FO_CTL_EU, yyvsp[-3].fp, yyvsp[-1].fp,
					   (FORMULA *) NULL);
			;
    break;}
case 73:

{ yyval.fp = ForAux(FO_CTL_EX, yyvsp[-1].fp, (FORMULA *) NULL,
					   (FORMULA *) NULL);
			;
    break;}
case 74:

{ yyval.fp = ForAux(FO_CTL_AF, yyvsp[-1].fp, (FORMULA *) NULL,
					   (FORMULA *) NULL);
			;
    break;}
case 75:

{ yyval.fp = ForAux(FO_CTL_AG, yyvsp[-1].fp, (FORMULA *) NULL,
					   (FORMULA *) NULL);
			;
    break;}
case 76:

{ yyval.fp = ForAux(FO_CTL_AU, yyvsp[-3].fp, yyvsp[-1].fp,
					   (FORMULA *) NULL);
			;
    break;}
case 77:

{ yyval.fp = ForAux(FO_CTL_AX, yyvsp[-1].fp, (FORMULA *) NULL,
					   (FORMULA *) NULL);
			;
    break;}
case 78:

{ if (yyvsp[0].ep)
			      (void) XprReduce(yyvsp[0].ep);
			  yyval.fp = ForAux(FO_CTL_EXPR, (FORMULA *) yyvsp[0].ep,
					  (FORMULA *) NULL, (FORMULA *) NULL);
                        ;
    break;}
case 79:

{ yyval.fp = ForAux(FO_CTL_AND, yyvsp[-2].fp, yyvsp[0].fp,
					  (FORMULA *) NULL);
                        ;
    break;}
case 80:

{ yyval.fp = ForAux(FO_CTL_OR, yyvsp[-2].fp, yyvsp[0].fp,
					  (FORMULA *) NULL);
                        ;
    break;}
case 81:

{ if (errorFlag == NO_ERROR)
                              {
				  (void) fprintf(_err,
						 "Error in expression:\n");
				  (void) fflush(_err);
				  PrtCaret(rulesPlc,
					   (unsigned) strlen(yytext));
				  errorFlag = XPR_ERROR;
			      }
			  yyval.ep = NULL;
			  yyclearin;
			;
    break;}
case 82:

{ yyval.ep = yyvsp[0].ep; ;
    break;}
case 83:

{ yyval.ep = XprAux(EO_NEG, yyvsp[0].ep, (EXPRESSION *) NULL,
					  (EXPRESSION *) NULL, 0L);
                        ;
    break;}
case 84:

{ yyval.ep = XprAux(EO_NOT, yyvsp[0].ep, (EXPRESSION *) NULL,
					  (EXPRESSION *) NULL, 0L);
                        ;
    break;}
case 85:

{ yyval.ep = XprAux(EO_BNOT, yyvsp[0].ep, (EXPRESSION *) NULL,
					  (EXPRESSION *) NULL, 0L);
                        ;
    break;}
case 86:

{ yyval.ep = XprAux(EO_TIMES, yyvsp[-2].ep, yyvsp[0].ep,
					  (EXPRESSION *) NULL, 0L);
                        ;
    break;}
case 87:

{ yyval.ep = XprAux(EO_DIV, yyvsp[-2].ep, yyvsp[0].ep,
					  (EXPRESSION *) NULL, 0L);
                        ;
    break;}
case 88:

{ yyval.ep = XprAux(EO_REM, yyvsp[-2].ep, yyvsp[0].ep,
					  (EXPRESSION *) NULL, 0L);
                        ;
    break;}
case 89:

{ yyval.ep = XprAux(EO_PLUS, yyvsp[-2].ep, yyvsp[0].ep,
					  (EXPRESSION *) NULL, 0L);
                        ;
    break;}
case 90:

{ yyval.ep = XprAux(EO_MINUS, yyvsp[-2].ep, yyvsp[0].ep,
					  (EXPRESSION *) NULL, 0L);
                        ;
    break;}
case 91:

{ yyval.ep = XprAux(EO_RSHIFT, yyvsp[-2].ep, yyvsp[0].ep,
					  (EXPRESSION *) NULL, 0L);
                        ;
    break;}
case 92:

{ yyval.ep = XprAux(EO_LSHIFT, yyvsp[-2].ep, yyvsp[0].ep,
					  (EXPRESSION *) NULL, 0L);
                        ;
    break;}
case 93:

{ yyval.ep = XprAux(EO_LESS, yyvsp[-2].ep, yyvsp[0].ep,
					  (EXPRESSION *) NULL, 0L);
                        ;
    break;}
case 94:

{ yyval.ep = XprAux(EO_LEQUAL, yyvsp[-2].ep, yyvsp[0].ep,
					  (EXPRESSION *) NULL, 0L);
                        ;
    break;}
case 95:

{ yyval.ep = XprAux(EO_LESS, yyvsp[0].ep, yyvsp[-2].ep,
					  (EXPRESSION *) NULL, 0L);
                        ;
    break;}
case 96:

{ yyval.ep = XprAux(EO_LEQUAL, yyvsp[0].ep, yyvsp[-2].ep,
					  (EXPRESSION *) NULL, 0L);
                        ;
    break;}
case 97:

{ yyval.ep = XprAux(EO_EQUAL, yyvsp[-2].ep, yyvsp[0].ep,
					  (EXPRESSION *) NULL, 0L);
                        ;
    break;}
case 98:

{ yyval.ep = XprAux(EO_NEQUAL, yyvsp[-2].ep, yyvsp[0].ep,
					  (EXPRESSION *) NULL, 0L);
                        ;
    break;}
case 99:

{ yyval.ep = XprAux(EO_BAND, yyvsp[-2].ep, yyvsp[0].ep,
					  (EXPRESSION *) NULL, 0L);
                        ;
    break;}
case 100:

{ yyval.ep = XprAux(EO_BXOR, yyvsp[-2].ep, yyvsp[0].ep,
					  (EXPRESSION *) NULL, 0L);
                        ;
    break;}
case 101:

{ yyval.ep = XprAux(EO_BOR, yyvsp[-2].ep, yyvsp[0].ep,
					  (EXPRESSION *) NULL, 0L);
                        ;
    break;}
case 102:

{ yyval.ep = XprAux(EO_AND, yyvsp[-2].ep, yyvsp[0].ep,
					  (EXPRESSION *) NULL, 0L);
                        ;
    break;}
case 103:

{ yyval.ep = XprAux(EO_OR, yyvsp[-2].ep, yyvsp[0].ep,
					  (EXPRESSION *) NULL, 0L);
                        ;
    break;}
case 104:

{ yyval.ep = XprAux(EO_IF, yyvsp[-4].ep, yyvsp[-2].ep, yyvsp[0].ep, 0L); ;
    break;}
case 105:

{ yyval.ep = XprAux(EO_MLESS, (EXPRESSION *) yyvsp[-2].mep,
					  (EXPRESSION *) yyvsp[0].mep,
					  (EXPRESSION *) NULL, 0L);
                        ;
    break;}
case 106:

{ yyval.ep = XprAux(EO_MLEQUAL, (EXPRESSION *) yyvsp[-2].mep,
					  (EXPRESSION *) yyvsp[0].mep,
					  (EXPRESSION *) NULL, 0L);
                        ;
    break;}
case 107:

{ yyval.ep = XprAux(EO_MLESS, (EXPRESSION *) yyvsp[0].mep,
					  (EXPRESSION *) yyvsp[-2].mep,
					  (EXPRESSION *) NULL, 0L);
                        ;
    break;}
case 108:

{ yyval.ep = XprAux(EO_MLEQUAL, (EXPRESSION *) yyvsp[0].mep,
					  (EXPRESSION *) yyvsp[-2].mep,
					  (EXPRESSION *) NULL, 0L);
                        ;
    break;}
case 109:

{ yyval.ep = XprAux(EO_MEQUAL, (EXPRESSION *) yyvsp[-2].mep,
					  (EXPRESSION *) yyvsp[0].mep,
					  (EXPRESSION *) NULL, 0L);
                        ;
    break;}
case 110:

{ yyval.ep = XprAux(EO_MNEQUAL, (EXPRESSION *) yyvsp[-2].mep,
					  (EXPRESSION *) yyvsp[0].mep,
					  (EXPRESSION *) NULL, 0L);
                        ;
    break;}
case 111:

{ if (errorFlag == NO_ERROR)
                              {
				  (void) fprintf(_err,
						 "Error in expression:\n");
				  (void) fflush(_err);
				  PrtCaret(rulesPlc,
					   (unsigned) strlen(yytext));
				  errorFlag = XPR_ERROR;
			      }
			  yyval.ep = NULL;
			  yyclearin;
			;
    break;}
case 112:

{ yyval.ep = XprAux(EO_PRECLASS, (EXPRESSION *) NULL,
					  (EXPRESSION *) NULL,
					  (EXPRESSION *) NULL, 0L);
			;
    break;}
case 113:

{ yyval.ep = XprAux(EO_FAITHFUL, (EXPRESSION *) NULL,
					  (EXPRESSION *) NULL,
					  (EXPRESSION *) NULL, 0L);
			;
    break;}
case 114:

{ if (errorFlag == NO_ERROR)
			      {
				  str = strncpy((char *)
						Allocate(yyvsp[0].token.length + 1),
						ioBuf->_buf + yyvsp[0].token.start,
						(size_t) (yyvsp[0].token.length));
				  str[yyvsp[0].token.length] = '\0';
				  if ((ref = (REF *)
				       BalTrElement(traVarTrees[transition],
						    (char *) str)))
				      yyval.ep = XprAux(EO_TRAVAR, 
						      (EXPRESSION *) NULL,
						      (EXPRESSION *) NULL,
						      (EXPRESSION *) NULL,
						      (DOMAIN) RefGSlot(ref));
				  else
				      {
					  (void) fprintf(_err,
							 "Transition %s does not have variable %s\n",
							 traNames[transition],
							 str);
					  (void) fflush(_err);
					  PrtCaret(yyvsp[0].token.start
						   + yyvsp[0].token.length,
						   yyvsp[0].token.length);
					  errorFlag = XPR_ERROR;
					  yyval.ep = NULL;
				      }
				  Deallocate((char *) str);
			      }
                          else
                              yyval.ep = NULL;
                        ;
    break;}
case 115:

{ yyval.ep = XprAux(EO_CARD, (EXPRESSION *) yyvsp[-1].mep,
					  (EXPRESSION *) NULL,
					  (EXPRESSION *) NULL, 0L);
                        ;
    break;}
case 116:

{ yyval.ep = yyvsp[-1].ep; ;
    break;}
case 117:

{ yyval.ep = XprAux(EO_FIELD, yyvsp[-1].ep,
					  (EXPRESSION *) NULL,
					  (EXPRESSION *) NULL, 0L);
                        ;
    break;}
case 118:

{ yyval.ep = XprAux(EO_DOM, (EXPRESSION *) NULL,
					  (EXPRESSION *) NULL,
					  (EXPRESSION *) NULL, yyvsp[0].dv);
                        ;
    break;}
case 119:

{ yyval.ep = XprAux(EO_DOM, (EXPRESSION *) NULL,
					  (EXPRESSION *) NULL,
					  (EXPRESSION *) NULL, (DOMAIN)
					  GphOrdinal(theGraph, 
						     PthEnd(thePath)));
                        ;
    break;}
case 120:

{ yyval.mep = yyvsp[0].mep; ;
    break;}
case 121:

{ yyval.mep = MexAux(MO_CARTES, yyvsp[-2].mep, yyvsp[0].mep,
					   (unsigned) 0); ;
    break;}
case 122:

{ yyval.mep = MexAux(MO_INTERS, yyvsp[-2].mep, yyvsp[0].mep,
                                           (unsigned) 0); ;
    break;}
case 123:

{ yyval.mep = MexAux(MO_SUM, yyvsp[-2].mep, yyvsp[0].mep,
                                           (unsigned) 0); ;
    break;}
case 124:

{ yyval.mep = MexAux(MO_DIFF, yyvsp[-2].mep, yyvsp[0].mep,
                                           (unsigned) 0); ;
    break;}
case 125:

{ yyval.mep = MexAux(MO_SELECT, (MARKEXPR *) yyvsp[0].ep,
					   yyvsp[-2].mep, (unsigned) 0);
                        ;
    break;}
case 126:

{ yyval.mep = MexAux(MO_TIMES, (MARKEXPR *) yyvsp[-1].ep,
					   yyvsp[0].mep, (unsigned) 0);
                        ;
    break;}
case 127:

{ if (errorFlag == NO_ERROR)
                              {
				  (void) fprintf(_err, 
						 "Error in marking expression:\n");
				  (void) fflush(_err);
				  PrtCaret(rulesPlc,
					   (unsigned) strlen(yytext));
				  errorFlag = MEX_ERROR;
			      }
			  yyval.mep = NULL;
                          yyclearin;
			;
    break;}
case 128:

{ if (errorFlag == NO_ERROR)
			      {
				  str = strncpy((char *)
						Allocate(yyvsp[0].token.length + 1),
						ioBuf->_buf + yyvsp[0].token.start,
						(size_t) (yyvsp[0].token.length));
				  str[yyvsp[0].token.length] = '\0';
				  if ((ref = (REF *)
				       BalTrElement(plaTree, (char *) str)))
				      yyval.mep = MexAux(MO_PLACE,
						       (MARKEXPR *) NULL,
						       (MARKEXPR *) NULL,
						       (unsigned)
						       RefGSlot(ref));
				  else
				      {
					  (void) fprintf(_err,
							 "Place %s does not exist\n",
							 str);
					  (void) fflush(_err);
					  PrtCaret(yyvsp[0].token.start
						   + yyvsp[0].token.length,
						   yyvsp[0].token.length);
					  errorFlag = MEX_ERROR;
					  yyval.mep = NULL;
				      }
				  Deallocate((char *) str);
			      }
                          else
                              yyval.mep = NULL;
                        ;
    break;}
case 129:

{ yyval.mep = MexAux(MO_CONSTANT,
					   (MARKEXPR *) MarCreate(),
					   (MARKEXPR *) NULL, 0);
                        ;
    break;}
case 130:

{ yyval.mep = MexAux(MO_TRANGE, (MARKEXPR *) yyvsp[-1].trp,
					   (MARKEXPR *) NULL, 0);
                        ;
    break;}
case 131:

{ yyval.mep = MexAux(MO_TRANGE, (MARKEXPR *) TrgCreate(),
					   (MARKEXPR *) NULL, 0);
                        ;
    break;}
case 132:

{ yyval.mep = yyvsp[-1].mep; ;
    break;}
case 133:

{ if (errorFlag == NO_ERROR)
			      {
				  yyval.trp = TrgCreate();
				  TrgInsert(yyval.trp, yyvsp[0].xrp);
			      }
                          else
                              {
				  yyval.trp = NULL;
				  if (yyvsp[0].xrp != NULL)
				      XrgDiscard(yyvsp[0].xrp);
			      }
                        ;
    break;}
case 134:

{ if (errorFlag == NO_ERROR)
			      {
				  yyval.trp = yyvsp[-2].trp;
				  TrgInsert(yyval.trp, yyvsp[0].xrp);
			      }
                          else
                              {
				  yyval.trp = NULL;
				  if (yyvsp[-2].trp != NULL)
				      TrgDiscard(yyvsp[-2].trp);
				  if (yyvsp[0].xrp != NULL)
				      XrgDiscard(yyvsp[0].xrp);
			      }
                        ;
    break;}
case 135:

{ if (yyvsp[0].ep)
			      yyval.xrp = XrgAux(yyvsp[0].ep, XprCopy(yyvsp[0].ep));
			  else
			      yyval.xrp = NULL;
		        ;
    break;}
case 136:

{ yyval.xrp = XrgAux(yyvsp[-2].ep, yyvsp[0].ep); ;
    break;}
case 137:

{ yyval.xrp = yyvsp[-1].xrp; ;
    break;}
case 138:

{ if (errorFlag == NO_ERROR)
                              {
				  (void) fprintf(_err,
						 "Error in firing class:\n");
				  (void) fflush(_err);
				  PrtCaret(rulesPlc,
					   (unsigned) strlen(yytext));
				  errorFlag = FOR_ERROR;
			      }
			  yyval.fcp = NULL;
                          yyclearin;
			;
    break;}
case 139:

{ if (errorFlag == NO_ERROR)
			      {
				  str = strncpy((char *)
						Allocate(yyvsp[-1].token.length + 1),
						ioBuf->_buf + yyvsp[-1].token.start,
						(size_t) (yyvsp[-1].token.length));
				  str[yyvsp[-1].token.length] = '\0';
				  if ((ref = (REF *)
				       BalTrElement(traTree, (char *) str)))
				      transition = (unsigned) RefGSlot(ref);
				  else
				      {
					  (void) fprintf(_err,
							 "Transition %s does not exist\n",
							 str);
					  (void) fflush(_err);
					  PrtCaret(yyvsp[-1].token.start
						   + yyvsp[-1].token.length,
						   yyvsp[-1].token.length);
					  errorFlag = FOR_ERROR;
				      }
				  Deallocate((char *) str);
			      }
                        ;
    break;}
case 140:

{ if (yyvsp[-1].ep)
			      (void) XprReduce(yyvsp[-1].ep);
			  yyval.fcp = FclAux(FC_ATOM, (FCLASS *) yyvsp[-1].ep,
					   (FCLASS *) NULL, transition);
                        ;
    break;}
case 141:

{ yyval.fcp = yyvsp[-1].fcp; ;
    break;}
case 142:

{ yyval.fcp = FclAux(FC_NOT, yyvsp[0].fcp,
					   (FCLASS *) NULL, 0);
                        ;
    break;}
case 143:

{ yyval.fcp = FclAux(FC_OR, yyvsp[-2].fcp, yyvsp[0].fcp, 0); ;
    break;}
case 144:

{ yyval.fcp = FclAux(FC_AND, yyvsp[-2].fcp, yyvsp[0].fcp, 0); ;
    break;}
case 145:

{ if (errorFlag == NO_ERROR)
                              {
				  (void) fprintf(_err,
						 "Error in set operation:\n");
				  (void) fflush(_err);
				  PrtCaret(rulesPlc,
					   (unsigned) strlen(yytext));
				  errorFlag = SOP_ERROR;
			      }
			  yyval.sop = NULL;
                          yyclearin;
			;
    break;}
case 146:

{ yyval.sop = yyvsp[-1].sop; ;
    break;}
case 147:

{ if (yyvsp[0].ep)
			      (void) XprReduce(yyvsp[0].ep);
			  yyval.sop = SopAux(SE_SET, (SETOPER *) yyvsp[0].ep,
					   (SETOPER *) NULL);
                        ;
    break;}
case 148:

{ if (yyvsp[0].ep)
			      (void) XprReduce(yyvsp[0].ep);
			  yyval.sop = SopAux(SE_COMP, (SETOPER *) yyvsp[0].ep,
					   (SETOPER *) NULL);
                        ;
    break;}
case 149:

{ yyval.sop = SopAux(SE_UNION, yyvsp[-2].sop, yyvsp[0].sop); ;
    break;}
case 150:

{ yyval.sop = SopAux(SE_UNION, yyvsp[-2].sop, yyvsp[0].sop); ;
    break;}
case 151:

{ yyval.sop = SopAux(SE_CUT, yyvsp[-2].sop, yyvsp[0].sop); ;
    break;}
case 152:

{ yyval.sop = SopAux(SE_MINUS, yyvsp[-2].sop, yyvsp[0].sop); ;
    break;}
case 153:

{ if (errorFlag == NO_ERROR)
                              {
				  (void) fprintf(_err,
						 "Error in set expression:\n");
				  (void) fflush(_err);
				  PrtCaret(rulesPlc,
					   (unsigned) strlen(yytext));
				  errorFlag = XPR_ERROR;
			      }
			  yyval.ep = NULL;
                          yyclearin;
			;
    break;}
case 154:

{ yyval.ep = yyvsp[0].ep; ;
    break;}
case 155:

{ yyval.ep = yyvsp[-1].ep; ;
    break;}
case 156:

{ if (errorFlag == NO_ERROR)
                              {
				  (void) fprintf(_err,
						 "Error in set expression:\n");
				  (void) fflush(_err);
				  PrtCaret(rulesPlc,
					   (unsigned) strlen(yytext));
				  errorFlag = XPR_ERROR;
			      }
			  yyval.ep = NULL;
                          yyclearin;
			;
    break;}
case 157:

{ yyval.ep = yyvsp[0].ep; ;
    break;}
case 158:

{ yyval.ep = yyvsp[-1].ep; ;
    break;}
}
   /* the action file gets copied in in place of this dollarsign */


  yyvsp -= yylen;
  yyssp -= yylen;
#ifdef YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      (void) fprintf (stderr, "state stack now");
      while (ssp1 != yyssp)
	(void) fprintf (stderr, " %d", *++ssp1);
      (void) fprintf (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;

#ifdef YYLSP_NEEDED
  yylsp++;
  if (yylen == 0)
    {
      yylsp->first_line = yylloc.first_line;
      yylsp->first_column = yylloc.first_column;
      yylsp->last_line = (yylsp-1)->last_line;
      yylsp->last_column = (yylsp-1)->last_column;
      yylsp->text = 0;
    }
  else
    {
      yylsp->last_line = (yylsp+yylen-1)->last_line;
      yylsp->last_column = (yylsp+yylen-1)->last_column;
    }
#endif

  /* Now "shift" the result of the reduction.
     Determine what state that goes to,
     based on the state we popped back to
     and the rule number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;

yyerrlab:   /* here on detecting error */

  if (! yyerrstatus)
    /* If not already recovering from an error, report this error.  */
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  int size = 0;
	  char *msg;
	  int x, count;

	  count = 0;
	  /* Start X at -yyn if nec to avoid negative indexes in yycheck.  */
	  for (x = (yyn < 0 ? -yyn : 0);
	       x < (sizeof(yytname) / sizeof(char *)); x++)
	    if (yycheck[x + yyn] == x)
	      size += strlen(yytname[x]) + 15, count++;
	  msg = (char *) malloc(size + 15);
	  if (msg != 0)
	    {
	      strcpy(msg, "parse error");

	      if (count < 5)
		{
		  count = 0;
		  for (x = (yyn < 0 ? -yyn : 0);
		       x < (sizeof(yytname) / sizeof(char *)); x++)
		    if (yycheck[x + yyn] == x)
		      {
			strcat(msg, count == 0 ? ", expecting `" : " or `");
			strcat(msg, yytname[x]);
			strcat(msg, "'");
			count++;
		      }
		}
	      yyerror(msg);
	      free(msg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exceeded");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror("parse error");
    }

  goto yyerrlab1;
yyerrlab1:   /* here on error raised explicitly by an action */

  if (yyerrstatus == 3)
    {
      /* if just tried and failed to reuse lookahead token after an error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;

#if YYDEBUG != 0
      if (yydebug)
	(void) fprintf(stderr, "Discarding token %d (%s).\n", yychar, yytname[yychar1]);
#endif

      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token
     after shifting the error token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;

yyerrdefault:  /* current state does not do anything special for the error token. */

#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */
  yyn = yydefact[yystate];  /* If its default is to accept any token, ok.  Otherwise pop it.*/
  if (yyn) goto yydefault;
#endif

yyerrpop:   /* pop the current state because it cannot handle the error token */

  if (yyssp == yyss) YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#ifdef YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      (void) fprintf (stderr, "Error: state stack now");
      while (ssp1 != yyssp)
	(void) fprintf (stderr, " %d", *++ssp1);
      (void) fprintf (stderr, "\n");
    }
#endif

yyerrhandle:

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

#if YYDEBUG != 0
  if (yydebug)
    (void) fprintf(stderr, "Shifting error token, ");
#endif

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;
}



/***************************************************************************
*
* Function:  CmlParse
* Purpose:
* Arguments:
* Returns:
* See also:
*
****************************************************************************
*/
FE1(COMLINE *, CmlParse,
    REDIRECT *, redirectp)
{
    ret = NULL;
    redirectp->type = REDIRECT_NONE;
    redirectp->name = NULL;
    redirectp->args = NULL;
    rulesPlc = 0;
    inFiringClass = FALSE;
    (void) rules_yyparse();
    redirectp->type = redirect.type;
    redirectp->name = redirect.name;
    redirectp->args = redirect.args;
    return(ret);
}
