/***************************************************************************
*
* Copyright (c) 1989 -- 2000
* by Helsinki University of Technology, Digital Systems Laboratory,
* a.k.a. Laboratory for Theoretical Computer Science.
* All rights reserved.
*
* This software is provided "as is" without express or implied warranty.
*
* Module:  yypmacp.h
*
* Part of: PROD's program probe
*
* Authors: Tomi Janhunen, Kimmo Valkealahti, and Kimmo Varpaaniemi
*
* Current version:
*     $Id$
*
* Description:
*     This module is needed for making a tolerable yacc based parser.
*     This module renames things so that there can be more than
*     one yacc based parser. Also, renaming reduces the number of
*     complaints from lint.
*
* Version history:
*     $Log$
***************************************************************************/

#include <stdio.h>
#ifdef UNIX
#include <sys/types.h>
#else
#ifdef TNIL
#include <sys/types.h>
#else
#include <sys\types.h>
#endif
#endif
#include <string.h>
#include "absolute.h"
#include "prod.h"
#include "alloc.h"
#define yymaxdepth yy2maxdepth
#define yyv yy2v
#define yytoks yy2toks
#define yyreds yy2reds
#define yydebug yy2debug
#define yyerrflag yy2errflag
#define yydef yy2def
#define yynerrs yy2nerrs
#define yyr1 yy2r1
#define yyr2 yy2r2
#define yychar yy2char
#define yyexca yy2exca
#define yypact yy2pact
#define yychk yy2chk
#define yypgo yy2pgo
#define yyact yy2act
#define yysptr yy2sptr
#define yyback yy2back
#define yylook yy2look
#define yyvstop yy2vstop
#define yyunput yy2unput
#define yylex yy2lex
#define yyoutput yy2output
#define yyout yy2out
#define yyinput yy2input
#define yyin yy2in
#define yycrank yy2crank
#define yybgin yy2bgin
#define yyprevious yy2previous
#define yyextra yy2extra
#define yysvec yy2svec
#define yymatch yy2match
#define yytop yy2top
#define yylineno yy2lineno
#define yyposix_point yy2posix_point
#define yynls16 yy2nls16
#define yynls_wchar yy2nls_wchar
#define yylocale yy2locale
#define yylval yy2lval
#define yyval yy2val
#define yy_yys yy2_yys
#define yys yy2s
#define yy_yyv yy2_yyv
#define yypv yy2pv
#define yyps yy2ps
#define yystate yy2state
#define yytmp yy2tmp
#define yyleng yy2leng
#define yytext yy2text
#define yymorfg yy2morfg
#define yysbuf yy2sbuf
#define yytchar yy2tchar
#define yyestate yy2estate
#define yylstate yy2lstate
#define yylsp yy2lsp
#define yyolsp yy2olsp
#define yyfnd yy2fnd
#define yylhs yy2lhs
#define yylen yy2len
#define yydefred yy2defred
#define yydgoto yy2dgoto
#define yysindex yy2sindex
#define yyrindex yy2rindex
#define yygindex yy2gindex
#define yytable yy2table
#define yycheck yy2check
#define yyname yy2name
#define yyrule yy2rule
#define yy_init_buffer yy2_init_buffer
#define yy_create_buffer yy2_create_buffer
#define yy_load_buffer_state yy2_load_buffer_state
#define yyrestart yy2restart
#define yy_switch_to_buffer yy2_switch_to_buffer
#define yy_delete_buffer yy2_delete_buffer
#define yy_push_state yy2_push_state
#define yy_pop_state yy2_pop_state
#define yy_top_state yy2_top_state
#define yysccsid yy2sccsid
#define yyerrlab yy2errlab
#define yynewerror yy2newerror
#define yy_flush_buffer yy2_flush_buffer
#define yy_scan_buffer yy2_scan_buffer
#define yy_scan_bytes yy2_scan_bytes
#define yy_scan_string yy2_scan_string
#define yy_fatal_error yy2_fatal_error
