
####################################################################
# repondre au "kit_name"
####################################################################

if [ "$1" = "-kit_name" ] ; then
        echo EPA-INV
        exit
fi

#############################################################################
# Pilote de greatSPN
#############################################################################

# Le directory de resultat

RES_DIR="PA_INV"
mkdir $RES_DIR
model_file="FK_MNGR/.model"

if [ ! -e $FK_TOOLS_ROOT'EPA_INV/Flots' ] ; then
	fk_send_msg -error -force_result "Internal problem, executable file not found, please contact maintenance"
	fk_set_end_status Error
else
	if [ -f $RES_DIR/result ] ; then
		fk_send_state_message 'Flows already computed, sending computed results'
		fk_set_end_status OK
	else
		fk_send_state_message 'Computing flows'
		$FK_TOOLS_ROOT'EPA_INV/Flots' $model_file > $RES_DIR/result
		fk_send_state_message 'Sending results'
	fi
	fk_send_file_content $RES_DIR/result
	fk_set_end_status OK
fi
