#!/usr/bin/env python2.6

'''
Created on 16 sept. 2009

@author: hong
'''



import sys 
import json


def depact_order(elt,level,current):
    mapping = {}
    if not level.has_key(current):
        level[current] = []
    tab = level[current]
    tab.append(mapping)
    index = 0
    for ee in elt:
        mapping[index]=ee
        index += 1
    for ee in elt:
        if type(ee).__name__=='list' or type(elt).__name__=='Hierarchy':
            depact_order(ee,level,current+1)

if __name__ == '__main__':
    file = sys.argv[1]
    max  = int(sys.argv[2])
    order = sys.argv[3]
    counter = {}
    file = open(file,'rU')
    actual = None
    cpt = 0
    
    # Load the ordering model JSON File
    forder = open(order,'rU')
    order = json.load(forder)
    forder.close()
    level = {}
    depact_order(order,level,0)
    for k,v in level.items():
        print 'Hierarchy Level [' , k ,']'
        for elt in v :
            print ' - ' , elt
    
    

            
            
    
    for line in file.readlines():
        if line.find('cluster_depth') != -1 and actual == None:
            if not counter.has_key(line):
                counter[line] = {}
                actual = line
                for i in range(0,max):
                    counter[actual][str(i)]=0
                    #counter[actual]["0"]=0
                #print 'Find line ', line
        if line.find('{') != -1 and actual != None:
            #print 'Begin { : ' , cpt 
            cpt += 1
        if line.find('}') != -1:
            if cpt > 0:
                cpt -= 1
        if cpt == 0 and actual != None:
            #print 'ENDING DEPTH ', line
            actual = None
        if actual != None:
            #print line
            for i in range(0,max):
                if line.find('"' + str(i) + '"') != -1 and line.find("node_") != -1:
                    counter[actual][str(i)]+= 1
    file.close()
    
    total = 0
    print 'Information States'
    print ' - Number of Level : ',len(counter)
    for k,v in counter.items():
        print ' --- Level : ',k
        for i in range(0,max): 
            if v[str(i)] > 0:
                total += v[str(i)]
                print ' --- [',i,']   : ',v[str(i)]
    
    print 'Total Nodes : ' , total


    
