#! /usr/bin/env python
#this is a heuristic algorithms
import sys
import re
import math
import commands
from pycami.parser import *

def sort_columns(x, y):
	return x[2]-y[2]


def score(temp_order):
	score=0;
	for i in range(len(temp_order[0][1])): #this is the number of rows
		currentpos=0
		startpos=-1
		endpos=-1
		for j in range(len(temp_order)):
			if temp_order[j][1][i]>0 :
				if startpos==-1:
					startpos=currentpos
				endpos=currentpos
			currentpos=currentpos+1
		score=score+endpos-startpos+1
	return score


#################
#Read input file#
#################
def greedy_first(matrix_file):


	f=open(matrix_file, 'r')
	
	no_columns=int(f.readline())
	no_rows=int(f.readline())
	zero_one_matrix=[[0 for j in range(no_columns)] for i in range(no_rows)]
	print 'Columns ' ,  len(zero_one_matrix)
	print 'Lines   ' ,  len(zero_one_matrix[0])
	
	matchLevel = re.compile('(\d+) :')
	matchEvents = re.compile(' (\d+)')
	
	#Read line by line
	while 1 :
		line=f.readline()
		if not line: #End of file
			break
		level = matchLevel.match(line) # Find the number of the level
		events=matchEvents.findall(line)
		for event in events:
			zero_one_matrix[ int(event) ][int(level.group(1))-1]=1 
	f.close()
	###############################
	#End of the input file reading#
	###############################
	
	#convert a column major representation 
	#print zero_one_matrix
	
	
	zero_one_matrix_columns=[[i,[zero_one_matrix[j][i] for j in range(no_rows)]] for i in range(no_columns)]
	
	for row in zero_one_matrix_columns:
		no_ones=0
		for cell in row[1]:
			if cell>0:
				no_ones=no_ones+1
		row.append(no_ones)
	
	#calculate the current cost, if one column only has one 1, then the cost for the column is 1 instead of 0
	score_first= score(zero_one_matrix_columns)
	#print score_first
	
	#sort the columns in ascending order according to the number of ones that each column has
	zero_one_matrix_columns.sort(sort_columns)
	#print zero_one_matrix_columns
	#print out the current score
	score_middle= score(zero_one_matrix_columns)
	#print 'after sorting before the heuristic algorithm'
	#print score_middle
	
	#now, place the columns into a new list one by one
	
	start_end_pos=[[-1 for i in range(no_rows)],[-2 for j in range(no_rows)]]
	final_order=[]
	for row in zero_one_matrix_columns:
		minimum_score=1000000000
		insert_pos=0
		choises=len(final_order)+1
	#	print 'choises'
	#	print range(choises)
		for choice in range(choises):
			temp_start_end_pos=[[start_end_pos[0][i] for i in range(no_rows)],[start_end_pos[1][j] for j in range(no_rows)]]
			currentcost=0
			for cell in range(len(row[1])):
				if choice<=temp_start_end_pos[1][cell] :
					temp_start_end_pos[1][cell]=temp_start_end_pos[1][cell]+1
				if choice<=temp_start_end_pos[0][cell] :
					temp_start_end_pos[0][cell]=temp_start_end_pos[0][cell]+1
				if row[1][cell]>0:
					if choice>temp_start_end_pos[1][cell]:
						temp_start_end_pos[1][cell]=choice
					if choice<temp_start_end_pos[0][cell]:
						temp_start_end_pos[0][cell]=choice
					if temp_start_end_pos[0][cell]==-1:
						temp_start_end_pos[0][cell]=choice
				currentcost=currentcost+temp_start_end_pos[1][cell]-temp_start_end_pos[0][cell]+1
			#print 'choice'
			#print choice
			#print 'currentcost'
			#print currentcost
			if  currentcost < minimum_score:
				insert_pos=choice
				minimum_score= currentcost
		final_order.insert(insert_pos,row) 
		for cell in range(len(row[1])):
			if insert_pos<=start_end_pos[1][cell]:
				start_end_pos[1][cell]=start_end_pos[1][cell]+1
			if insert_pos<=start_end_pos[0][cell]:
				start_end_pos[0][cell]=start_end_pos[0][cell]+1
			if row[1][cell]>0:
				if insert_pos>start_end_pos[1][cell]:
					start_end_pos[1][cell]=insert_pos
				if insert_pos<start_end_pos[0][cell]:
					start_end_pos[0][cell]=insert_pos
				if start_end_pos[0][cell]==-1:
					start_end_pos[0][cell]=insert_pos
	#	print start_end_pos[0]
	#	print start_end_pos[1]
	#	print 'finished one row'
	
	#print start_end_pos[0]
	#print start_end_pos[1]
	
	score_final= score(final_order)
	print 'Score:' , (score_final) , ' ELEMENTS : ' , len(final_order)
	final = []
	for i in final_order:
		final.append(i[0])

	return final
	####################
	#Writes output file#
	####################
#	f=open(sys.argv[2],'w')
#	f.write("%i\n"%len(final_order))
#	for i in final_order:
#		f.write("%i\n"%(int(i[0])+1))
#	
#	
#	f.close()

############################
#End of output file writing#
############################



	








	

