#! /usr/bin/env python
import sys
import re
import math
import commands
import random
import time



#####################
#define the sort function
######################
def sort_columns(x, y):
	return x[1]-y[1]


#################
#Read input file#
#################

starttime="startat:"+str(time.ctime())
print starttime

starttime2="startat1:"+str(time.time())
print starttime2

starttime1=time.time()


logfile = open(sys.argv[3],'w')
logfile.write(starttime)
logfile.write('\n')
logfile.write(starttime2)
logfile.write('\n')

f=open(sys.argv[1], 'r')

N=int(f.readline())
M=int(f.readline())
Sis=[[] for i in range(M)]
maximas=[[0,0] for i in range(M)] #will contain the maximas and minimas of each column according to an ordering
Current_Sis=[[] for i in range(M)]

matchLevel = re.compile('(\d+) :')
matchEvents = re.compile(' (\d+)')

#Read line by line
nofones_per_level=[[i,0] for i in range(N)]

while 1 :
	line=f.readline()
	if not line: #End of file
		break
	level = matchLevel.match(line) # Find the number of the level
	events=matchEvents.findall(line)
	nofones_per_level[int(level.group(1))-1][1] = len(events)
	for event in events:
		Sis[int(event)-1].append(int(level.group(1))-1) 
f.close()

#print nofones_per_level
nofones_per_level.sort(sort_columns)
print nofones_per_level
###############################
#End of the input file reading#
###############################

#Compute the cost
def score(temp_orderi):
	temp_order=[-1 for i in range(N)]
	for i in range(len(temp_orderi)):
		temp_order[temp_orderi[i]]=i
	NewSis=[[] for i in range(M)]
	cost=0
	for i in range(0,len(Sis)):
		for j in Sis[i]:
			if(temp_order[j]!=-1):
				NewSis[i].append(temp_order[j])
	for i in NewSis:
			if len(i)>0:
				cost+=max(max(i)-min(i)+1,0)
	return cost

def precompute(temp_orderi):
	global Current_Sis
	Current_Sis=[[] for i in range(M)]
	temp_order=[-1 for i in range(N)]
	for i in range(len(temp_orderi)):
		temp_order[temp_orderi[i]]=i
	for i in range(0,len(Sis)):
		for j in Sis[i]:
			if(temp_order[j]!=-1):
				Current_Sis[i].append(temp_order[j])
	for i in xrange(len(Current_Sis)):
			if len(Current_Sis[i])>=1:
				temp_extremas=Current_Sis[i][:]
				max1=max(temp_extremas)
				temp_extremas.remove(max1)
				max2=0
				if len(temp_extremas)>=1:
					max2=max(temp_extremas)
				maximas[i] = (0,0,max2,max1)

def score_ones_at_end(temp_orderi):
	temp_order=[-1 for i in range(N)]
	for i in range(len(temp_orderi)):
		temp_order[temp_orderi[i]]=i
	NewSis=[[] for i in range(M)]
	cost=0
	for i in range(0,len(Sis)):
		for j in Sis[i]:
			if(temp_order[j]!=-1):
				NewSis[i].append(temp_order[j])
	for i in NewSis:
			if len(i)>0:
				cost+=max(max(i),0)
	return cost


def incremental_score(operation, i,j, column):
	if len(Current_Sis[column])<1:
		return 0
	if operation=="insertion":
		min1,min2,max2,max1=maximas[column]
		if(i==j):#possibly wrong !!!
			if i==max1:
				return 1
			return 0
		if (i<max1 and  j >= max1 and not i in Current_Sis[column]): # It is the case where the moved raw is removed from between the two 1s ans were empty
			return -1
		if ( i<max1 and j >= max1 and i in Current_Sis[column]):# It is the case where the moved raw is removed from between the two 1s and were not empty
			return j-max1
		if (i == max1):# It is the case where the moved raw is the lower bound
			if j>max2 :
				return j-max1
			if j<=max2:
				return max2-max1
		return 0
	
	if operation=="swap":
		min1,min2,max2,max1=maximas[column]
		if ( (not i in Current_Sis[column]) and (not j in Current_Sis[column])): # i and j are empty.
			return 0
		if ( (i in Current_Sis[column]) and (j in Current_Sis[column]) ): # i and j are full.
			return 0
		
		if (i==max1):
	
			if j>=max2:
				return j-max1
			if j<=min1:
				return max2-j-(max1-min1)
			return max2-max1
		if (j==max1):
	
			if i>=max2:
				return i-max1
			if i<=min1:
				return max2-i-(max1-min1)
			return max2-max1
		
		
		if (i==min1):
			if j>=max1:
				return j-min2-(max1-min1)
			if j>=min2:
				return min1-min2
			return min1-j
		if (j==min1):
			if i>=max1:
				return i-min2-(max1-min1)
			if i>=min2:
				return min1-min2
			return min1-i
		if (i in Current_Sis[column] and j<=min1):# i is in and will be swapped out, on bottom
			return min1-j
		if (i in Current_Sis[column] and j>=max1):# i is in and will be swapped out, on top
			return j-max1
		if (j in Current_Sis[column] and i<=min1):# i is in and will be swapped out, on bottom
			return min1-i
		if (j in Current_Sis[column] and i>=max1):# i is in and will be swapped out, on top
			return i-max1
		#print i,j,Current_Sis[column],maximas[column]
		#if ((i < min1 and j>=max1) or (i < min1 and j<min1) or (i > max1 and j>=max1) or (i>max1 and j < min1) or (i>min1 and j>min1 and j<max1 and i<max1) ): # It is the case where the moved raw is inserted between the two 1s
		#	return 0
		#print "Has not to happen2",i,j,Current_Sis[column],maximas[column]
		return 0








def swap(i,j,ordering):
	temp=ordering[i]
	ordering[i]=order[j]
	ordering[j]=temp



if (len(sys.argv) >=5):
	print sys.argv[4]
	deforder = readinorder(sys.argv[4])
	print deforder
else:
	deforder = [nofones_per_level[i][0] for i in range(N)]
	print deforder

rating= score_ones_at_end(deforder)
order=deforder
change = 1

timethreshold = 220

timenow = time.time()
timedifference = timenow - starttime1


while(change) and (timedifference < timethreshold):
	change=0
	precompute(order)
	couple=(0,0)
	max_new_score=0
	
	for i in range(0,N):
		for j in range(i,N):
			newscore = 0
			for column in range(0,M):
				newscore+=incremental_score("swap",i,j,column)
			if newscore<max_new_score:
				max_new_score=newscore
				couple=(i,j)
#stop if the time spent on this local improvement exceeds timethreshold seconds
		timenow = time.time()
		timedifference = timenow - starttime1
		if (timedifference > timethreshold):
			break

	if max_new_score<0:
		swap(couple[0],couple[1],order)
		change=1
		precompute(order)
	max_new_score=0
	temporder=order[:]
	
	for i in range(0,N):
		for j in range(i,N):
			newscore = 0
			for column in range(0,M):
				newscore+=incremental_score("insertion",i,j,column)
			if newscore<max_new_score:
				max_new_score=newscore
				couple=(i,j)
#stop if the time taken to run localimprovement exceeds timethreshold seconds
		timenow = time.time()
		timedifference = timenow - starttime1
		if (timedifference > timethreshold):
			break

	if max_new_score<0:
		tomove=temporder[couple[0]]
		temporder.__delitem__(couple[0])
		temporder.insert(couple[1],tomove)
		change=1
		order=temporder[:]
	max_new_score=0
	
	timenow = time.time()
	timedifference = timenow - starttime1
	print (time.ctime())
	


print "Score:"
print(score_ones_at_end(order))
####################
#Writes output file#
####################
f=open(sys.argv[2],'w')
f.write("%i\n"%len(order))
for i in order:
	f.write("%i\n"%(int(i)+1))


f.close()

stopat="stopat:"+str(time.ctime())
print stopat
stopat1="stopat1:"+str(time.time())
print stopat1

logfile.write(stopat)
logfile.write('\n')
logfile.write(stopat1)
logfile.write('\n')
logfile.close()


############################
#End of output file writing#
############################






	

