#! /usr/bin/env python
import sys
import re
import math
import commands

#################
#Read input file#
#################
f=open(sys.argv[1], 'r')

N=int(f.readline())
M=int(f.readline())
Sis=[[] for i in range(N)]

matchLevel = re.compile('(\d+) :')
matchEvents = re.compile(' (\d+)')

#Read line by line
while 1 :
	line=f.readline()
	if not line: #End of file
		break
	level = matchLevel.match(line) # Find the number of the level
	events=matchEvents.findall(line)
	for event in events:
		Sis[int(level.group(1))-1].append(int(event)) 
f.close()
for row in Sis:
	print row
###############################
#End of the input file reading#
###############################


######################################################
#write back a new file with an extra line of all ones#
######################################################

filename=sys.argv[1]+".sumtopi"
f=open(filename,'w')

f.write("%d\n"%(N+1))
f.write("%d\n"%M)
i=1
while i<=N:
	f.write("%d"%i)
	f.write(" :")
	for column in Sis[i-1]:
		f.write(" %d"%column)
	f.write("\n")
	i=i+1


f.write("%d"%(N+1))
f.write(" :")
i=0
while i<M:

	f.write(" %d"%i)
	i=i+1
f.write("\n")
f.close()


commands.getoutput("./LognApprox.py "+filename+" "+sys.argv[2]+".sumtopi")

order=[]
filename=sys.argv[2]+".sumtopi"
f=open(filename,'r')
while 1:
	line=f.readline()
	if not line:
		break
	order.append(int(line))
f.close()
additional_row=order.pop(0)
print 'the additional row'
print additional_row
print 'the order file'
print order

new_order=[]
row_index=order.index(additional_row)
print 'the row index'
print row_index

counter=0
distance=0
while counter<additional_row-1:
	distance=distance+1
	if row_index+distance<=additional_row-1:
		new_order.append(order[row_index+distance])
		counter=counter+1
	if row_index-distance>=0:
		new_order.append(order[row_index-distance])
		counter=counter+1
print new_order


f=open(sys.argv[2],'w')
f.write("%i\n"%len(new_order))
for i in new_order:
	f.write("%i\n"%(int(i)))


f.close()


	
	

