/***************************************************************************
*
* Copyright (c) 1989 -- 2000
* by Helsinki University of Technology, Digital Systems Laboratory,
* a.k.a. Laboratory for Theoretical Computer Science.
* All rights reserved.
*
* This software is provided "as is" without express or implied warranty.
*
* Module:  yypmace.h
*
* Part of: PROD's program probe
*
* Authors: Tomi Janhunen, Kimmo Valkealahti, and Kimmo Varpaaniemi
*
* Current version:
*     $Id$
*
* Description:
*     This module is needed for making a tolerable yacc based parser.
*     This module renames things so that there can be more than
*     one yacc based parser. Also, renaming reduces the number of
*     complaints from lint.
*
* Version history:
*     $Log$
***************************************************************************/

#include <stdio.h>
#ifdef UNIX
#include <sys/types.h>
#else
#ifdef TNIL
#include <sys/types.h>
#else
#include <sys\types.h>
#endif
#endif
#include <string.h>
#include "absolute.h"
#include "prod.h"
#include "alloc.h"
#define yymaxdepth yy3maxdepth
#define yyv yy3v
#define yytoks yy3toks
#define yyreds yy3reds
#define yydebug yy3debug
#define yyerrflag yy3errflag
#define yydef yy3def
#define yynerrs yy3nerrs
#define yyr1 yy3r1
#define yyr2 yy3r2
#define yychar yy3char
#define yyexca yy3exca
#define yypact yy3pact
#define yychk yy3chk
#define yypgo yy3pgo
#define yyact yy3act
#define yysptr yy3sptr
#define yyback yy3back
#define yylook yy3look
#define yyvstop yy3vstop
#define yyunput yy3unput
#define yylex yy3lex
#define yyoutput yy3output
#define yyout yy3out
#define yyinput yy3input
#define yyin yy3in
#define yycrank yy3crank
#define yybgin yy3bgin
#define yyprevious yy3previous
#define yyextra yy3extra
#define yysvec yy3svec
#define yymatch yy3match
#define yytop yy3top
#define yylineno yy3lineno
#define yyposix_point yy3posix_point
#define yynls16 yy3nls16
#define yynls_wchar yy3nls_wchar
#define yylocale yy3locale
#define yylval yy3lval
#define yyval yy3val
#define yy_yys yy3_yys
#define yys yy3s
#define yy_yyv yy3_yyv
#define yypv yy3pv
#define yyps yy3ps
#define yystate yy3state
#define yytmp yy3tmp
#define yyleng yy3leng
#define yytext yy3text
#define yymorfg yy3morfg
#define yysbuf yy3sbuf
#define yytchar yy3tchar
#define yyestate yy3estate
#define yylstate yy3lstate
#define yylsp yy3lsp
#define yyolsp yy3olsp
#define yyfnd yy3fnd
#define yylhs yy3lhs
#define yylen yy3len
#define yydefred yy3defred
#define yydgoto yy3dgoto
#define yysindex yy3sindex
#define yyrindex yy3rindex
#define yygindex yy3gindex
#define yytable yy3table
#define yycheck yy3check
#define yyname yy3name
#define yyrule yy3rule
#define yy_init_buffer yy3_init_buffer
#define yy_create_buffer yy3_create_buffer
#define yy_load_buffer_state yy3_load_buffer_state
#define yyrestart yy3restart
#define yy_switch_to_buffer yy3_switch_to_buffer
#define yy_delete_buffer yy3_delete_buffer
#define yy_push_state yy3_push_state
#define yy_pop_state yy3_pop_state
#define yy_top_state yy3_top_state
#define yysccsid yy3sccsid
#define yyerrlab yy3errlab
#define yynewerror yy3newerror
#define yy_flush_buffer yy3_flush_buffer
#define yy_scan_buffer yy3_scan_buffer
#define yy_scan_bytes yy3_scan_bytes
#define yy_scan_string yy3_scan_string
#define yy_fatal_error yy3_fatal_error
