/***************************************************************************
*
* Copyright (c) 1989 -- 2000
* by Helsinki University of Technology, Digital Systems Laboratory,
* a.k.a. Laboratory for Theoretical Computer Science.
* All rights reserved.
*
* This software is provided "as is" without express or implied warranty.
*
* Module:  yyprules.h
*
* Part of: PROD's program probe
*
* Authors: Tomi Janhunen, Kimmo Valkealahti, and Kimmo Varpaaniemi
*
* Current version:
*     $Id$
*
* Description:
*     This module is needed for making a tolerable yacc based parser.
*
* Version history:
*     $Log$
***************************************************************************/

#include <stdio.h>
#ifdef UNIX
#include <sys/types.h>
#else
#ifdef TNIL
#include <sys/types.h>
#else
#include <sys\types.h>
#endif
#endif
#include <string.h>
#include "absolute.h"
#include "prod.h"
#include "alloc.h"
#define yymaxdepth yy4maxdepth
#define yyv yy4v
#define yytoks yy4toks
#define yyreds yy4reds
#define yydebug yy4debug
#define yyerrflag yy4errflag
#define yydef yy4def
#define yynerrs yy4nerrs
#define yyr1 yy4r1
#define yyr2 yy4r2
#define yychar yy4char
#define yyexca yy4exca
#define yypact yy4pact
#define yychk yy4chk
#define yypgo yy4pgo
#define yyact yy4act
#define yysptr yy4sptr
#define yyback yy4back
#define yylook yy4look
#define yyvstop yy4vstop
#define yyunput yy4unput
#define yylex yy4lex
#define yyoutput yy4output
#define yyout yy4out
#define yyinput yy4input
#define yyin yy4in
#define yycrank yy4crank
#define yybgin yy4bgin
#define yyprevious yy4previous
#define yyextra yy4extra
#define yysvec yy4svec
#define yymatch yy4match
#define yytop yy4top
#define yylineno yy4lineno
#define yyposix_point yy4posix_point
#define yynls16 yy4nls16
#define yynls_wchar yy4nls_wchar
#define yylocale yy4locale
#define yylval yy4lval
#define yyval yy4val
#define yy_yys yy4_yys
#define yys yy4s
#define yy_yyv yy4_yyv
#define yypv yy4pv
#define yyps yy4ps
#define yystate yy4state
#define yytmp yy4tmp
#define yyleng yy4leng
#define yytext yy4text
#define yymorfg yy4morfg
#define yysbuf yy4sbuf
#define yytchar yy4tchar
#define yyestate yy4estate
#define yylstate yy4lstate
#define yylsp yy4lsp
#define yyolsp yy4olsp
#define yyfnd yy4fnd
#define yylhs yy4lhs
#define yylen yy4len
#define yydefred yy4defred
#define yydgoto yy4dgoto
#define yysindex yy4sindex
#define yyrindex yy4rindex
#define yygindex yy4gindex
#define yytable yy4table
#define yycheck yy4check
#define yyname yy4name
#define yyrule yy4rule
#define yy_init_buffer yy4_init_buffer
#define yy_create_buffer yy4_create_buffer
#define yy_load_buffer_state yy4_load_buffer_state
#define yyrestart yy4restart
#define yy_switch_to_buffer yy4_switch_to_buffer
#define yy_delete_buffer yy4_delete_buffer
#define yy_push_state yy4_push_state
#define yy_pop_state yy4_pop_state
#define yy_top_state yy4_top_state
#define yysccsid yy4sccsid
#define yyerrlab yy4errlab
#define yynewerror yy4newerror
#define yy_flush_buffer yy4_flush_buffer
#define yy_scan_buffer yy4_scan_buffer
#define yy_scan_bytes yy4_scan_bytes
#define yy_scan_string yy4_scan_string
#define yy_fatal_error yy4_fatal_error
