/**
 *
 */
package fr.lip6.move.pnml.framework.general;

/**
 * This interface gives needed elements for a File type descriptor.
 *
 * @author ggiffo
 *
 */
public interface PNMLFileType {

    /**
     * @return the library type name
     */
    String getTypeName();

    /**
     * @return the className
     */
    String getClassName();

    /**
     * @return the namespace
     */
    String getNamespace();

    /**
     * @return the rng file Url
     */
    String getRngUrl();

    /**
     *
     * @return the classname of the fall back class, null if no FB class
     */
    String getFallBackClassName();
}
